import{S as ks,i as Es,s as Ps,e as r,k as m,w as v,t as s,M as zs,c as a,d as o,m as p,a as n,x as b,h as i,b as c,G as e,g as u,y as w,q as $,o as M,B as y,v as Fs,L as vn}from"../../chunks/vendor-hf-doc-builder.js";import{T as tr}from"../../chunks/Tip-hf-doc-builder.js";import{D as S}from"../../chunks/Docstring-hf-doc-builder.js";import{C as bn}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Fe}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as Cn}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function js(z){let d,C,f,g,T;return g=new bn({props:{code:`from transformers import MCTCTConfig, MCTCTModel

# Initializing a M-CTC-T mctct-large style configuration
configuration = MCTCTConfig()

# Initializing a model (with random weights) from the mctct-large style configuration
model = MCTCTModel(configuration)

# Accessing the model configuration
configuration = model.config`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> MCTCTConfig, MCTCTModel

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a M-CTC-T mctct-large style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = MCTCTConfig()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Initializing a model (with random weights) from the mctct-large style configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MCTCTModel(configuration)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Accessing the model configuration</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>configuration = model.config`}}),{c(){d=r("p"),C=s("Example:"),f=m(),v(g.$$.fragment)},l(l){d=a(l,"P",{});var _=n(d);C=i(_,"Example:"),_.forEach(o),f=p(l),b(g.$$.fragment,l)},m(l,_){u(l,d,_),e(d,C),u(l,f,_),w(g,l,_),T=!0},p:vn,i(l){T||($(g.$$.fragment,l),T=!0)},o(l){M(g.$$.fragment,l),T=!1},d(l){l&&o(d),l&&o(f),y(g,l)}}}function qs(z){let d,C,f,g,T,l,_,k,A,E,F;return{c(){d=r("p"),C=s(`This class method is simply calling the feature extractor
`),f=r("a"),g=s("from_pretrained()"),T=s(`, image processor
`),l=r("a"),_=s("ImageProcessingMixin"),k=s(` and the tokenizer
`),A=r("code"),E=s("~tokenization_utils_base.PreTrainedTokenizer.from_pretrained"),F=s(` methods. Please refer to the docstrings of the
methods above for more information.`),this.h()},l(P){d=a(P,"P",{});var j=n(d);C=i(j,`This class method is simply calling the feature extractor
`),f=a(j,"A",{href:!0});var H=n(f);g=i(H,"from_pretrained()"),H.forEach(o),T=i(j,`, image processor
`),l=a(j,"A",{href:!0});var pt=n(l);_=i(pt,"ImageProcessingMixin"),pt.forEach(o),k=i(j,` and the tokenizer
`),A=a(j,"CODE",{});var ie=n(A);E=i(ie,"~tokenization_utils_base.PreTrainedTokenizer.from_pretrained"),ie.forEach(o),F=i(j,` methods. Please refer to the docstrings of the
methods above for more information.`),j.forEach(o),this.h()},h(){c(f,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.from_pretrained"),c(l,"href","/docs/transformers/pr_22182/en/main_classes/image_processor#transformers.ImageProcessingMixin")},m(P,j){u(P,d,j),e(d,C),e(d,f),e(f,g),e(d,T),e(d,l),e(l,_),e(d,k),e(d,A),e(A,E),e(d,F)},d(P){P&&o(d)}}}function As(z){let d,C,f,g,T,l,_,k;return{c(){d=r("p"),C=s("This class method is simply calling "),f=r("a"),g=s("save_pretrained()"),T=s(` and
`),l=r("a"),_=s("save_pretrained()"),k=s(`. Please refer to the docstrings of the
methods above for more information.`),this.h()},l(A){d=a(A,"P",{});var E=n(d);C=i(E,"This class method is simply calling "),f=a(E,"A",{href:!0});var F=n(f);g=i(F,"save_pretrained()"),F.forEach(o),T=i(E,` and
`),l=a(E,"A",{href:!0});var P=n(l);_=i(P,"save_pretrained()"),P.forEach(o),k=i(E,`. Please refer to the docstrings of the
methods above for more information.`),E.forEach(o),this.h()},h(){c(f,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained"),c(l,"href","/docs/transformers/pr_22182/en/internal/tokenization_utils#transformers.PreTrainedTokenizerBase.save_pretrained")},m(A,E){u(A,d,E),e(d,C),e(d,f),e(f,g),e(d,T),e(d,l),e(l,_),e(d,k)},d(A){A&&o(d)}}}function Ds(z){let d,C,f,g,T;return{c(){d=r("p"),C=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=r("code"),g=s("Module"),T=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var _=n(d);C=i(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=a(_,"CODE",{});var k=n(f);g=i(k,"Module"),k.forEach(o),T=i(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(o)},m(l,_){u(l,d,_),e(d,C),e(d,f),e(f,g),e(d,T)},d(l){l&&o(d)}}}function Is(z){let d,C,f,g,T;return g=new bn({props:{code:`from transformers import AutoProcessor, MCTCTModel
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

processor = AutoProcessor.from_pretrained("speechbrain/m-ctc-t-large")
model = MCTCTModel.from_pretrained("speechbrain/m-ctc-t-large")

# audio file is decoded on the fly
inputs = processor(dataset[0]["audio"]["array"], sampling_rate=sampling_rate, return_tensors="pt")
with torch.no_grad():
    logits = model(**inputs).logits
predicted_ids = torch.argmax(logits, dim=-1)

# transcribe speech
transcription = processor.batch_decode(predicted_ids)
transcription[0]

inputs["labels"] = processor(text=dataset[0]["text"], return_tensors="pt").input_ids

# compute loss
loss = model(**inputs).loss`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, MCTCTModel
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;speechbrain/m-ctc-t-large&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MCTCTModel.from_pretrained(<span class="hljs-string">&quot;speechbrain/m-ctc-t-large&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_ids = torch.argmax(logits, dim=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># transcribe speech</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription = processor.batch_decode(predicted_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription[<span class="hljs-number">0</span>]
[<span class="hljs-number">1</span>, <span class="hljs-number">195</span>, <span class="hljs-number">1536</span>]

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs[<span class="hljs-string">&quot;labels&quot;</span>] = processor(text=dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;text&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute loss</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs).loss`}}),{c(){d=r("p"),C=s("Example:"),f=m(),v(g.$$.fragment)},l(l){d=a(l,"P",{});var _=n(d);C=i(_,"Example:"),_.forEach(o),f=p(l),b(g.$$.fragment,l)},m(l,_){u(l,d,_),e(d,C),u(l,f,_),w(g,l,_),T=!0},p:vn,i(l){T||($(g.$$.fragment,l),T=!0)},o(l){M(g.$$.fragment,l),T=!1},d(l){l&&o(d),l&&o(f),y(g,l)}}}function Ls(z){let d,C,f,g,T;return{c(){d=r("p"),C=s("Although the recipe for forward pass needs to be defined within this function, one should call the "),f=r("code"),g=s("Module"),T=s(`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`)},l(l){d=a(l,"P",{});var _=n(d);C=i(_,"Although the recipe for forward pass needs to be defined within this function, one should call the "),f=a(_,"CODE",{});var k=n(f);g=i(k,"Module"),k.forEach(o),T=i(_,`
instance afterwards instead of this since the former takes care of running the pre and post processing steps while
the latter silently ignores them.`),_.forEach(o)},m(l,_){u(l,d,_),e(d,C),e(d,f),e(f,g),e(d,T)},d(l){l&&o(d)}}}function Ss(z){let d,C,f,g,T;return g=new bn({props:{code:`from transformers import AutoProcessor, MCTCTForCTC
from datasets import load_dataset
import torch

dataset = load_dataset("hf-internal-testing/librispeech_asr_demo", "clean", split="validation")
dataset = dataset.sort("id")
sampling_rate = dataset.features["audio"].sampling_rate

processor = AutoProcessor.from_pretrained("speechbrain/m-ctc-t-large")
model = MCTCTForCTC.from_pretrained("speechbrain/m-ctc-t-large")

# audio file is decoded on the fly
inputs = processor(dataset[0]["audio"]["array"], sampling_rate=sampling_rate, return_tensors="pt")
with torch.no_grad():
    logits = model(**inputs).logits
predicted_ids = torch.argmax(logits, dim=-1)

# transcribe speech
transcription = processor.batch_decode(predicted_ids)
transcription[0]

inputs["labels"] = processor(text=dataset[0]["text"], return_tensors="pt").input_ids

# compute loss
loss = model(**inputs).loss
round(loss.item(), 2)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoProcessor, MCTCTForCTC
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = load_dataset(<span class="hljs-string">&quot;hf-internal-testing/librispeech_asr_demo&quot;</span>, <span class="hljs-string">&quot;clean&quot;</span>, split=<span class="hljs-string">&quot;validation&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = dataset.sort(<span class="hljs-string">&quot;id&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>sampling_rate = dataset.features[<span class="hljs-string">&quot;audio&quot;</span>].sampling_rate

<span class="hljs-meta">&gt;&gt;&gt; </span>processor = AutoProcessor.from_pretrained(<span class="hljs-string">&quot;speechbrain/m-ctc-t-large&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>model = MCTCTForCTC.from_pretrained(<span class="hljs-string">&quot;speechbrain/m-ctc-t-large&quot;</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># audio file is decoded on the fly</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = processor(dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;audio&quot;</span>][<span class="hljs-string">&quot;array&quot;</span>], sampling_rate=sampling_rate, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> torch.no_grad():
<span class="hljs-meta">... </span>    logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>predicted_ids = torch.argmax(logits, dim=-<span class="hljs-number">1</span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># transcribe speech</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription = processor.batch_decode(predicted_ids)
<span class="hljs-meta">&gt;&gt;&gt; </span>transcription[<span class="hljs-number">0</span>]
<span class="hljs-string">&quot;Mr. Quilter is the apostle of the middle classes, and we&#x27;re glad to welcome his gospel.&quot;</span>

<span class="hljs-meta">&gt;&gt;&gt; </span>inputs[<span class="hljs-string">&quot;labels&quot;</span>] = processor(text=dataset[<span class="hljs-number">0</span>][<span class="hljs-string">&quot;text&quot;</span>], return_tensors=<span class="hljs-string">&quot;pt&quot;</span>).input_ids

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># compute loss</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>loss = model(**inputs).loss
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">round</span>(loss.item(), <span class="hljs-number">2</span>)
<span class="hljs-number">1885.65</span>`}}),{c(){d=r("p"),C=s("Example:"),f=m(),v(g.$$.fragment)},l(l){d=a(l,"P",{});var _=n(d);C=i(_,"Example:"),_.forEach(o),f=p(l),b(g.$$.fragment,l)},m(l,_){u(l,d,_),e(d,C),u(l,f,_),w(g,l,_),T=!0},p:vn,i(l){T||($(g.$$.fragment,l),T=!0)},o(l){M(g.$$.fragment,l),T=!1},d(l){l&&o(d),l&&o(f),y(g,l)}}}function Ns(z){let d,C,f,g,T,l,_,k,A,E,F,P,j,H,pt,ie,or,bo,le,rr,je,ar,nr,wo,ht,sr,$o,ft,Ut,ir,Mo,B,lr,qe,cr,dr,Ae,mr,pr,yo,K,ce,Rt,De,hr,Ht,fr,xo,ut,Bt,gt,ur,ko,_t,gr,Eo,Tt,Gt,_r,Po,Q,de,Jt,Ie,Tr,Kt,Cr,zo,I,Le,vr,Y,br,Ct,wr,$r,Se,Mr,yr,xr,X,kr,vt,Er,Pr,bt,zr,Fr,jr,me,Fo,Z,pe,Qt,Ne,qr,Yt,Ar,jo,L,Oe,Dr,Xt,Ir,Lr,ee,Sr,wt,Nr,Or,Ve,Vr,Wr,Ur,he,We,Rr,Zt,Hr,qo,te,fe,eo,Ue,Br,to,Gr,Ao,x,Re,Jr,oo,Kr,Qr,D,$t,Yr,Xr,Mt,Zr,ea,yt,ta,oa,He,ro,ra,aa,na,xt,sa,ia,la,ue,Be,ca,V,da,Ge,ao,ma,pa,ha,no,fa,ua,so,ga,_a,Ta,G,Je,Ca,io,va,ba,ge,wa,J,Ke,$a,Qe,Ma,kt,ya,xa,ka,_e,Ea,Te,Ye,Pa,Xe,za,Et,Fa,ja,qa,Ce,Ze,Aa,et,Da,Pt,Ia,La,Do,oe,ve,lo,tt,Sa,co,Na,Io,W,ot,Oa,rt,Va,at,Wa,Ua,Ra,N,nt,Ha,re,Ba,zt,Ga,Ja,mo,Ka,Qa,Ya,be,Xa,we,Lo,ae,$e,po,st,Za,ho,en,So,U,it,tn,ne,on,fo,rn,an,lt,nn,sn,ln,O,ct,cn,se,dn,Ft,mn,pn,uo,hn,fn,un,Me,gn,ye,No;return l=new Fe({}),H=new Fe({}),De=new Fe({}),Ie=new Fe({}),Le=new S({props:{name:"class transformers.MCTCTConfig",anchor:"transformers.MCTCTConfig",parameters:[{name:"vocab_size",val:" = 8065"},{name:"hidden_size",val:" = 1536"},{name:"num_hidden_layers",val:" = 36"},{name:"intermediate_size",val:" = 6144"},{name:"num_attention_heads",val:" = 4"},{name:"attention_head_dim",val:" = 384"},{name:"max_position_embeddings",val:" = 920"},{name:"layer_norm_eps",val:" = 1e-05"},{name:"layerdrop",val:" = 0.3"},{name:"hidden_act",val:" = 'relu'"},{name:"initializer_range",val:" = 0.02"},{name:"hidden_dropout_prob",val:" = 0.3"},{name:"attention_probs_dropout_prob",val:" = 0.3"},{name:"pad_token_id",val:" = 1"},{name:"bos_token_id",val:" = 0"},{name:"eos_token_id",val:" = 2"},{name:"conv_glu_dim",val:" = 1"},{name:"conv_dropout",val:" = 0.3"},{name:"num_conv_layers",val:" = 1"},{name:"conv_kernel",val:" = (7,)"},{name:"conv_stride",val:" = (3,)"},{name:"input_feat_per_channel",val:" = 80"},{name:"input_channels",val:" = 1"},{name:"conv_channels",val:" = None"},{name:"ctc_loss_reduction",val:" = 'sum'"},{name:"ctc_zero_infinity",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MCTCTConfig.vocab_size",description:`<strong>vocab_size</strong> (<code>int</code>, <em>optional</em>, defaults to 8065) &#x2014;
Vocabulary size of the M-CTC-T model. Defines the number of different tokens that can be represented by the
<code>inputs_ids</code> passed when calling <a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTModel">MCTCTModel</a>.`,name:"vocab_size"},{anchor:"transformers.MCTCTConfig.hidden_size",description:`<strong>hidden_size</strong> (<code>int</code>, <em>optional</em>, defaults to 1536) &#x2014;
Dimension of the encoder layers and the pooler layer.`,name:"hidden_size"},{anchor:"transformers.MCTCTConfig.num_hidden_layers",description:`<strong>num_hidden_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 36) &#x2014;
Number of hidden layers in the Transformer encoder.`,name:"num_hidden_layers"},{anchor:"transformers.MCTCTConfig.intermediate_size",description:`<strong>intermediate_size</strong> (<code>int</code>, <em>optional</em>, defaults to 6144) &#x2014;
Dimension of the &#x201C;intermediate&#x201D; (i.e., feed-forward) layer in the Transformer encoder.`,name:"intermediate_size"},{anchor:"transformers.MCTCTConfig.num_attention_heads",description:`<strong>num_attention_heads</strong> (<code>int</code>, <em>optional</em>, defaults to 4) &#x2014;
Number of attention heads for each attention layer in the Transformer encoder.`,name:"num_attention_heads"},{anchor:"transformers.MCTCTConfig.attention_head_dim",description:`<strong>attention_head_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 384) &#x2014;
Dimensions of each attention head for each attention layer in the Transformer encoder.`,name:"attention_head_dim"},{anchor:"transformers.MCTCTConfig.max_position_embeddings",description:`<strong>max_position_embeddings</strong> (<code>int</code>, <em>optional</em>, defaults to 920) &#x2014;
The maximum sequence length that this model might ever be used with (after log-mel spectrogram extraction).`,name:"max_position_embeddings"},{anchor:"transformers.MCTCTConfig.layer_norm_eps",description:`<strong>layer_norm_eps</strong> (<code>float</code>, <em>optional</em>, defaults to 1e-5) &#x2014;
The epsilon used by the layer normalization layers.`,name:"layer_norm_eps"},{anchor:"transformers.MCTCTConfig.layerdrop",description:`<strong>layerdrop</strong> (<code>float</code>, <em>optional</em>, defaults to 0.3) &#x2014;
The probability of dropping an encoder layer during training. The default 0.3 value is used in the original
implementation.`,name:"layerdrop"},{anchor:"transformers.MCTCTConfig.hidden_act",description:`<strong>hidden_act</strong> (<code>str</code> or <code>function</code>, <em>optional</em>, defaults to <code>&quot;relu&quot;</code>) &#x2014;
The non-linear activation function (function or string) in the encoder and pooler. If string, <code>&quot;gelu&quot;</code>,
<code>&quot;relu&quot;</code>, <code>&quot;selu&quot;</code> and <code>&quot;gelu_new&quot;</code> are supported.`,name:"hidden_act"},{anchor:"transformers.MCTCTConfig.initializer_range",description:`<strong>initializer_range</strong> (<code>float</code>, <em>optional</em>, defaults to 0.02) &#x2014;
The standard deviation of the truncated_normal_initializer for initializing all weight matrices.`,name:"initializer_range"},{anchor:"transformers.MCTCTConfig.hidden_dropout_prob",description:`<strong>hidden_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout probabilitiy for all fully connected layers in the embeddings, encoder, and pooler.`,name:"hidden_dropout_prob"},{anchor:"transformers.MCTCTConfig.attention_probs_dropout_prob",description:`<strong>attention_probs_dropout_prob</strong> (<code>float</code>, <em>optional</em>, defaults to 0.1) &#x2014;
The dropout ratio for the attention probabilities.`,name:"attention_probs_dropout_prob"},{anchor:"transformers.MCTCTConfig.pad_token_id",description:`<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The tokenizer index of the pad token.`,name:"pad_token_id"},{anchor:"transformers.MCTCTConfig.bos_token_id",description:`<strong>bos_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014;
The tokenizer index of the bos token.`,name:"bos_token_id"},{anchor:"transformers.MCTCTConfig.eos_token_id",description:`<strong>eos_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to 2) &#x2014;
The tokenizer index of the eos token.`,name:"eos_token_id"},{anchor:"transformers.MCTCTConfig.conv_glu_dim",description:`<strong>conv_glu_dim</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The dimension of the output of the <code>Conv1dSubsampler</code> layer in which GLU is applied on. Though the original
Flashlight code uses the value of 2, here it&#x2019;s adapted to 1 due to transposition differences.`,name:"conv_glu_dim"},{anchor:"transformers.MCTCTConfig.conv_dropout",description:`<strong>conv_dropout</strong> (<code>int</code>, <em>optional</em>, defaults to 0.3) &#x2014;
The probability of randomly dropping the <code>Conv1dSubsampler</code> layer during training.`,name:"conv_dropout"},{anchor:"transformers.MCTCTConfig.num_conv_layers",description:`<strong>num_conv_layers</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of convolution layers before applying transformer encoder layers.`,name:"num_conv_layers"},{anchor:"transformers.MCTCTConfig.conv_kernel",description:`<strong>conv_kernel</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[7]</code>) &#x2014;
The kernel size of the 1D convolution applied before transformer layers. <code>len(conv_kernel)</code> must be equal
to <code>num_conv_layers</code>.`,name:"conv_kernel"},{anchor:"transformers.MCTCTConfig.conv_stride",description:`<strong>conv_stride</strong> (<code>List[int]</code>, <em>optional</em>, defaults to <code>[3]</code>) &#x2014;
The stride length of the 1D convolution applied before transformer layers. <code>len(conv_stride)</code> must be equal
to <code>num_conv_layers</code>.`,name:"conv_stride"},{anchor:"transformers.MCTCTConfig.input_feat_per_channel",description:`<strong>input_feat_per_channel</strong> (<code>int</code>, <em>optional</em>, defaults to 80) &#x2014;
Feature dimensions of the channels of the input to the Conv1D layer.`,name:"input_feat_per_channel"},{anchor:"transformers.MCTCTConfig.input_channels",description:`<strong>input_channels</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of input channels of the input to the Conv1D layer.`,name:"input_channels"},{anchor:"transformers.MCTCTConfig.conv_channels",description:`<strong>conv_channels</strong> (<code>List[int]</code>, <em>optional</em>, defaults to None) &#x2014;
Channel sizes of intermediate Conv1D layers.`,name:"conv_channels"},{anchor:"transformers.MCTCTConfig.ctc_loss_reduction",description:`<strong>ctc_loss_reduction</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sum&quot;</code>) &#x2014;
Specifies the reduction to apply to the output of <code>torch.nn.CTCLoss</code>. Only relevant when training an
instance of <a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTForCTC">MCTCTForCTC</a>.`,name:"ctc_loss_reduction"},{anchor:"transformers.MCTCTConfig.ctc_zero_infinity",description:`<strong>ctc_zero_infinity</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to zero infinite losses and the associated gradients of <code>torch.nn.CTCLoss</code>. Infinite losses mainly
occur when the inputs are too short to be aligned to the targets. Only relevant when training an instance
of <a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTForCTC">MCTCTForCTC</a>.`,name:"ctc_zero_infinity"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/configuration_mctct.py#L29"}}),me=new Cn({props:{anchor:"transformers.MCTCTConfig.example",$$slots:{default:[js]},$$scope:{ctx:z}}}),Ne=new Fe({}),Oe=new S({props:{name:"class transformers.MCTCTFeatureExtractor",anchor:"transformers.MCTCTFeatureExtractor",parameters:[{name:"feature_size",val:" = 80"},{name:"sampling_rate",val:" = 16000"},{name:"padding_value",val:" = 0.0"},{name:"hop_length",val:" = 10"},{name:"win_length",val:" = 25"},{name:"win_function",val:" = 'hamming_window'"},{name:"frame_signal_scale",val:" = 32768.0"},{name:"preemphasis_coeff",val:" = 0.97"},{name:"mel_floor",val:" = 1.0"},{name:"normalize_means",val:" = True"},{name:"normalize_vars",val:" = True"},{name:"return_attention_mask",val:" = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MCTCTFeatureExtractor.feature_size",description:`<strong>feature_size</strong> (<code>int</code>, defaults to 80) &#x2014;
The feature dimension of the extracted features. This is the number of mel_frequency`,name:"feature_size"},{anchor:"transformers.MCTCTFeatureExtractor.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, defaults to 16000) &#x2014;
The sampling rate at which the audio files should be digitalized expressed in hertz (Hz).`,name:"sampling_rate"},{anchor:"transformers.MCTCTFeatureExtractor.padding_value",description:`<strong>padding_value</strong> (<code>float</code>, defaults to 0.0) &#x2014;
The value that is used to fill the padding values.`,name:"padding_value"},{anchor:"transformers.MCTCTFeatureExtractor.hop_length",description:`<strong>hop_length</strong> (<code>int</code>, defaults to 10) &#x2014;
Number of audio samples between windows. Otherwise referred to as &#x201C;shift&#x201D; in many papers.`,name:"hop_length"},{anchor:"transformers.MCTCTFeatureExtractor.win_length",description:`<strong>win_length</strong> (<code>int</code>, defaults to 25) &#x2014;
Number of ms per window`,name:"win_length"},{anchor:"transformers.MCTCTFeatureExtractor.win_function",description:`<strong>win_function</strong> (<code>str</code>, defaults to <code>&quot;hamming_window&quot;</code>) &#x2014;
Name for the window function used for windowing, must be accessible via <code>torch.{win_function}</code>`,name:"win_function"},{anchor:"transformers.MCTCTFeatureExtractor.frame_signal_scale",description:`<strong>frame_signal_scale</strong> (<code>float</code>, defaults to 32768.0) &#x2014;
Constant multiplied in creating the frames before applying DFT.`,name:"frame_signal_scale"},{anchor:"transformers.MCTCTFeatureExtractor.preemphasis_coeff",description:`<strong>preemphasis_coeff</strong> (<code>float</code>, defaults to 0.97) &#x2014;
Constant multiplied in applying Pre-emphasis before DFT.`,name:"preemphasis_coeff"},{anchor:"transformers.MCTCTFeatureExtractor.mel_floor",description:`<strong>mel_floor</strong> (<code>float</code> defaults to 1.0) &#x2014;
Minimum value of mel frequency banks.`,name:"mel_floor"},{anchor:"transformers.MCTCTFeatureExtractor.normalize_means",description:`<strong>normalize_means</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to zero-mean normalize the extracted features.`,name:"normalize_means"},{anchor:"transformers.MCTCTFeatureExtractor.normalize_vars",description:`<strong>normalize_vars</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to unit-variance normalize the extracted features.`,name:"normalize_vars"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/feature_extraction_mctct.py#L42"}}),We=new S({props:{name:"__call__",anchor:"transformers.MCTCTFeatureExtractor.__call__",parameters:[{name:"raw_speech",val:": typing.Union[numpy.ndarray, typing.List[float], typing.List[numpy.ndarray], typing.List[typing.List[float]]]"},{name:"padding",val:": typing.Union[bool, str, transformers.utils.generic.PaddingStrategy] = False"},{name:"max_length",val:": typing.Optional[int] = None"},{name:"truncation",val:": bool = False"},{name:"pad_to_multiple_of",val:": typing.Optional[int] = None"},{name:"return_attention_mask",val:": typing.Optional[bool] = None"},{name:"return_tensors",val:": typing.Union[str, transformers.utils.generic.TensorType, NoneType] = None"},{name:"sampling_rate",val:": typing.Optional[int] = None"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MCTCTFeatureExtractor.__call__.raw_speech",description:`<strong>raw_speech</strong> (<code>torch.Tensor</code>, <code>np.ndarray</code>, <code>List[float]</code>, <code>List[torch.Tensor]</code>, <code>List[np.ndarray]</code>, <code>List[List[float]]</code>) &#x2014;
The sequence or batch of sequences to be padded. Each sequence can be a tensor, a numpy array, a list
of float values, a list of tensors, a list of numpy arrays or a list of list of float values.`,name:"raw_speech"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.padding",description:`<strong>padding</strong> (<code>bool</code>, <code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.utils.PaddingStrategy">PaddingStrategy</a>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Select a strategy to pad the returned sequences (according to the model&#x2019;s padding side and padding
index) among:</p>
<ul>
<li><code>True</code> or <code>&apos;longest&apos;</code>: Pad to the longest sequence in the batch (or no padding if only a single
sequence if provided).</li>
<li><code>&apos;max_length&apos;</code>: Pad to a maximum length specified with the argument <code>max_length</code> or to the maximum
acceptable input length for the model if that argument is not provided.</li>
<li><code>False</code> or <code>&apos;do_not_pad&apos;</code> (default): No padding (i.e., can output a batch with sequences of different
lengths).</li>
</ul>`,name:"padding"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Maximum length of the returned list and optionally padding length (see above).`,name:"max_length"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.truncation",description:`<strong>truncation</strong> (<code>bool</code>) &#x2014;
Activates truncation to cut input sequences longer than <em>max_length</em> to <em>max_length</em>.`,name:"truncation"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.pad_to_multiple_of",description:`<strong>pad_to_multiple_of</strong> (<code>int</code>, <em>optional</em>) &#x2014;
If set will pad the sequence to a multiple of the provided value.</p>
<p>This is especially useful to enable the use of Tensor Cores on NVIDIA hardware with compute capability
<code>&gt;= 7.5</code> (Volta), or on TPUs which benefit from having sequence lengths be a multiple of 128.`,name:"pad_to_multiple_of"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.return_attention_mask",description:`<strong>return_attention_mask</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to return the attention mask. If left to the default, will return the attention mask according
to the specific feature_extractor&#x2019;s default.</p>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"return_attention_mask"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.return_tensors",description:`<strong>return_tensors</strong> (<code>str</code> or <a href="/docs/transformers/pr_22182/en/internal/file_utils#transformers.TensorType">TensorType</a>, <em>optional</em>) &#x2014;
If set, will return tensors instead of list of python integers. Acceptable values are:</p>
<ul>
<li><code>&apos;tf&apos;</code>: Return TensorFlow <code>tf.constant</code> objects.</li>
<li><code>&apos;pt&apos;</code>: Return PyTorch <code>torch.Tensor</code> objects.</li>
<li><code>&apos;np&apos;</code>: Return Numpy <code>np.ndarray</code> objects.</li>
</ul>`,name:"return_tensors"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.sampling_rate",description:`<strong>sampling_rate</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The sampling rate at which the <code>raw_speech</code> input was sampled. It is strongly recommended to pass
<code>sampling_rate</code> at the forward call to prevent silent errors.`,name:"sampling_rate"},{anchor:"transformers.MCTCTFeatureExtractor.__call__.padding_value",description:"<strong>padding_value</strong> (<code>float</code>, defaults to 0.0) &#x2014;",name:"padding_value"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/feature_extraction_mctct.py#L240"}}),Ue=new Fe({}),Re=new S({props:{name:"class transformers.MCTCTProcessor",anchor:"transformers.MCTCTProcessor",parameters:[{name:"feature_extractor",val:""},{name:"tokenizer",val:""}],parametersDescription:[{anchor:"transformers.MCTCTProcessor.feature_extractor",description:`<strong>feature_extractor</strong> (<code>MCTCTFeatureExtractor</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTFeatureExtractor">MCTCTFeatureExtractor</a>. The feature extractor is a required input.`,name:"feature_extractor"},{anchor:"transformers.MCTCTProcessor.tokenizer",description:`<strong>tokenizer</strong> (<code>AutoTokenizer</code>) &#x2014;
An instance of <a href="/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoTokenizer">AutoTokenizer</a>. The tokenizer is a required input.`,name:"tokenizer"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/processing_mctct.py#L24"}}),Be=new S({props:{name:"__call__",anchor:"transformers.MCTCTProcessor.__call__",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/processing_mctct.py#L45"}}),Je=new S({props:{name:"from_pretrained",anchor:"transformers.MCTCTProcessor.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:""},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MCTCTProcessor.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
This can be either:</p>
<ul>
<li>a string, the <em>model id</em> of a pretrained feature_extractor hosted inside a model repo on
huggingface.co. Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or
namespaced under a user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>a path to a <em>directory</em> containing a feature extractor file saved using the
<a href="/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.save_pretrained">save_pretrained()</a> method, e.g., <code>./my_model_directory/</code>.</li>
<li>a path or url to a saved feature extractor JSON <em>file</em>, e.g.,
<code>./my_model_directory/preprocessor_config.json</code>.
**kwargs &#x2014;
Additional keyword arguments passed along to both
<a href="/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.FeatureExtractionMixin.from_pretrained">from_pretrained()</a> and
<code>~tokenization_utils_base.PreTrainedTokenizer.from_pretrained</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/processing_utils.py#L153"}}),ge=new tr({props:{$$slots:{default:[qs]},$$scope:{ctx:z}}}),Ke=new S({props:{name:"save_pretrained",anchor:"transformers.MCTCTProcessor.save_pretrained",parameters:[{name:"save_directory",val:""},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.MCTCTProcessor.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the feature extractor JSON file and the tokenizer files will be saved (directory will
be created if it does not exist).`,name:"save_directory"},{anchor:"transformers.MCTCTProcessor.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Hugging Face model hub after saving it. You can specify the
repository you want to push to with <code>repo_id</code> (will default to the name of <code>save_directory</code> in your
namespace).
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.push_to_hub">push_to_hub()</a> method.`,name:"push_to_hub"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/processing_utils.py#L91"}}),_e=new tr({props:{$$slots:{default:[As]},$$scope:{ctx:z}}}),Ye=new S({props:{name:"batch_decode",anchor:"transformers.MCTCTProcessor.batch_decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/processing_mctct.py#L83"}}),Ze=new S({props:{name:"decode",anchor:"transformers.MCTCTProcessor.decode",parameters:[{name:"*args",val:""},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/processing_mctct.py#L120"}}),tt=new Fe({}),ot=new S({props:{name:"class transformers.MCTCTModel",anchor:"transformers.MCTCTModel",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.MCTCTModel.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTConfig">MCTCTConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/modeling_mctct.py#L661"}}),nt=new S({props:{name:"forward",anchor:"transformers.MCTCTModel.forward",parameters:[{name:"input_features",val:": Tensor"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"}],parametersDescription:[{anchor:"transformers.MCTCTModel.forward.input_features",description:`<strong>input_features</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, sequence_length)</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer">Wav2Vec2CTCTokenizer</a>. See <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_features"},{anchor:"transformers.MCTCTModel.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length)</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.MCTCTModel.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.MCTCTModel.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.MCTCTModel.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.MCTCTModel.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/modeling_mctct.py#L671",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTConfig"
>MCTCTConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>last_hidden_state</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, hidden_size)</code>) \u2014 Sequence of hidden-states at the output of the last layer of the model.</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.BaseModelOutput"
>transformers.modeling_outputs.BaseModelOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),be=new tr({props:{$$slots:{default:[Ds]},$$scope:{ctx:z}}}),we=new Cn({props:{anchor:"transformers.MCTCTModel.forward.example",$$slots:{default:[Is]},$$scope:{ctx:z}}}),st=new Fe({}),it=new S({props:{name:"class transformers.MCTCTForCTC",anchor:"transformers.MCTCTForCTC",parameters:[{name:"config",val:""}],parametersDescription:[{anchor:"transformers.MCTCTForCTC.config",description:`<strong>config</strong> (<a href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTConfig">MCTCTConfig</a>) &#x2014; Model configuration class with all the parameters of the model.
Initializing with a config file does not load the weights associated with the model, only the
configuration. Check out the <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">from_pretrained()</a> method to load the model weights.`,name:"config"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/modeling_mctct.py#L721"}}),ct=new S({props:{name:"forward",anchor:"transformers.MCTCTForCTC.forward",parameters:[{name:"input_features",val:": Tensor"},{name:"attention_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"head_mask",val:": typing.Optional[torch.Tensor] = None"},{name:"output_attentions",val:": typing.Optional[bool] = None"},{name:"output_hidden_states",val:": typing.Optional[bool] = None"},{name:"return_dict",val:": typing.Optional[bool] = None"},{name:"labels",val:": typing.Optional[torch.LongTensor] = None"}],parametersDescription:[{anchor:"transformers.MCTCTForCTC.forward.input_features",description:`<strong>input_features</strong> (<code>torch.LongTensor</code> of shape <code>({0})</code>) &#x2014;
Indices of input sequence tokens in the vocabulary.</p>
<p>Indices can be obtained using <a href="/docs/transformers/pr_22182/en/model_doc/wav2vec2#transformers.Wav2Vec2CTCTokenizer">Wav2Vec2CTCTokenizer</a>. See <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.encode">PreTrainedTokenizer.encode()</a> and
<a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.__call__">PreTrainedTokenizer.<strong>call</strong>()</a> for details.</p>
<p><a href="../glossary#input-ids">What are input IDs?</a>`,name:"input_features"},{anchor:"transformers.MCTCTForCTC.forward.attention_mask",description:`<strong>attention_mask</strong> (<code>torch.FloatTensor</code> of shape <code>({0})</code>, <em>optional</em>) &#x2014;
Mask to avoid performing attention on padding token indices. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 for tokens that are <strong>not masked</strong>,</li>
<li>0 for tokens that are <strong>masked</strong>.</li>
</ul>
<p><a href="../glossary#attention-mask">What are attention masks?</a>`,name:"attention_mask"},{anchor:"transformers.MCTCTForCTC.forward.head_mask",description:`<strong>head_mask</strong> (<code>torch.FloatTensor</code> of shape <code>(num_heads,)</code> or <code>(num_layers, num_heads)</code>, <em>optional</em>) &#x2014;
Mask to nullify selected heads of the self-attention modules. Mask values selected in <code>[0, 1]</code>:</p>
<ul>
<li>1 indicates the head is <strong>not masked</strong>,</li>
<li>0 indicates the head is <strong>masked</strong>.</li>
</ul>`,name:"head_mask"},{anchor:"transformers.MCTCTForCTC.forward.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the attentions tensors of all attention layers. See <code>attentions</code> under returned
tensors for more detail.`,name:"output_attentions"},{anchor:"transformers.MCTCTForCTC.forward.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return the hidden states of all layers. See <code>hidden_states</code> under returned tensors for
more detail.`,name:"output_hidden_states"},{anchor:"transformers.MCTCTForCTC.forward.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.MCTCTForCTC.forward.labels",description:`<strong>labels</strong> (<code>torch.LongTensor</code> of shape <code>(batch_size, target_length)</code>, <em>optional</em>) &#x2014;
Labels for connectionist temporal classification. Note that <code>target_length</code> has to be smaller or equal to
the sequence length of the output logits. Indices are selected in <code>[-100, 0, ..., config.vocab_size - 1]</code>.
All labels set to <code>-100</code> are ignored (masked), the loss is only computed for labels in <code>[0, ..., config.vocab_size - 1]</code>.`,name:"labels"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/models/mctct/modeling_mctct.py#L741",returnDescription:`
<p>A <a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.CausalLMOutput"
>transformers.modeling_outputs.CausalLMOutput</a> or a tuple of
<code>torch.FloatTensor</code> (if <code>return_dict=False</code> is passed or when <code>config.return_dict=False</code>) comprising various
elements depending on the configuration (<a
  href="/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTConfig"
>MCTCTConfig</a>) and inputs.</p>
<ul>
<li>
<p><strong>loss</strong> (<code>torch.FloatTensor</code> of shape <code>(1,)</code>, <em>optional</em>, returned when <code>labels</code> is provided) \u2014 Language modeling loss (for next-token prediction).</p>
</li>
<li>
<p><strong>logits</strong> (<code>torch.FloatTensor</code> of shape <code>(batch_size, sequence_length, config.vocab_size)</code>) \u2014 Prediction scores of the language modeling head (scores for each vocabulary token before SoftMax).</p>
</li>
<li>
<p><strong>hidden_states</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_hidden_states=True</code> is passed or when <code>config.output_hidden_states=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for the output of the embeddings, if the model has an embedding layer, +
one for the output of each layer) of shape <code>(batch_size, sequence_length, hidden_size)</code>.</p>
<p>Hidden-states of the model at the output of each layer plus the optional initial embedding outputs.</p>
</li>
<li>
<p><strong>attentions</strong> (<code>tuple(torch.FloatTensor)</code>, <em>optional</em>, returned when <code>output_attentions=True</code> is passed or when <code>config.output_attentions=True</code>) \u2014 Tuple of <code>torch.FloatTensor</code> (one for each layer) of shape <code>(batch_size, num_heads, sequence_length, sequence_length)</code>.</p>
<p>Attentions weights after the attention softmax, used to compute the weighted average in the self-attention
heads.</p>
</li>
</ul>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/output#transformers.modeling_outputs.CausalLMOutput"
>transformers.modeling_outputs.CausalLMOutput</a> or <code>tuple(torch.FloatTensor)</code></p>
`}}),Me=new tr({props:{$$slots:{default:[Ls]},$$scope:{ctx:z}}}),ye=new Cn({props:{anchor:"transformers.MCTCTForCTC.forward.example",$$slots:{default:[Ss]},$$scope:{ctx:z}}}),{c(){d=r("meta"),C=m(),f=r("h1"),g=r("a"),T=r("span"),v(l.$$.fragment),_=m(),k=r("span"),A=s("M-CTC-T"),E=m(),F=r("h2"),P=r("a"),j=r("span"),v(H.$$.fragment),pt=m(),ie=r("span"),or=s("Overview"),bo=m(),le=r("p"),rr=s("The M-CTC-T model was proposed in "),je=r("a"),ar=s("Pseudo-Labeling For Massively Multilingual Speech Recognition"),nr=s(" by Loren Lugosch, Tatiana Likhomanenko, Gabriel Synnaeve, and Ronan Collobert. The model is a 1B-param transformer encoder, with a CTC head over 8065 character labels and a language identification head over 60 language ID labels. It is trained on Common Voice (version 6.1, December 2020 release) and VoxPopuli. After training on Common Voice and VoxPopuli, the model is trained on Common Voice only. The labels are unnormalized character-level transcripts (punctuation and capitalization are not removed). The model takes as input Mel filterbank features from a 16Khz audio signal."),wo=m(),ht=r("p"),sr=s("The abstract from the paper is the following:"),$o=m(),ft=r("p"),Ut=r("em"),ir=s(`Semi-supervised learning through pseudo-labeling has become a staple of state-of-the-art monolingual
speech recognition systems. In this work, we extend pseudo-labeling to massively multilingual speech
recognition with 60 languages. We propose a simple pseudo-labeling recipe that works well even
with low-resource languages: train a supervised multilingual model, fine-tune it with semi-supervised
learning on a target language, generate pseudo-labels for that language, and train a final model using
pseudo-labels for all languages, either from scratch or by fine-tuning. Experiments on the labeled
Common Voice and unlabeled VoxPopuli datasets show that our recipe can yield a model with better
performance for many languages that also transfers well to LibriSpeech.`),Mo=m(),B=r("p"),lr=s("This model was contributed by "),qe=r("a"),cr=s("cwkeam"),dr=s(". The original code can be found "),Ae=r("a"),mr=s("here"),pr=s("."),yo=m(),K=r("h2"),ce=r("a"),Rt=r("span"),v(De.$$.fragment),hr=m(),Ht=r("span"),fr=s("Documentation resources"),xo=m(),ut=r("ul"),Bt=r("li"),gt=r("a"),ur=s("Automatic speech recognition task guide"),ko=m(),_t=r("p"),gr=s("Tips:"),Eo=m(),Tt=r("ul"),Gt=r("li"),_r=s("The PyTorch version of this model is only available in torch 1.9 and higher."),Po=m(),Q=r("h2"),de=r("a"),Jt=r("span"),v(Ie.$$.fragment),Tr=m(),Kt=r("span"),Cr=s("MCTCTConfig"),zo=m(),I=r("div"),v(Le.$$.fragment),vr=m(),Y=r("p"),br=s("This is the configuration class to store the configuration of a "),Ct=r("a"),wr=s("MCTCTModel"),$r=s(`. It is used to instantiate an
M-CTC-T model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the M-CTC-T
`),Se=r("a"),Mr=s("speechbrain/m-ctc-t-large"),yr=s(" architecture."),xr=m(),X=r("p"),kr=s("Configuration objects inherit from "),vt=r("a"),Er=s("PretrainedConfig"),Pr=s(` and can be used to control the model outputs. Read the
documentation from `),bt=r("a"),zr=s("PretrainedConfig"),Fr=s(" for more information."),jr=m(),v(me.$$.fragment),Fo=m(),Z=r("h2"),pe=r("a"),Qt=r("span"),v(Ne.$$.fragment),qr=m(),Yt=r("span"),Ar=s("MCTCTFeatureExtractor"),jo=m(),L=r("div"),v(Oe.$$.fragment),Dr=m(),Xt=r("p"),Ir=s("Constructs a M-CTC-T feature extractor."),Lr=m(),ee=r("p"),Sr=s("This feature extractor inherits from "),wt=r("a"),Nr=s("SequenceFeatureExtractor"),Or=s(` which contains
most of the main methods. Users should refer to this superclass for more information regarding those methods. This
code has been adapted from Flashlight\u2019s C++ code. For more information about the implementation, one can refer to
this `),Ve=r("a"),Vr=s("notebook"),Wr=s(`
that takes the user step-by-step in the implementation.`),Ur=m(),he=r("div"),v(We.$$.fragment),Rr=m(),Zt=r("p"),Hr=s(`Main method to featurize and prepare for the model one or several sequence(s). sequences. It returns the
log-mel spectrogram of the input audio, as implemented in the original Flashlight MFSC feature extraction code.`),qo=m(),te=r("h2"),fe=r("a"),eo=r("span"),v(Ue.$$.fragment),Br=m(),to=r("span"),Gr=s("MCTCTProcessor"),Ao=m(),x=r("div"),v(Re.$$.fragment),Jr=m(),oo=r("p"),Kr=s("Constructs a MCTCT processor which wraps a MCTCT feature extractor and a MCTCT tokenizer into a single processor."),Qr=m(),D=r("p"),$t=r("a"),Yr=s("MCTCTProcessor"),Xr=s(" offers all the functionalities of "),Mt=r("a"),Zr=s("MCTCTFeatureExtractor"),ea=s(" and "),yt=r("a"),ta=s("AutoTokenizer"),oa=s(`. See the
`),He=r("a"),ro=r("strong"),ra=s("call"),aa=s("()"),na=s(" and "),xt=r("a"),sa=s("decode()"),ia=s(" for more information."),la=m(),ue=r("div"),v(Be.$$.fragment),ca=m(),V=r("p"),da=s(`When used in normal mode, this method forwards all its arguments to MCTCTFeatureExtractor\u2019s
`),Ge=r("a"),ao=r("strong"),ma=s("call"),pa=s("()"),ha=s(` and returns its output. If used in the context
`),no=r("code"),fa=s("as_target_processor()"),ua=s(` this method forwards all its arguments to AutoTokenizer\u2019s
`),so=r("code"),ga=s("__call__()"),_a=s(". Please refer to the doctsring of the above two methods for more information."),Ta=m(),G=r("div"),v(Je.$$.fragment),Ca=m(),io=r("p"),va=s("Instantiate a processor associated with a pretrained model."),ba=m(),v(ge.$$.fragment),wa=m(),J=r("div"),v(Ke.$$.fragment),$a=m(),Qe=r("p"),Ma=s(`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),kt=r("a"),ya=s("from_pretrained()"),xa=s(" method."),ka=m(),v(_e.$$.fragment),Ea=m(),Te=r("div"),v(Ye.$$.fragment),Pa=m(),Xe=r("p"),za=s("This method forwards all its arguments to AutoTokenizer\u2019s "),Et=r("a"),Fa=s("batch_decode()"),ja=s(`. Please refer
to the docstring of this method for more information.`),qa=m(),Ce=r("div"),v(Ze.$$.fragment),Aa=m(),et=r("p"),Da=s("This method forwards all its arguments to AutoTokenizer\u2019s "),Pt=r("a"),Ia=s("decode()"),La=s(`. Please refer to the
docstring of this method for more information.`),Do=m(),oe=r("h2"),ve=r("a"),lo=r("span"),v(tt.$$.fragment),Sa=m(),co=r("span"),Na=s("MCTCTModel"),Io=m(),W=r("div"),v(ot.$$.fragment),Oa=m(),rt=r("p"),Va=s(`The bare M-CTC-T Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),at=r("a"),Wa=s("torch.nn.Module"),Ua=s(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Ra=m(),N=r("div"),v(nt.$$.fragment),Ha=m(),re=r("p"),Ba=s("The "),zt=r("a"),Ga=s("MCTCTModel"),Ja=s(" forward method, overrides the "),mo=r("code"),Ka=s("__call__"),Qa=s(" special method."),Ya=m(),v(be.$$.fragment),Xa=m(),v(we.$$.fragment),Lo=m(),ae=r("h2"),$e=r("a"),po=r("span"),v(st.$$.fragment),Za=m(),ho=r("span"),en=s("MCTCTForCTC"),So=m(),U=r("div"),v(it.$$.fragment),tn=m(),ne=r("p"),on=s("MCTCT Model with a "),fo=r("code"),rn=s("language modeling"),an=s(` head on top for Connectionist Temporal Classification (CTC).
This model is a PyTorch `),lt=r("a"),nn=s("torch.nn.Module"),sn=s(` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),ln=m(),O=r("div"),v(ct.$$.fragment),cn=m(),se=r("p"),dn=s("The "),Ft=r("a"),mn=s("MCTCTForCTC"),pn=s(" forward method, overrides the "),uo=r("code"),hn=s("__call__"),fn=s(" special method."),un=m(),v(Me.$$.fragment),gn=m(),v(ye.$$.fragment),this.h()},l(t){const h=zs('[data-svelte="svelte-1phssyn"]',document.head);d=a(h,"META",{name:!0,content:!0}),h.forEach(o),C=p(t),f=a(t,"H1",{class:!0});var dt=n(f);g=a(dt,"A",{id:!0,class:!0,href:!0});var go=n(g);T=a(go,"SPAN",{});var _o=n(T);b(l.$$.fragment,_o),_o.forEach(o),go.forEach(o),_=p(dt),k=a(dt,"SPAN",{});var To=n(k);A=i(To,"M-CTC-T"),To.forEach(o),dt.forEach(o),E=p(t),F=a(t,"H2",{class:!0});var mt=n(F);P=a(mt,"A",{id:!0,class:!0,href:!0});var Co=n(P);j=a(Co,"SPAN",{});var vo=n(j);b(H.$$.fragment,vo),vo.forEach(o),Co.forEach(o),pt=p(mt),ie=a(mt,"SPAN",{});var wn=n(ie);or=i(wn,"Overview"),wn.forEach(o),mt.forEach(o),bo=p(t),le=a(t,"P",{});var Oo=n(le);rr=i(Oo,"The M-CTC-T model was proposed in "),je=a(Oo,"A",{href:!0,rel:!0});var $n=n(je);ar=i($n,"Pseudo-Labeling For Massively Multilingual Speech Recognition"),$n.forEach(o),nr=i(Oo," by Loren Lugosch, Tatiana Likhomanenko, Gabriel Synnaeve, and Ronan Collobert. The model is a 1B-param transformer encoder, with a CTC head over 8065 character labels and a language identification head over 60 language ID labels. It is trained on Common Voice (version 6.1, December 2020 release) and VoxPopuli. After training on Common Voice and VoxPopuli, the model is trained on Common Voice only. The labels are unnormalized character-level transcripts (punctuation and capitalization are not removed). The model takes as input Mel filterbank features from a 16Khz audio signal."),Oo.forEach(o),wo=p(t),ht=a(t,"P",{});var Mn=n(ht);sr=i(Mn,"The abstract from the paper is the following:"),Mn.forEach(o),$o=p(t),ft=a(t,"P",{});var yn=n(ft);Ut=a(yn,"EM",{});var xn=n(Ut);ir=i(xn,`Semi-supervised learning through pseudo-labeling has become a staple of state-of-the-art monolingual
speech recognition systems. In this work, we extend pseudo-labeling to massively multilingual speech
recognition with 60 languages. We propose a simple pseudo-labeling recipe that works well even
with low-resource languages: train a supervised multilingual model, fine-tune it with semi-supervised
learning on a target language, generate pseudo-labels for that language, and train a final model using
pseudo-labels for all languages, either from scratch or by fine-tuning. Experiments on the labeled
Common Voice and unlabeled VoxPopuli datasets show that our recipe can yield a model with better
performance for many languages that also transfers well to LibriSpeech.`),xn.forEach(o),yn.forEach(o),Mo=p(t),B=a(t,"P",{});var jt=n(B);lr=i(jt,"This model was contributed by "),qe=a(jt,"A",{href:!0,rel:!0});var kn=n(qe);cr=i(kn,"cwkeam"),kn.forEach(o),dr=i(jt,". The original code can be found "),Ae=a(jt,"A",{href:!0,rel:!0});var En=n(Ae);mr=i(En,"here"),En.forEach(o),pr=i(jt,"."),jt.forEach(o),yo=p(t),K=a(t,"H2",{class:!0});var Vo=n(K);ce=a(Vo,"A",{id:!0,class:!0,href:!0});var Pn=n(ce);Rt=a(Pn,"SPAN",{});var zn=n(Rt);b(De.$$.fragment,zn),zn.forEach(o),Pn.forEach(o),hr=p(Vo),Ht=a(Vo,"SPAN",{});var Fn=n(Ht);fr=i(Fn,"Documentation resources"),Fn.forEach(o),Vo.forEach(o),xo=p(t),ut=a(t,"UL",{});var jn=n(ut);Bt=a(jn,"LI",{});var qn=n(Bt);gt=a(qn,"A",{href:!0});var An=n(gt);ur=i(An,"Automatic speech recognition task guide"),An.forEach(o),qn.forEach(o),jn.forEach(o),ko=p(t),_t=a(t,"P",{});var Dn=n(_t);gr=i(Dn,"Tips:"),Dn.forEach(o),Eo=p(t),Tt=a(t,"UL",{});var In=n(Tt);Gt=a(In,"LI",{});var Ln=n(Gt);_r=i(Ln,"The PyTorch version of this model is only available in torch 1.9 and higher."),Ln.forEach(o),In.forEach(o),Po=p(t),Q=a(t,"H2",{class:!0});var Wo=n(Q);de=a(Wo,"A",{id:!0,class:!0,href:!0});var Sn=n(de);Jt=a(Sn,"SPAN",{});var Nn=n(Jt);b(Ie.$$.fragment,Nn),Nn.forEach(o),Sn.forEach(o),Tr=p(Wo),Kt=a(Wo,"SPAN",{});var On=n(Kt);Cr=i(On,"MCTCTConfig"),On.forEach(o),Wo.forEach(o),zo=p(t),I=a(t,"DIV",{class:!0});var xe=n(I);b(Le.$$.fragment,xe),vr=p(xe),Y=a(xe,"P",{});var qt=n(Y);br=i(qt,"This is the configuration class to store the configuration of a "),Ct=a(qt,"A",{href:!0});var Vn=n(Ct);wr=i(Vn,"MCTCTModel"),Vn.forEach(o),$r=i(qt,`. It is used to instantiate an
M-CTC-T model according to the specified arguments, defining the model architecture. Instantiating a configuration
with the defaults will yield a similar configuration to that of the M-CTC-T
`),Se=a(qt,"A",{href:!0,rel:!0});var Wn=n(Se);Mr=i(Wn,"speechbrain/m-ctc-t-large"),Wn.forEach(o),yr=i(qt," architecture."),qt.forEach(o),xr=p(xe),X=a(xe,"P",{});var At=n(X);kr=i(At,"Configuration objects inherit from "),vt=a(At,"A",{href:!0});var Un=n(vt);Er=i(Un,"PretrainedConfig"),Un.forEach(o),Pr=i(At,` and can be used to control the model outputs. Read the
documentation from `),bt=a(At,"A",{href:!0});var Rn=n(bt);zr=i(Rn,"PretrainedConfig"),Rn.forEach(o),Fr=i(At," for more information."),At.forEach(o),jr=p(xe),b(me.$$.fragment,xe),xe.forEach(o),Fo=p(t),Z=a(t,"H2",{class:!0});var Uo=n(Z);pe=a(Uo,"A",{id:!0,class:!0,href:!0});var Hn=n(pe);Qt=a(Hn,"SPAN",{});var Bn=n(Qt);b(Ne.$$.fragment,Bn),Bn.forEach(o),Hn.forEach(o),qr=p(Uo),Yt=a(Uo,"SPAN",{});var Gn=n(Yt);Ar=i(Gn,"MCTCTFeatureExtractor"),Gn.forEach(o),Uo.forEach(o),jo=p(t),L=a(t,"DIV",{class:!0});var ke=n(L);b(Oe.$$.fragment,ke),Dr=p(ke),Xt=a(ke,"P",{});var Jn=n(Xt);Ir=i(Jn,"Constructs a M-CTC-T feature extractor."),Jn.forEach(o),Lr=p(ke),ee=a(ke,"P",{});var Dt=n(ee);Sr=i(Dt,"This feature extractor inherits from "),wt=a(Dt,"A",{href:!0});var Kn=n(wt);Nr=i(Kn,"SequenceFeatureExtractor"),Kn.forEach(o),Or=i(Dt,` which contains
most of the main methods. Users should refer to this superclass for more information regarding those methods. This
code has been adapted from Flashlight\u2019s C++ code. For more information about the implementation, one can refer to
this `),Ve=a(Dt,"A",{href:!0,rel:!0});var Qn=n(Ve);Vr=i(Qn,"notebook"),Qn.forEach(o),Wr=i(Dt,`
that takes the user step-by-step in the implementation.`),Dt.forEach(o),Ur=p(ke),he=a(ke,"DIV",{class:!0});var Ro=n(he);b(We.$$.fragment,Ro),Rr=p(Ro),Zt=a(Ro,"P",{});var Yn=n(Zt);Hr=i(Yn,`Main method to featurize and prepare for the model one or several sequence(s). sequences. It returns the
log-mel spectrogram of the input audio, as implemented in the original Flashlight MFSC feature extraction code.`),Yn.forEach(o),Ro.forEach(o),ke.forEach(o),qo=p(t),te=a(t,"H2",{class:!0});var Ho=n(te);fe=a(Ho,"A",{id:!0,class:!0,href:!0});var Xn=n(fe);eo=a(Xn,"SPAN",{});var Zn=n(eo);b(Ue.$$.fragment,Zn),Zn.forEach(o),Xn.forEach(o),Br=p(Ho),to=a(Ho,"SPAN",{});var es=n(to);Gr=i(es,"MCTCTProcessor"),es.forEach(o),Ho.forEach(o),Ao=p(t),x=a(t,"DIV",{class:!0});var q=n(x);b(Re.$$.fragment,q),Jr=p(q),oo=a(q,"P",{});var ts=n(oo);Kr=i(ts,"Constructs a MCTCT processor which wraps a MCTCT feature extractor and a MCTCT tokenizer into a single processor."),ts.forEach(o),Qr=p(q),D=a(q,"P",{});var R=n(D);$t=a(R,"A",{href:!0});var os=n($t);Yr=i(os,"MCTCTProcessor"),os.forEach(o),Xr=i(R," offers all the functionalities of "),Mt=a(R,"A",{href:!0});var rs=n(Mt);Zr=i(rs,"MCTCTFeatureExtractor"),rs.forEach(o),ea=i(R," and "),yt=a(R,"A",{href:!0});var as=n(yt);ta=i(as,"AutoTokenizer"),as.forEach(o),oa=i(R,`. See the
`),He=a(R,"A",{href:!0});var _n=n(He);ro=a(_n,"STRONG",{});var ns=n(ro);ra=i(ns,"call"),ns.forEach(o),aa=i(_n,"()"),_n.forEach(o),na=i(R," and "),xt=a(R,"A",{href:!0});var ss=n(xt);sa=i(ss,"decode()"),ss.forEach(o),ia=i(R," for more information."),R.forEach(o),la=p(q),ue=a(q,"DIV",{class:!0});var Bo=n(ue);b(Be.$$.fragment,Bo),ca=p(Bo),V=a(Bo,"P",{});var Ee=n(V);da=i(Ee,`When used in normal mode, this method forwards all its arguments to MCTCTFeatureExtractor\u2019s
`),Ge=a(Ee,"A",{href:!0});var Tn=n(Ge);ao=a(Tn,"STRONG",{});var is=n(ao);ma=i(is,"call"),is.forEach(o),pa=i(Tn,"()"),Tn.forEach(o),ha=i(Ee,` and returns its output. If used in the context
`),no=a(Ee,"CODE",{});var ls=n(no);fa=i(ls,"as_target_processor()"),ls.forEach(o),ua=i(Ee,` this method forwards all its arguments to AutoTokenizer\u2019s
`),so=a(Ee,"CODE",{});var cs=n(so);ga=i(cs,"__call__()"),cs.forEach(o),_a=i(Ee,". Please refer to the doctsring of the above two methods for more information."),Ee.forEach(o),Bo.forEach(o),Ta=p(q),G=a(q,"DIV",{class:!0});var It=n(G);b(Je.$$.fragment,It),Ca=p(It),io=a(It,"P",{});var ds=n(io);va=i(ds,"Instantiate a processor associated with a pretrained model."),ds.forEach(o),ba=p(It),b(ge.$$.fragment,It),It.forEach(o),wa=p(q),J=a(q,"DIV",{class:!0});var Lt=n(J);b(Ke.$$.fragment,Lt),$a=p(Lt),Qe=a(Lt,"P",{});var Go=n(Qe);Ma=i(Go,`Saves the attributes of this processor (feature extractor, tokenizer\u2026) in the specified directory so that it
can be reloaded using the `),kt=a(Go,"A",{href:!0});var ms=n(kt);ya=i(ms,"from_pretrained()"),ms.forEach(o),xa=i(Go," method."),Go.forEach(o),ka=p(Lt),b(_e.$$.fragment,Lt),Lt.forEach(o),Ea=p(q),Te=a(q,"DIV",{class:!0});var Jo=n(Te);b(Ye.$$.fragment,Jo),Pa=p(Jo),Xe=a(Jo,"P",{});var Ko=n(Xe);za=i(Ko,"This method forwards all its arguments to AutoTokenizer\u2019s "),Et=a(Ko,"A",{href:!0});var ps=n(Et);Fa=i(ps,"batch_decode()"),ps.forEach(o),ja=i(Ko,`. Please refer
to the docstring of this method for more information.`),Ko.forEach(o),Jo.forEach(o),qa=p(q),Ce=a(q,"DIV",{class:!0});var Qo=n(Ce);b(Ze.$$.fragment,Qo),Aa=p(Qo),et=a(Qo,"P",{});var Yo=n(et);Da=i(Yo,"This method forwards all its arguments to AutoTokenizer\u2019s "),Pt=a(Yo,"A",{href:!0});var hs=n(Pt);Ia=i(hs,"decode()"),hs.forEach(o),La=i(Yo,`. Please refer to the
docstring of this method for more information.`),Yo.forEach(o),Qo.forEach(o),q.forEach(o),Do=p(t),oe=a(t,"H2",{class:!0});var Xo=n(oe);ve=a(Xo,"A",{id:!0,class:!0,href:!0});var fs=n(ve);lo=a(fs,"SPAN",{});var us=n(lo);b(tt.$$.fragment,us),us.forEach(o),fs.forEach(o),Sa=p(Xo),co=a(Xo,"SPAN",{});var gs=n(co);Na=i(gs,"MCTCTModel"),gs.forEach(o),Xo.forEach(o),Io=p(t),W=a(t,"DIV",{class:!0});var St=n(W);b(ot.$$.fragment,St),Oa=p(St),rt=a(St,"P",{});var Zo=n(rt);Va=i(Zo,`The bare M-CTC-T Model transformer outputting raw hidden-states without any specific head on top.
This model is a PyTorch `),at=a(Zo,"A",{href:!0,rel:!0});var _s=n(at);Wa=i(_s,"torch.nn.Module"),_s.forEach(o),Ua=i(Zo,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Zo.forEach(o),Ra=p(St),N=a(St,"DIV",{class:!0});var Pe=n(N);b(nt.$$.fragment,Pe),Ha=p(Pe),re=a(Pe,"P",{});var Nt=n(re);Ba=i(Nt,"The "),zt=a(Nt,"A",{href:!0});var Ts=n(zt);Ga=i(Ts,"MCTCTModel"),Ts.forEach(o),Ja=i(Nt," forward method, overrides the "),mo=a(Nt,"CODE",{});var Cs=n(mo);Ka=i(Cs,"__call__"),Cs.forEach(o),Qa=i(Nt," special method."),Nt.forEach(o),Ya=p(Pe),b(be.$$.fragment,Pe),Xa=p(Pe),b(we.$$.fragment,Pe),Pe.forEach(o),St.forEach(o),Lo=p(t),ae=a(t,"H2",{class:!0});var er=n(ae);$e=a(er,"A",{id:!0,class:!0,href:!0});var vs=n($e);po=a(vs,"SPAN",{});var bs=n(po);b(st.$$.fragment,bs),bs.forEach(o),vs.forEach(o),Za=p(er),ho=a(er,"SPAN",{});var ws=n(ho);en=i(ws,"MCTCTForCTC"),ws.forEach(o),er.forEach(o),So=p(t),U=a(t,"DIV",{class:!0});var Ot=n(U);b(it.$$.fragment,Ot),tn=p(Ot),ne=a(Ot,"P",{});var Vt=n(ne);on=i(Vt,"MCTCT Model with a "),fo=a(Vt,"CODE",{});var $s=n(fo);rn=i($s,"language modeling"),$s.forEach(o),an=i(Vt,` head on top for Connectionist Temporal Classification (CTC).
This model is a PyTorch `),lt=a(Vt,"A",{href:!0,rel:!0});var Ms=n(lt);nn=i(Ms,"torch.nn.Module"),Ms.forEach(o),sn=i(Vt,` sub-class. Use
it as a regular PyTorch Module and refer to the PyTorch documentation for all matter related to general usage and
behavior.`),Vt.forEach(o),ln=p(Ot),O=a(Ot,"DIV",{class:!0});var ze=n(O);b(ct.$$.fragment,ze),cn=p(ze),se=a(ze,"P",{});var Wt=n(se);dn=i(Wt,"The "),Ft=a(Wt,"A",{href:!0});var ys=n(Ft);mn=i(ys,"MCTCTForCTC"),ys.forEach(o),pn=i(Wt," forward method, overrides the "),uo=a(Wt,"CODE",{});var xs=n(uo);hn=i(xs,"__call__"),xs.forEach(o),fn=i(Wt," special method."),Wt.forEach(o),un=p(ze),b(Me.$$.fragment,ze),gn=p(ze),b(ye.$$.fragment,ze),ze.forEach(o),Ot.forEach(o),this.h()},h(){c(d,"name","hf:doc:metadata"),c(d,"content",JSON.stringify(Os)),c(g,"id","mctct"),c(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(g,"href","#mctct"),c(f,"class","relative group"),c(P,"id","overview"),c(P,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(P,"href","#overview"),c(F,"class","relative group"),c(je,"href","https://arxiv.org/abs/2111.00161"),c(je,"rel","nofollow"),c(qe,"href","https://huggingface.co/cwkeam"),c(qe,"rel","nofollow"),c(Ae,"href","https://github.com/flashlight/wav2letter/tree/main/recipes/mling_pl"),c(Ae,"rel","nofollow"),c(ce,"id","documentation-resources"),c(ce,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ce,"href","#documentation-resources"),c(K,"class","relative group"),c(gt,"href","../tasks/asr"),c(de,"id","transformers.MCTCTConfig"),c(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(de,"href","#transformers.MCTCTConfig"),c(Q,"class","relative group"),c(Ct,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTModel"),c(Se,"href","https://huggingface.co/speechbrain/m-ctc-t-large"),c(Se,"rel","nofollow"),c(vt,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),c(bt,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),c(I,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(pe,"id","transformers.MCTCTFeatureExtractor"),c(pe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(pe,"href","#transformers.MCTCTFeatureExtractor"),c(Z,"class","relative group"),c(wt,"href","/docs/transformers/pr_22182/en/main_classes/feature_extractor#transformers.SequenceFeatureExtractor"),c(Ve,"href","https://colab.research.google.com/drive/1GLtINkkhzms-IsdcGy_-tVCkv0qNF-Gt#scrollTo=pMCRGMmUC_an"),c(Ve,"rel","nofollow"),c(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(fe,"id","transformers.MCTCTProcessor"),c(fe,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(fe,"href","#transformers.MCTCTProcessor"),c(te,"class","relative group"),c($t,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTProcessor"),c(Mt,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTFeatureExtractor"),c(yt,"href","/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoTokenizer"),c(He,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTProcessor.__call__"),c(xt,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTProcessor.decode"),c(Ge,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTFeatureExtractor.__call__"),c(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(kt,"href","/docs/transformers/pr_22182/en/main_classes/processors#transformers.ProcessorMixin.from_pretrained"),c(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Et,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.batch_decode"),c(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(Pt,"href","/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.decode"),c(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(ve,"id","transformers.MCTCTModel"),c(ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(ve,"href","#transformers.MCTCTModel"),c(oe,"class","relative group"),c(at,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(at,"rel","nofollow"),c(zt,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTModel"),c(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c($e,"id","transformers.MCTCTForCTC"),c($e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c($e,"href","#transformers.MCTCTForCTC"),c(ae,"class","relative group"),c(lt,"href","https://pytorch.org/docs/stable/nn.html#torch.nn.Module"),c(lt,"rel","nofollow"),c(Ft,"href","/docs/transformers/pr_22182/en/model_doc/mctct#transformers.MCTCTForCTC"),c(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),c(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,h){e(document.head,d),u(t,C,h),u(t,f,h),e(f,g),e(g,T),w(l,T,null),e(f,_),e(f,k),e(k,A),u(t,E,h),u(t,F,h),e(F,P),e(P,j),w(H,j,null),e(F,pt),e(F,ie),e(ie,or),u(t,bo,h),u(t,le,h),e(le,rr),e(le,je),e(je,ar),e(le,nr),u(t,wo,h),u(t,ht,h),e(ht,sr),u(t,$o,h),u(t,ft,h),e(ft,Ut),e(Ut,ir),u(t,Mo,h),u(t,B,h),e(B,lr),e(B,qe),e(qe,cr),e(B,dr),e(B,Ae),e(Ae,mr),e(B,pr),u(t,yo,h),u(t,K,h),e(K,ce),e(ce,Rt),w(De,Rt,null),e(K,hr),e(K,Ht),e(Ht,fr),u(t,xo,h),u(t,ut,h),e(ut,Bt),e(Bt,gt),e(gt,ur),u(t,ko,h),u(t,_t,h),e(_t,gr),u(t,Eo,h),u(t,Tt,h),e(Tt,Gt),e(Gt,_r),u(t,Po,h),u(t,Q,h),e(Q,de),e(de,Jt),w(Ie,Jt,null),e(Q,Tr),e(Q,Kt),e(Kt,Cr),u(t,zo,h),u(t,I,h),w(Le,I,null),e(I,vr),e(I,Y),e(Y,br),e(Y,Ct),e(Ct,wr),e(Y,$r),e(Y,Se),e(Se,Mr),e(Y,yr),e(I,xr),e(I,X),e(X,kr),e(X,vt),e(vt,Er),e(X,Pr),e(X,bt),e(bt,zr),e(X,Fr),e(I,jr),w(me,I,null),u(t,Fo,h),u(t,Z,h),e(Z,pe),e(pe,Qt),w(Ne,Qt,null),e(Z,qr),e(Z,Yt),e(Yt,Ar),u(t,jo,h),u(t,L,h),w(Oe,L,null),e(L,Dr),e(L,Xt),e(Xt,Ir),e(L,Lr),e(L,ee),e(ee,Sr),e(ee,wt),e(wt,Nr),e(ee,Or),e(ee,Ve),e(Ve,Vr),e(ee,Wr),e(L,Ur),e(L,he),w(We,he,null),e(he,Rr),e(he,Zt),e(Zt,Hr),u(t,qo,h),u(t,te,h),e(te,fe),e(fe,eo),w(Ue,eo,null),e(te,Br),e(te,to),e(to,Gr),u(t,Ao,h),u(t,x,h),w(Re,x,null),e(x,Jr),e(x,oo),e(oo,Kr),e(x,Qr),e(x,D),e(D,$t),e($t,Yr),e(D,Xr),e(D,Mt),e(Mt,Zr),e(D,ea),e(D,yt),e(yt,ta),e(D,oa),e(D,He),e(He,ro),e(ro,ra),e(He,aa),e(D,na),e(D,xt),e(xt,sa),e(D,ia),e(x,la),e(x,ue),w(Be,ue,null),e(ue,ca),e(ue,V),e(V,da),e(V,Ge),e(Ge,ao),e(ao,ma),e(Ge,pa),e(V,ha),e(V,no),e(no,fa),e(V,ua),e(V,so),e(so,ga),e(V,_a),e(x,Ta),e(x,G),w(Je,G,null),e(G,Ca),e(G,io),e(io,va),e(G,ba),w(ge,G,null),e(x,wa),e(x,J),w(Ke,J,null),e(J,$a),e(J,Qe),e(Qe,Ma),e(Qe,kt),e(kt,ya),e(Qe,xa),e(J,ka),w(_e,J,null),e(x,Ea),e(x,Te),w(Ye,Te,null),e(Te,Pa),e(Te,Xe),e(Xe,za),e(Xe,Et),e(Et,Fa),e(Xe,ja),e(x,qa),e(x,Ce),w(Ze,Ce,null),e(Ce,Aa),e(Ce,et),e(et,Da),e(et,Pt),e(Pt,Ia),e(et,La),u(t,Do,h),u(t,oe,h),e(oe,ve),e(ve,lo),w(tt,lo,null),e(oe,Sa),e(oe,co),e(co,Na),u(t,Io,h),u(t,W,h),w(ot,W,null),e(W,Oa),e(W,rt),e(rt,Va),e(rt,at),e(at,Wa),e(rt,Ua),e(W,Ra),e(W,N),w(nt,N,null),e(N,Ha),e(N,re),e(re,Ba),e(re,zt),e(zt,Ga),e(re,Ja),e(re,mo),e(mo,Ka),e(re,Qa),e(N,Ya),w(be,N,null),e(N,Xa),w(we,N,null),u(t,Lo,h),u(t,ae,h),e(ae,$e),e($e,po),w(st,po,null),e(ae,Za),e(ae,ho),e(ho,en),u(t,So,h),u(t,U,h),w(it,U,null),e(U,tn),e(U,ne),e(ne,on),e(ne,fo),e(fo,rn),e(ne,an),e(ne,lt),e(lt,nn),e(ne,sn),e(U,ln),e(U,O),w(ct,O,null),e(O,cn),e(O,se),e(se,dn),e(se,Ft),e(Ft,mn),e(se,pn),e(se,uo),e(uo,hn),e(se,fn),e(O,un),w(Me,O,null),e(O,gn),w(ye,O,null),No=!0},p(t,[h]){const dt={};h&2&&(dt.$$scope={dirty:h,ctx:t}),me.$set(dt);const go={};h&2&&(go.$$scope={dirty:h,ctx:t}),ge.$set(go);const _o={};h&2&&(_o.$$scope={dirty:h,ctx:t}),_e.$set(_o);const To={};h&2&&(To.$$scope={dirty:h,ctx:t}),be.$set(To);const mt={};h&2&&(mt.$$scope={dirty:h,ctx:t}),we.$set(mt);const Co={};h&2&&(Co.$$scope={dirty:h,ctx:t}),Me.$set(Co);const vo={};h&2&&(vo.$$scope={dirty:h,ctx:t}),ye.$set(vo)},i(t){No||($(l.$$.fragment,t),$(H.$$.fragment,t),$(De.$$.fragment,t),$(Ie.$$.fragment,t),$(Le.$$.fragment,t),$(me.$$.fragment,t),$(Ne.$$.fragment,t),$(Oe.$$.fragment,t),$(We.$$.fragment,t),$(Ue.$$.fragment,t),$(Re.$$.fragment,t),$(Be.$$.fragment,t),$(Je.$$.fragment,t),$(ge.$$.fragment,t),$(Ke.$$.fragment,t),$(_e.$$.fragment,t),$(Ye.$$.fragment,t),$(Ze.$$.fragment,t),$(tt.$$.fragment,t),$(ot.$$.fragment,t),$(nt.$$.fragment,t),$(be.$$.fragment,t),$(we.$$.fragment,t),$(st.$$.fragment,t),$(it.$$.fragment,t),$(ct.$$.fragment,t),$(Me.$$.fragment,t),$(ye.$$.fragment,t),No=!0)},o(t){M(l.$$.fragment,t),M(H.$$.fragment,t),M(De.$$.fragment,t),M(Ie.$$.fragment,t),M(Le.$$.fragment,t),M(me.$$.fragment,t),M(Ne.$$.fragment,t),M(Oe.$$.fragment,t),M(We.$$.fragment,t),M(Ue.$$.fragment,t),M(Re.$$.fragment,t),M(Be.$$.fragment,t),M(Je.$$.fragment,t),M(ge.$$.fragment,t),M(Ke.$$.fragment,t),M(_e.$$.fragment,t),M(Ye.$$.fragment,t),M(Ze.$$.fragment,t),M(tt.$$.fragment,t),M(ot.$$.fragment,t),M(nt.$$.fragment,t),M(be.$$.fragment,t),M(we.$$.fragment,t),M(st.$$.fragment,t),M(it.$$.fragment,t),M(ct.$$.fragment,t),M(Me.$$.fragment,t),M(ye.$$.fragment,t),No=!1},d(t){o(d),t&&o(C),t&&o(f),y(l),t&&o(E),t&&o(F),y(H),t&&o(bo),t&&o(le),t&&o(wo),t&&o(ht),t&&o($o),t&&o(ft),t&&o(Mo),t&&o(B),t&&o(yo),t&&o(K),y(De),t&&o(xo),t&&o(ut),t&&o(ko),t&&o(_t),t&&o(Eo),t&&o(Tt),t&&o(Po),t&&o(Q),y(Ie),t&&o(zo),t&&o(I),y(Le),y(me),t&&o(Fo),t&&o(Z),y(Ne),t&&o(jo),t&&o(L),y(Oe),y(We),t&&o(qo),t&&o(te),y(Ue),t&&o(Ao),t&&o(x),y(Re),y(Be),y(Je),y(ge),y(Ke),y(_e),y(Ye),y(Ze),t&&o(Do),t&&o(oe),y(tt),t&&o(Io),t&&o(W),y(ot),y(nt),y(be),y(we),t&&o(Lo),t&&o(ae),y(st),t&&o(So),t&&o(U),y(it),y(ct),y(Me),y(ye)}}}const Os={local:"mctct",sections:[{local:"overview",title:"Overview"},{local:"documentation-resources",title:"Documentation resources"},{local:"transformers.MCTCTConfig",title:"MCTCTConfig"},{local:"transformers.MCTCTFeatureExtractor",title:"MCTCTFeatureExtractor"},{local:"transformers.MCTCTProcessor",title:"MCTCTProcessor"},{local:"transformers.MCTCTModel",title:"MCTCTModel"},{local:"transformers.MCTCTForCTC",title:"MCTCTForCTC"}],title:"M-CTC-T"};function Vs(z){return Fs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Js extends ks{constructor(d){super();Es(this,d,Vs,Ns,Ps,{})}}export{Js as default,Os as metadata};
