import{S as co,i as uo,s as _o,e as o,k,w as T,t as a,M as go,c as n,d as s,m as $,a as r,x as A,h as l,b as d,G as e,g as h,y as M,q,o as z,B as P,v as ko,L as Ga}from"../../chunks/vendor-hf-doc-builder.js";import{T as Xa}from"../../chunks/Tip-hf-doc-builder.js";import{Y as fo}from"../../chunks/Youtube-hf-doc-builder.js";import{I as va}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{C as V}from"../../chunks/CodeBlock-hf-doc-builder.js";import{D as $o}from"../../chunks/DocNotebookDropdown-hf-doc-builder.js";import{F as dl,M as ha}from"../../chunks/Markdown-hf-doc-builder.js";function yo(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N,u,E,Y,ce,Z,K,oe,De,te,Ae,ue,we,ge,ve,J,Me,ae,fe,pe,ke,xe,qe,ne,re,se,me,he,$e,c,R,de,ye,g,I,je,be,Ee,ee,Ce,ze,Se,Te,Pe,Ge,We,He,Oe,Be,Ye,rs,et,tt,Ot,Re,is,Tt,ht,ps,At,ft,ms,Nt,Ie,Ve,Mt,Ne,hs,qt,ct,St,st,at,Qe,fs,Ke,cs,us,lt,ot,Wt,_e,ds,zt,ut,_s,Pt,dt,gs,Rt,_t,ks,nt,Je,$s,ys,rt,it,Ht,Le,bs,Lt,gt,ws,Ft,kt,js,Yt,Ue,vs;return{c(){p=a(`You can finetune other architectures for masked language modeling following the same steps in this guide.
Choose one of the following architectures:

`),i=o("p"),m=o("a"),y=a("ALBERT"),w=a(", "),v=o("a"),x=a("BART"),F=a(", "),b=o("a"),j=a("BERT"),L=a(", "),D=o("a"),S=a("BigBird"),W=a(", "),B=o("a"),ie=a("CamemBERT"),Q=a(", "),C=o("a"),le=a("ConvBERT"),U=a(", "),X=o("a"),O=a("Data2VecText"),H=a(", "),N=o("a"),u=a("DeBERTa"),E=a(", "),Y=o("a"),ce=a("DeBERTa-v2"),Z=a(", "),K=o("a"),oe=a("DistilBERT"),De=a(", "),te=o("a"),Ae=a("ELECTRA"),ue=a(", "),we=o("a"),ge=a("ERNIE"),ve=a(", "),J=o("a"),Me=a("ESM"),ae=a(", "),fe=o("a"),pe=a("FlauBERT"),ke=a(", "),xe=o("a"),qe=a("FNet"),ne=a(", "),re=o("a"),se=a("Funnel Transformer"),me=a(", "),he=o("a"),$e=a("I-BERT"),c=a(", "),R=o("a"),de=a("LayoutLM"),ye=a(", "),g=o("a"),I=a("Longformer"),je=a(", "),be=o("a"),Ee=a("LUKE"),ee=a(", "),Ce=o("a"),ze=a("mBART"),Se=a(", "),Te=o("a"),Pe=a("MEGA"),Ge=a(", "),We=o("a"),He=a("Megatron-BERT"),Oe=a(", "),Be=o("a"),Ye=a("MobileBERT"),rs=a(", "),et=o("a"),tt=a("MPNet"),Ot=a(", "),Re=o("a"),is=a("MVP"),Tt=a(", "),ht=o("a"),ps=a("Nezha"),At=a(", "),ft=o("a"),ms=a("Nystr\xF6mformer"),Nt=a(", "),Ie=o("a"),Ve=a("Perceiver"),Mt=a(", "),Ne=o("a"),hs=a("QDQBert"),qt=a(", "),ct=o("a"),St=a("Reformer"),st=a(", "),at=o("a"),Qe=a("RemBERT"),fs=a(", "),Ke=o("a"),cs=a("RoBERTa"),us=a(", "),lt=o("a"),ot=a("RoBERTa-PreLayerNorm"),Wt=a(", "),_e=o("a"),ds=a("RoCBert"),zt=a(", "),ut=o("a"),_s=a("RoFormer"),Pt=a(", "),dt=o("a"),gs=a("SqueezeBERT"),Rt=a(", "),_t=o("a"),ks=a("TAPAS"),nt=a(", "),Je=o("a"),$s=a("Wav2Vec2"),ys=a(", "),rt=o("a"),it=a("XLM"),Ht=a(", "),Le=o("a"),bs=a("XLM-RoBERTa"),Lt=a(", "),gt=o("a"),ws=a("XLM-RoBERTa-XL"),Ft=a(", "),kt=o("a"),js=a("X-MOD"),Yt=a(", "),Ue=o("a"),vs=a("YOSO"),this.h()},l(Xe){p=l(Xe,`You can finetune other architectures for masked language modeling following the same steps in this guide.
Choose one of the following architectures:

`),i=n(Xe,"P",{});var _=r(i);m=n(_,"A",{href:!0});var xs=r(m);y=l(xs,"ALBERT"),xs.forEach(s),w=l(_,", "),v=n(_,"A",{href:!0});var Fe=r(v);x=l(Fe,"BART"),Fe.forEach(s),F=l(_,", "),b=n(_,"A",{href:!0});var Is=r(b);j=l(Is,"BERT"),Is.forEach(s),L=l(_,", "),D=n(_,"A",{href:!0});var $t=r(D);S=l($t,"BigBird"),$t.forEach(s),W=l(_,", "),B=n(_,"A",{href:!0});var Os=r(B);ie=l(Os,"CamemBERT"),Os.forEach(s),Q=l(_,", "),C=n(_,"A",{href:!0});var Ns=r(C);le=l(Ns,"ConvBERT"),Ns.forEach(s),U=l(_,", "),X=n(_,"A",{href:!0});var Ut=r(X);O=l(Ut,"Data2VecText"),Ut.forEach(s),H=l(_,", "),N=n(_,"A",{href:!0});var Ss=r(N);u=l(Ss,"DeBERTa"),Ss.forEach(s),E=l(_,", "),Y=n(_,"A",{href:!0});var Ws=r(Y);ce=l(Ws,"DeBERTa-v2"),Ws.forEach(s),Z=l(_,", "),K=n(_,"A",{href:!0});var Xt=r(K);oe=l(Xt,"DistilBERT"),Xt.forEach(s),De=l(_,", "),te=n(_,"A",{href:!0});var Hs=r(te);Ae=l(Hs,"ELECTRA"),Hs.forEach(s),ue=l(_,", "),we=n(_,"A",{href:!0});var Ys=r(we);ge=l(Ys,"ERNIE"),Ys.forEach(s),ve=l(_,", "),J=n(_,"A",{href:!0});var Gt=r(J);Me=l(Gt,"ESM"),Gt.forEach(s),ae=l(_,", "),fe=n(_,"A",{href:!0});var Us=r(fe);pe=l(Us,"FlauBERT"),Us.forEach(s),ke=l(_,", "),xe=n(_,"A",{href:!0});var Xs=r(xe);qe=l(Xs,"FNet"),Xs.forEach(s),ne=l(_,", "),re=n(_,"A",{href:!0});var Es=r(re);se=l(Es,"Funnel Transformer"),Es.forEach(s),me=l(_,", "),he=n(_,"A",{href:!0});var yt=r(he);$e=l(yt,"I-BERT"),yt.forEach(s),c=l(_,", "),R=n(_,"A",{href:!0});var Ts=r(R);de=l(Ts,"LayoutLM"),Ts.forEach(s),ye=l(_,", "),g=n(_,"A",{href:!0});var Dt=r(g);I=l(Dt,"Longformer"),Dt.forEach(s),je=l(_,", "),be=n(_,"A",{href:!0});var Gs=r(be);Ee=l(Gs,"LUKE"),Gs.forEach(s),ee=l(_,", "),Ce=n(_,"A",{href:!0});var As=r(Ce);ze=l(As,"mBART"),As.forEach(s),Se=l(_,", "),Te=n(_,"A",{href:!0});var Ct=r(Te);Pe=l(Ct,"MEGA"),Ct.forEach(s),Ge=l(_,", "),We=n(_,"A",{href:!0});var Vs=r(We);He=l(Vs,"Megatron-BERT"),Vs.forEach(s),Oe=l(_,", "),Be=n(_,"A",{href:!0});var Ms=r(Be);Ye=l(Ms,"MobileBERT"),Ms.forEach(s),rs=l(_,", "),et=n(_,"A",{href:!0});var pt=r(et);tt=l(pt,"MPNet"),pt.forEach(s),Ot=l(_,", "),Re=n(_,"A",{href:!0});var Vt=r(Re);is=l(Vt,"MVP"),Vt.forEach(s),Tt=l(_,", "),ht=n(_,"A",{href:!0});var Qs=r(ht);ps=l(Qs,"Nezha"),Qs.forEach(s),At=l(_,", "),ft=n(_,"A",{href:!0});var Ks=r(ft);ms=l(Ks,"Nystr\xF6mformer"),Ks.forEach(s),Nt=l(_,", "),Ie=n(_,"A",{href:!0});var bt=r(Ie);Ve=l(bt,"Perceiver"),bt.forEach(s),Mt=l(_,", "),Ne=n(_,"A",{href:!0});var Js=r(Ne);hs=l(Js,"QDQBert"),Js.forEach(s),qt=l(_,", "),ct=n(_,"A",{href:!0});var Qt=r(ct);St=l(Qt,"Reformer"),Qt.forEach(s),st=l(_,", "),at=n(_,"A",{href:!0});var Zs=r(at);Qe=l(Zs,"RemBERT"),Zs.forEach(s),fs=l(_,", "),Ke=n(_,"A",{href:!0});var ea=r(Ke);cs=l(ea,"RoBERTa"),ea.forEach(s),us=l(_,", "),lt=n(_,"A",{href:!0});var qs=r(lt);ot=l(qs,"RoBERTa-PreLayerNorm"),qs.forEach(s),Wt=l(_,", "),_e=n(_,"A",{href:!0});var wt=r(_e);ds=l(wt,"RoCBert"),wt.forEach(s),zt=l(_,", "),ut=n(_,"A",{href:!0});var zs=r(ut);_s=l(zs,"RoFormer"),zs.forEach(s),Pt=l(_,", "),dt=n(_,"A",{href:!0});var mt=r(dt);gs=l(mt,"SqueezeBERT"),mt.forEach(s),Rt=l(_,", "),_t=n(_,"A",{href:!0});var ta=r(_t);ks=l(ta,"TAPAS"),ta.forEach(s),nt=l(_,", "),Je=n(_,"A",{href:!0});var Kt=r(Je);$s=l(Kt,"Wav2Vec2"),Kt.forEach(s),ys=l(_,", "),rt=n(_,"A",{href:!0});var sa=r(rt);it=l(sa,"XLM"),sa.forEach(s),Ht=l(_,", "),Le=n(_,"A",{href:!0});var aa=r(Le);bs=l(aa,"XLM-RoBERTa"),aa.forEach(s),Lt=l(_,", "),gt=n(_,"A",{href:!0});var Ps=r(gt);ws=l(Ps,"XLM-RoBERTa-XL"),Ps.forEach(s),Ft=l(_,", "),kt=n(_,"A",{href:!0});var jt=r(kt);js=l(jt,"X-MOD"),jt.forEach(s),Yt=l(_,", "),Ue=n(_,"A",{href:!0});var Rs=r(Ue);vs=l(Rs,"YOSO"),Rs.forEach(s),_.forEach(s),this.h()},h(){d(m,"href","../model_doc/albert"),d(v,"href","../model_doc/bart"),d(b,"href","../model_doc/bert"),d(D,"href","../model_doc/big_bird"),d(B,"href","../model_doc/camembert"),d(C,"href","../model_doc/convbert"),d(X,"href","../model_doc/data2vec-text"),d(N,"href","../model_doc/deberta"),d(Y,"href","../model_doc/deberta-v2"),d(K,"href","../model_doc/distilbert"),d(te,"href","../model_doc/electra"),d(we,"href","../model_doc/ernie"),d(J,"href","../model_doc/esm"),d(fe,"href","../model_doc/flaubert"),d(xe,"href","../model_doc/fnet"),d(re,"href","../model_doc/funnel"),d(he,"href","../model_doc/ibert"),d(R,"href","../model_doc/layoutlm"),d(g,"href","../model_doc/longformer"),d(be,"href","../model_doc/luke"),d(Ce,"href","../model_doc/mbart"),d(Te,"href","../model_doc/mega"),d(We,"href","../model_doc/megatron-bert"),d(Be,"href","../model_doc/mobilebert"),d(et,"href","../model_doc/mpnet"),d(Re,"href","../model_doc/mvp"),d(ht,"href","../model_doc/nezha"),d(ft,"href","../model_doc/nystromformer"),d(Ie,"href","../model_doc/perceiver"),d(Ne,"href","../model_doc/qdqbert"),d(ct,"href","../model_doc/reformer"),d(at,"href","../model_doc/rembert"),d(Ke,"href","../model_doc/roberta"),d(lt,"href","../model_doc/roberta-prelayernorm"),d(_e,"href","../model_doc/roc_bert"),d(ut,"href","../model_doc/roformer"),d(dt,"href","../model_doc/squeezebert"),d(_t,"href","../model_doc/tapas"),d(Je,"href","../model_doc/wav2vec2"),d(rt,"href","../model_doc/xlm"),d(Le,"href","../model_doc/xlm-roberta"),d(gt,"href","../model_doc/xlm-roberta-xl"),d(kt,"href","../model_doc/xmod"),d(Ue,"href","../model_doc/yoso")},m(Xe,_){h(Xe,p,_),h(Xe,i,_),e(i,m),e(m,y),e(i,w),e(i,v),e(v,x),e(i,F),e(i,b),e(b,j),e(i,L),e(i,D),e(D,S),e(i,W),e(i,B),e(B,ie),e(i,Q),e(i,C),e(C,le),e(i,U),e(i,X),e(X,O),e(i,H),e(i,N),e(N,u),e(i,E),e(i,Y),e(Y,ce),e(i,Z),e(i,K),e(K,oe),e(i,De),e(i,te),e(te,Ae),e(i,ue),e(i,we),e(we,ge),e(i,ve),e(i,J),e(J,Me),e(i,ae),e(i,fe),e(fe,pe),e(i,ke),e(i,xe),e(xe,qe),e(i,ne),e(i,re),e(re,se),e(i,me),e(i,he),e(he,$e),e(i,c),e(i,R),e(R,de),e(i,ye),e(i,g),e(g,I),e(i,je),e(i,be),e(be,Ee),e(i,ee),e(i,Ce),e(Ce,ze),e(i,Se),e(i,Te),e(Te,Pe),e(i,Ge),e(i,We),e(We,He),e(i,Oe),e(i,Be),e(Be,Ye),e(i,rs),e(i,et),e(et,tt),e(i,Ot),e(i,Re),e(Re,is),e(i,Tt),e(i,ht),e(ht,ps),e(i,At),e(i,ft),e(ft,ms),e(i,Nt),e(i,Ie),e(Ie,Ve),e(i,Mt),e(i,Ne),e(Ne,hs),e(i,qt),e(i,ct),e(ct,St),e(i,st),e(i,at),e(at,Qe),e(i,fs),e(i,Ke),e(Ke,cs),e(i,us),e(i,lt),e(lt,ot),e(i,Wt),e(i,_e),e(_e,ds),e(i,zt),e(i,ut),e(ut,_s),e(i,Pt),e(i,dt),e(dt,gs),e(i,Rt),e(i,_t),e(_t,ks),e(i,nt),e(i,Je),e(Je,$s),e(i,ys),e(i,rt),e(rt,it),e(i,Ht),e(i,Le),e(Le,bs),e(i,Lt),e(i,gt),e(gt,ws),e(i,Ft),e(i,kt),e(kt,js),e(i,Yt),e(i,Ue),e(Ue,vs)},d(Xe){Xe&&s(p),Xe&&s(i)}}}function bo(G){let p,i,m,y,w,v,x,F;return x=new V({props:{code:`from transformers import DataCollatorForLanguageModeling

tokenizer.pad_token = tokenizer.eos_token
data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=0.15)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DataCollatorForLanguageModeling

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer.pad_token = tokenizer.eos_token
<span class="hljs-meta">&gt;&gt;&gt; </span>data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=<span class="hljs-number">0.15</span>)`}}),{c(){p=o("p"),i=a("Use the end-of-sequence token as the padding token and specify "),m=o("code"),y=a("mlm_probability"),w=a(" to randomly mask tokens each time you iterate over the data:"),v=k(),T(x.$$.fragment)},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"Use the end-of-sequence token as the padding token and specify "),m=n(j,"CODE",{});var L=r(m);y=l(L,"mlm_probability"),L.forEach(s),w=l(j," to randomly mask tokens each time you iterate over the data:"),j.forEach(s),v=$(b),A(x.$$.fragment,b)},m(b,j){h(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),h(b,v,j),M(x,b,j),F=!0},p:Ga,i(b){F||(q(x.$$.fragment,b),F=!0)},o(b){z(x.$$.fragment,b),F=!1},d(b){b&&s(p),b&&s(v),P(x,b)}}}function wo(G){let p,i;return p=new ha({props:{$$slots:{default:[bo]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function jo(G){let p,i,m,y,w,v,x,F;return x=new V({props:{code:`from transformers import DataCollatorForLanguageModeling

data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=0.15, return_tensors="tf")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> DataCollatorForLanguageModeling

<span class="hljs-meta">&gt;&gt;&gt; </span>data_collator = DataCollatorForLanguageModeling(tokenizer=tokenizer, mlm_probability=<span class="hljs-number">0.15</span>, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)`}}),{c(){p=o("p"),i=a("Use the end-of-sequence token as the padding token and specify "),m=o("code"),y=a("mlm_probability"),w=a(" to randomly mask tokens each time you iterate over the data:"),v=k(),T(x.$$.fragment)},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"Use the end-of-sequence token as the padding token and specify "),m=n(j,"CODE",{});var L=r(m);y=l(L,"mlm_probability"),L.forEach(s),w=l(j," to randomly mask tokens each time you iterate over the data:"),j.forEach(s),v=$(b),A(x.$$.fragment,b)},m(b,j){h(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),h(b,v,j),M(x,b,j),F=!0},p:Ga,i(b){F||(q(x.$$.fragment,b),F=!0)},o(b){z(x.$$.fragment,b),F=!1},d(b){b&&s(p),b&&s(v),P(x,b)}}}function vo(G){let p,i;return p=new ha({props:{$$slots:{default:[jo]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function xo(G){let p,i,m,y,w,v,x,F;return{c(){p=o("p"),i=a("If you aren\u2019t familiar with finetuning a model with the "),m=o("a"),y=a("Trainer"),w=a(", take a look at the basic tutorial "),v=o("a"),x=a("here"),F=a("!"),this.h()},l(b){p=n(b,"P",{});var j=r(p);i=l(j,"If you aren\u2019t familiar with finetuning a model with the "),m=n(j,"A",{href:!0});var L=r(m);y=l(L,"Trainer"),L.forEach(s),w=l(j,", take a look at the basic tutorial "),v=n(j,"A",{href:!0});var D=r(v);x=l(D,"here"),D.forEach(s),F=l(j,"!"),j.forEach(s),this.h()},h(){d(m,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.Trainer"),d(v,"href","../training#train-with-pytorch-trainer")},m(b,j){h(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,F)},d(b){b&&s(p)}}}function Eo(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N,u,E,Y,ce,Z,K,oe,De,te,Ae,ue,we,ge,ve,J,Me,ae,fe,pe,ke,xe,qe,ne,re,se,me,he,$e,c,R,de,ye;return p=new Xa({props:{$$slots:{default:[xo]},$$scope:{ctx:G}}}),b=new V({props:{code:`from transformers import AutoModelForMaskedLM

model = AutoModelForMaskedLM.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),J=new V({props:{code:`training_args = TrainingArguments(
    output_dir="my_awesome_eli5_mlm_model",
    evaluation_strategy="epoch",
    learning_rate=2e-5,
    num_train_epochs=3,
    weight_decay=0.01,
    push_to_hub=True,
)

trainer = Trainer(
    model=model,
    args=training_args,
    train_dataset=lm_dataset["train"],
    eval_dataset=lm_dataset["test"],
    data_collator=data_collator,
)

trainer.train()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>training_args = TrainingArguments(
<span class="hljs-meta">... </span>    output_dir=<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>,
<span class="hljs-meta">... </span>    evaluation_strategy=<span class="hljs-string">&quot;epoch&quot;</span>,
<span class="hljs-meta">... </span>    learning_rate=<span class="hljs-number">2e-5</span>,
<span class="hljs-meta">... </span>    num_train_epochs=<span class="hljs-number">3</span>,
<span class="hljs-meta">... </span>    weight_decay=<span class="hljs-number">0.01</span>,
<span class="hljs-meta">... </span>    push_to_hub=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>trainer = Trainer(
<span class="hljs-meta">... </span>    model=model,
<span class="hljs-meta">... </span>    args=training_args,
<span class="hljs-meta">... </span>    train_dataset=lm_dataset[<span class="hljs-string">&quot;train&quot;</span>],
<span class="hljs-meta">... </span>    eval_dataset=lm_dataset[<span class="hljs-string">&quot;test&quot;</span>],
<span class="hljs-meta">... </span>    data_collator=data_collator,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>trainer.train()`}}),ne=new V({props:{code:`import math

eval_results = trainer.evaluate()
print(f"Perplexity: {math.exp(eval_results['eval_loss']):.2f}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> math

<span class="hljs-meta">&gt;&gt;&gt; </span>eval_results = trainer.evaluate()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Perplexity: <span class="hljs-subst">{math.exp(eval_results[<span class="hljs-string">&#x27;eval_loss&#x27;</span>]):<span class="hljs-number">.2</span>f}</span>&quot;</span>)
Perplexity: <span class="hljs-number">8.76</span>`}}),de=new V({props:{code:"trainer.push_to_hub()",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>trainer.push_to_hub()'}}),{c(){T(p.$$.fragment),i=k(),m=o("p"),y=a("You\u2019re ready to start training your model now! Load DistilRoBERTa with "),w=o("a"),v=a("AutoModelForMaskedLM"),x=a(":"),F=k(),T(b.$$.fragment),j=k(),L=o("p"),D=a("At this point, only three steps remain:"),S=k(),W=o("ol"),B=o("li"),ie=a("Define your training hyperparameters in "),Q=o("a"),C=a("TrainingArguments"),le=a(". The only required parameter is "),U=o("code"),X=a("output_dir"),O=a(" which specifies where to save your model. You\u2019ll push this model to the Hub by setting "),H=o("code"),N=a("push_to_hub=True"),u=a(" (you need to be signed in to Hugging Face to upload your model)."),E=k(),Y=o("li"),ce=a("Pass the training arguments to "),Z=o("a"),K=a("Trainer"),oe=a(" along with the model, datasets, and data collator."),De=k(),te=o("li"),Ae=a("Call "),ue=o("a"),we=a("train()"),ge=a(" to finetune your model."),ve=k(),T(J.$$.fragment),Me=k(),ae=o("p"),fe=a("Once training is completed, use the "),pe=o("a"),ke=a("evaluate()"),xe=a(" method to evaluate your model and get its perplexity:"),qe=k(),T(ne.$$.fragment),re=k(),se=o("p"),me=a("Then share your model to the Hub with the "),he=o("a"),$e=a("push_to_hub()"),c=a(" method so everyone can use your model:"),R=k(),T(de.$$.fragment),this.h()},l(g){A(p.$$.fragment,g),i=$(g),m=n(g,"P",{});var I=r(m);y=l(I,"You\u2019re ready to start training your model now! Load DistilRoBERTa with "),w=n(I,"A",{href:!0});var je=r(w);v=l(je,"AutoModelForMaskedLM"),je.forEach(s),x=l(I,":"),I.forEach(s),F=$(g),A(b.$$.fragment,g),j=$(g),L=n(g,"P",{});var be=r(L);D=l(be,"At this point, only three steps remain:"),be.forEach(s),S=$(g),W=n(g,"OL",{});var Ee=r(W);B=n(Ee,"LI",{});var ee=r(B);ie=l(ee,"Define your training hyperparameters in "),Q=n(ee,"A",{href:!0});var Ce=r(Q);C=l(Ce,"TrainingArguments"),Ce.forEach(s),le=l(ee,". The only required parameter is "),U=n(ee,"CODE",{});var ze=r(U);X=l(ze,"output_dir"),ze.forEach(s),O=l(ee," which specifies where to save your model. You\u2019ll push this model to the Hub by setting "),H=n(ee,"CODE",{});var Se=r(H);N=l(Se,"push_to_hub=True"),Se.forEach(s),u=l(ee," (you need to be signed in to Hugging Face to upload your model)."),ee.forEach(s),E=$(Ee),Y=n(Ee,"LI",{});var Te=r(Y);ce=l(Te,"Pass the training arguments to "),Z=n(Te,"A",{href:!0});var Pe=r(Z);K=l(Pe,"Trainer"),Pe.forEach(s),oe=l(Te," along with the model, datasets, and data collator."),Te.forEach(s),De=$(Ee),te=n(Ee,"LI",{});var Ge=r(te);Ae=l(Ge,"Call "),ue=n(Ge,"A",{href:!0});var We=r(ue);we=l(We,"train()"),We.forEach(s),ge=l(Ge," to finetune your model."),Ge.forEach(s),Ee.forEach(s),ve=$(g),A(J.$$.fragment,g),Me=$(g),ae=n(g,"P",{});var He=r(ae);fe=l(He,"Once training is completed, use the "),pe=n(He,"A",{href:!0});var Oe=r(pe);ke=l(Oe,"evaluate()"),Oe.forEach(s),xe=l(He," method to evaluate your model and get its perplexity:"),He.forEach(s),qe=$(g),A(ne.$$.fragment,g),re=$(g),se=n(g,"P",{});var Be=r(se);me=l(Be,"Then share your model to the Hub with the "),he=n(Be,"A",{href:!0});var Ye=r(he);$e=l(Ye,"push_to_hub()"),Ye.forEach(s),c=l(Be," method so everyone can use your model:"),Be.forEach(s),R=$(g),A(de.$$.fragment,g),this.h()},h(){d(w,"href","/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoModelForMaskedLM"),d(Q,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.TrainingArguments"),d(Z,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.Trainer"),d(ue,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.Trainer.train"),d(pe,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.Trainer.evaluate"),d(he,"href","/docs/transformers/pr_22182/en/main_classes/trainer#transformers.Trainer.push_to_hub")},m(g,I){M(p,g,I),h(g,i,I),h(g,m,I),e(m,y),e(m,w),e(w,v),e(m,x),h(g,F,I),M(b,g,I),h(g,j,I),h(g,L,I),e(L,D),h(g,S,I),h(g,W,I),e(W,B),e(B,ie),e(B,Q),e(Q,C),e(B,le),e(B,U),e(U,X),e(B,O),e(B,H),e(H,N),e(B,u),e(W,E),e(W,Y),e(Y,ce),e(Y,Z),e(Z,K),e(Y,oe),e(W,De),e(W,te),e(te,Ae),e(te,ue),e(ue,we),e(te,ge),h(g,ve,I),M(J,g,I),h(g,Me,I),h(g,ae,I),e(ae,fe),e(ae,pe),e(pe,ke),e(ae,xe),h(g,qe,I),M(ne,g,I),h(g,re,I),h(g,se,I),e(se,me),e(se,he),e(he,$e),e(se,c),h(g,R,I),M(de,g,I),ye=!0},p(g,I){const je={};I&2&&(je.$$scope={dirty:I,ctx:g}),p.$set(je)},i(g){ye||(q(p.$$.fragment,g),q(b.$$.fragment,g),q(J.$$.fragment,g),q(ne.$$.fragment,g),q(de.$$.fragment,g),ye=!0)},o(g){z(p.$$.fragment,g),z(b.$$.fragment,g),z(J.$$.fragment,g),z(ne.$$.fragment,g),z(de.$$.fragment,g),ye=!1},d(g){P(p,g),g&&s(i),g&&s(m),g&&s(F),P(b,g),g&&s(j),g&&s(L),g&&s(S),g&&s(W),g&&s(ve),P(J,g),g&&s(Me),g&&s(ae),g&&s(qe),P(ne,g),g&&s(re),g&&s(se),g&&s(R),P(de,g)}}}function To(G){let p,i;return p=new ha({props:{$$slots:{default:[Eo]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function Ao(G){let p,i,m,y,w;return{c(){p=o("p"),i=a("If you aren\u2019t familiar with finetuning a model with Keras, take a look at the basic tutorial "),m=o("a"),y=a("here"),w=a("!"),this.h()},l(v){p=n(v,"P",{});var x=r(p);i=l(x,"If you aren\u2019t familiar with finetuning a model with Keras, take a look at the basic tutorial "),m=n(x,"A",{href:!0});var F=r(m);y=l(F,"here"),F.forEach(s),w=l(x,"!"),x.forEach(s),this.h()},h(){d(m,"href","../training#train-a-tensorflow-model-with-keras")},m(v,x){h(v,p,x),e(p,i),e(p,m),e(m,y),e(p,w)},d(v){v&&s(p)}}}function Mo(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N,u,E,Y,ce,Z,K,oe,De,te,Ae,ue,we,ge,ve,J,Me,ae,fe,pe,ke,xe,qe,ne,re,se,me,he,$e;return p=new Xa({props:{$$slots:{default:[Ao]},$$scope:{ctx:G}}}),m=new V({props:{code:`from transformers import create_optimizer, AdamWeightDecay

optimizer = AdamWeightDecay(learning_rate=2e-5, weight_decay_rate=0.01)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> create_optimizer, AdamWeightDecay

<span class="hljs-meta">&gt;&gt;&gt; </span>optimizer = AdamWeightDecay(learning_rate=<span class="hljs-number">2e-5</span>, weight_decay_rate=<span class="hljs-number">0.01</span>)`}}),L=new V({props:{code:`from transformers import TFAutoModelForMaskedLM

model = TFAutoModelForMaskedLM.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),O=new V({props:{code:`tf_train_set = model.prepare_tf_dataset(
    lm_dataset["train"],
    shuffle=True,
    batch_size=16,
    collate_fn=data_collator,
)

tf_test_set = model.prepare_tf_dataset(
    lm_dataset["test"],
    shuffle=False,
    batch_size=16,
    collate_fn=data_collator,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>tf_train_set = model.prepare_tf_dataset(
<span class="hljs-meta">... </span>    lm_dataset[<span class="hljs-string">&quot;train&quot;</span>],
<span class="hljs-meta">... </span>    shuffle=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    batch_size=<span class="hljs-number">16</span>,
<span class="hljs-meta">... </span>    collate_fn=data_collator,
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span>tf_test_set = model.prepare_tf_dataset(
<span class="hljs-meta">... </span>    lm_dataset[<span class="hljs-string">&quot;test&quot;</span>],
<span class="hljs-meta">... </span>    shuffle=<span class="hljs-literal">False</span>,
<span class="hljs-meta">... </span>    batch_size=<span class="hljs-number">16</span>,
<span class="hljs-meta">... </span>    collate_fn=data_collator,
<span class="hljs-meta">... </span>)`}}),oe=new V({props:{code:`import tensorflow as tf

model.compile(optimizer=optimizer)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> tensorflow <span class="hljs-keyword">as</span> tf

<span class="hljs-meta">&gt;&gt;&gt; </span>model.<span class="hljs-built_in">compile</span>(optimizer=optimizer)`}}),J=new V({props:{code:`from transformers.keras_callbacks import PushToHubCallback

callback = PushToHubCallback(
    output_dir="my_awesome_eli5_mlm_model",
    tokenizer=tokenizer,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers.keras_callbacks <span class="hljs-keyword">import</span> PushToHubCallback

<span class="hljs-meta">&gt;&gt;&gt; </span>callback = PushToHubCallback(
<span class="hljs-meta">... </span>    output_dir=<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>,
<span class="hljs-meta">... </span>    tokenizer=tokenizer,
<span class="hljs-meta">... </span>)`}}),re=new V({props:{code:"model.fit(x=tf_train_set, validation_data=tf_test_set, epochs=3, callbacks=[callback])",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>model.fit(x=tf_train_set, validation_data=tf_test_set, epochs=<span class="hljs-number">3</span>, callbacks=[callback])'}}),{c(){T(p.$$.fragment),i=a(`
To finetune a model in TensorFlow, start by setting up an optimizer function, learning rate schedule, and some training hyperparameters:

	`),T(m.$$.fragment),y=k(),w=o("p"),v=a("Then you can load DistilRoBERTa with "),x=o("a"),F=a("TFAutoModelForMaskedLM"),b=a(":"),j=k(),T(L.$$.fragment),D=k(),S=o("p"),W=a("Convert your datasets to the "),B=o("code"),ie=a("tf.data.Dataset"),Q=a(" format with "),C=o("a"),le=a("prepare_tf_dataset()"),U=a(":"),X=k(),T(O.$$.fragment),H=k(),N=o("p"),u=a("Configure the model for training with "),E=o("a"),Y=o("code"),ce=a("compile"),Z=a(":"),K=k(),T(oe.$$.fragment),De=k(),te=o("p"),Ae=a("This can be done by specifying where to push your model and tokenizer in the "),ue=o("a"),we=a("PushToHubCallback"),ge=a(":"),ve=k(),T(J.$$.fragment),Me=k(),ae=o("p"),fe=a("Finally, you\u2019re ready to start training your model! Call "),pe=o("a"),ke=o("code"),xe=a("fit"),qe=a(" with your training and validation datasets, the number of epochs, and your callback to finetune the model:"),ne=k(),T(re.$$.fragment),se=k(),me=o("p"),he=a("Once training is completed, your model is automatically uploaded to the Hub so everyone can use it!"),this.h()},l(c){A(p.$$.fragment,c),i=l(c,`
To finetune a model in TensorFlow, start by setting up an optimizer function, learning rate schedule, and some training hyperparameters:

	`),A(m.$$.fragment,c),y=$(c),w=n(c,"P",{});var R=r(w);v=l(R,"Then you can load DistilRoBERTa with "),x=n(R,"A",{href:!0});var de=r(x);F=l(de,"TFAutoModelForMaskedLM"),de.forEach(s),b=l(R,":"),R.forEach(s),j=$(c),A(L.$$.fragment,c),D=$(c),S=n(c,"P",{});var ye=r(S);W=l(ye,"Convert your datasets to the "),B=n(ye,"CODE",{});var g=r(B);ie=l(g,"tf.data.Dataset"),g.forEach(s),Q=l(ye," format with "),C=n(ye,"A",{href:!0});var I=r(C);le=l(I,"prepare_tf_dataset()"),I.forEach(s),U=l(ye,":"),ye.forEach(s),X=$(c),A(O.$$.fragment,c),H=$(c),N=n(c,"P",{});var je=r(N);u=l(je,"Configure the model for training with "),E=n(je,"A",{href:!0,rel:!0});var be=r(E);Y=n(be,"CODE",{});var Ee=r(Y);ce=l(Ee,"compile"),Ee.forEach(s),be.forEach(s),Z=l(je,":"),je.forEach(s),K=$(c),A(oe.$$.fragment,c),De=$(c),te=n(c,"P",{});var ee=r(te);Ae=l(ee,"This can be done by specifying where to push your model and tokenizer in the "),ue=n(ee,"A",{href:!0});var Ce=r(ue);we=l(Ce,"PushToHubCallback"),Ce.forEach(s),ge=l(ee,":"),ee.forEach(s),ve=$(c),A(J.$$.fragment,c),Me=$(c),ae=n(c,"P",{});var ze=r(ae);fe=l(ze,"Finally, you\u2019re ready to start training your model! Call "),pe=n(ze,"A",{href:!0,rel:!0});var Se=r(pe);ke=n(Se,"CODE",{});var Te=r(ke);xe=l(Te,"fit"),Te.forEach(s),Se.forEach(s),qe=l(ze," with your training and validation datasets, the number of epochs, and your callback to finetune the model:"),ze.forEach(s),ne=$(c),A(re.$$.fragment,c),se=$(c),me=n(c,"P",{});var Pe=r(me);he=l(Pe,"Once training is completed, your model is automatically uploaded to the Hub so everyone can use it!"),Pe.forEach(s),this.h()},h(){d(x,"href","/docs/transformers/pr_22182/en/model_doc/auto#transformers.TFAutoModelForMaskedLM"),d(C,"href","/docs/transformers/pr_22182/en/main_classes/model#transformers.TFPreTrainedModel.prepare_tf_dataset"),d(E,"href","https://keras.io/api/models/model_training_apis/#compile-method"),d(E,"rel","nofollow"),d(ue,"href","/docs/transformers/pr_22182/en/main_classes/keras_callbacks#transformers.PushToHubCallback"),d(pe,"href","https://keras.io/api/models/model_training_apis/#fit-method"),d(pe,"rel","nofollow")},m(c,R){M(p,c,R),h(c,i,R),M(m,c,R),h(c,y,R),h(c,w,R),e(w,v),e(w,x),e(x,F),e(w,b),h(c,j,R),M(L,c,R),h(c,D,R),h(c,S,R),e(S,W),e(S,B),e(B,ie),e(S,Q),e(S,C),e(C,le),e(S,U),h(c,X,R),M(O,c,R),h(c,H,R),h(c,N,R),e(N,u),e(N,E),e(E,Y),e(Y,ce),e(N,Z),h(c,K,R),M(oe,c,R),h(c,De,R),h(c,te,R),e(te,Ae),e(te,ue),e(ue,we),e(te,ge),h(c,ve,R),M(J,c,R),h(c,Me,R),h(c,ae,R),e(ae,fe),e(ae,pe),e(pe,ke),e(ke,xe),e(ae,qe),h(c,ne,R),M(re,c,R),h(c,se,R),h(c,me,R),e(me,he),$e=!0},p(c,R){const de={};R&2&&(de.$$scope={dirty:R,ctx:c}),p.$set(de)},i(c){$e||(q(p.$$.fragment,c),q(m.$$.fragment,c),q(L.$$.fragment,c),q(O.$$.fragment,c),q(oe.$$.fragment,c),q(J.$$.fragment,c),q(re.$$.fragment,c),$e=!0)},o(c){z(p.$$.fragment,c),z(m.$$.fragment,c),z(L.$$.fragment,c),z(O.$$.fragment,c),z(oe.$$.fragment,c),z(J.$$.fragment,c),z(re.$$.fragment,c),$e=!1},d(c){P(p,c),c&&s(i),P(m,c),c&&s(y),c&&s(w),c&&s(j),P(L,c),c&&s(D),c&&s(S),c&&s(X),P(O,c),c&&s(H),c&&s(N),c&&s(K),P(oe,c),c&&s(De),c&&s(te),c&&s(ve),P(J,c),c&&s(Me),c&&s(ae),c&&s(ne),P(re,c),c&&s(se),c&&s(me)}}}function qo(G){let p,i;return p=new ha({props:{$$slots:{default:[Mo]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function zo(G){let p,i,m,y,w,v,x,F;return{c(){p=o("p"),i=a(`For a more in-depth example of how to finetune a model for masked language modeling, take a look at the corresponding
`),m=o("a"),y=a("PyTorch notebook"),w=a(`
or `),v=o("a"),x=a("TensorFlow notebook"),F=a("."),this.h()},l(b){p=n(b,"P",{});var j=r(p);i=l(j,`For a more in-depth example of how to finetune a model for masked language modeling, take a look at the corresponding
`),m=n(j,"A",{href:!0,rel:!0});var L=r(m);y=l(L,"PyTorch notebook"),L.forEach(s),w=l(j,`
or `),v=n(j,"A",{href:!0,rel:!0});var D=r(v);x=l(D,"TensorFlow notebook"),D.forEach(s),F=l(j,"."),j.forEach(s),this.h()},h(){d(m,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling.ipynb"),d(m,"rel","nofollow"),d(v,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/examples/language_modeling-tf.ipynb"),d(v,"rel","nofollow")},m(b,j){h(b,p,j),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,F)},d(b){b&&s(p)}}}function Po(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N;return j=new V({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("my_awesome_eli5_mlm_model")
inputs = tokenizer(text, return_tensors="pt")
mask_token_index = torch.where(inputs["input_ids"] == tokenizer.mask_token_id)[1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;pt&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = torch.where(inputs[<span class="hljs-string">&quot;input_ids&quot;</span>] == tokenizer.mask_token_id)[<span class="hljs-number">1</span>]`}}),C=new V({props:{code:`from transformers import AutoModelForMaskedLM

model = AutoModelForMaskedLM.from_pretrained("stevhliu/my_awesome_eli5_mlm_model")
logits = model(**inputs).logits
mask_token_logits = logits[0, mask_token_index, :]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = AutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_logits = logits[<span class="hljs-number">0</span>, mask_token_index, :]`}}),H=new V({props:{code:`top_3_tokens = torch.topk(mask_token_logits, 3, dim=1).indices[0].tolist()

for token in top_3_tokens:
    print(text.replace(tokenizer.mask_token, tokenizer.decode([token])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>top_3_tokens = torch.topk(mask_token_logits, <span class="hljs-number">3</span>, dim=<span class="hljs-number">1</span>).indices[<span class="hljs-number">0</span>].tolist()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> token <span class="hljs-keyword">in</span> top_3_tokens:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(text.replace(tokenizer.mask_token, tokenizer.decode([token])))
The Milky Way <span class="hljs-keyword">is</span> a spiral galaxy.
The Milky Way <span class="hljs-keyword">is</span> a massive galaxy.
The Milky Way <span class="hljs-keyword">is</span> a small galaxy.`}}),{c(){p=o("p"),i=a("Tokenize the text and return the "),m=o("code"),y=a("input_ids"),w=a(" as PyTorch tensors. You\u2019ll also need to specify the position of the "),v=o("code"),x=a("<mask>"),F=a(" token:"),b=k(),T(j.$$.fragment),L=k(),D=o("p"),S=a("Pass your inputs to the model and return the "),W=o("code"),B=a("logits"),ie=a(" of the masked token:"),Q=k(),T(C.$$.fragment),le=k(),U=o("p"),X=a("Then return the three masked tokens with the highest probability and print them out:"),O=k(),T(H.$$.fragment)},l(u){p=n(u,"P",{});var E=r(p);i=l(E,"Tokenize the text and return the "),m=n(E,"CODE",{});var Y=r(m);y=l(Y,"input_ids"),Y.forEach(s),w=l(E," as PyTorch tensors. You\u2019ll also need to specify the position of the "),v=n(E,"CODE",{});var ce=r(v);x=l(ce,"<mask>"),ce.forEach(s),F=l(E," token:"),E.forEach(s),b=$(u),A(j.$$.fragment,u),L=$(u),D=n(u,"P",{});var Z=r(D);S=l(Z,"Pass your inputs to the model and return the "),W=n(Z,"CODE",{});var K=r(W);B=l(K,"logits"),K.forEach(s),ie=l(Z," of the masked token:"),Z.forEach(s),Q=$(u),A(C.$$.fragment,u),le=$(u),U=n(u,"P",{});var oe=r(U);X=l(oe,"Then return the three masked tokens with the highest probability and print them out:"),oe.forEach(s),O=$(u),A(H.$$.fragment,u)},m(u,E){h(u,p,E),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,F),h(u,b,E),M(j,u,E),h(u,L,E),h(u,D,E),e(D,S),e(D,W),e(W,B),e(D,ie),h(u,Q,E),M(C,u,E),h(u,le,E),h(u,U,E),e(U,X),h(u,O,E),M(H,u,E),N=!0},p:Ga,i(u){N||(q(j.$$.fragment,u),q(C.$$.fragment,u),q(H.$$.fragment,u),N=!0)},o(u){z(j.$$.fragment,u),z(C.$$.fragment,u),z(H.$$.fragment,u),N=!1},d(u){u&&s(p),u&&s(b),P(j,u),u&&s(L),u&&s(D),u&&s(Q),P(C,u),u&&s(le),u&&s(U),u&&s(O),P(H,u)}}}function Ro(G){let p,i;return p=new ha({props:{$$slots:{default:[Po]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function Lo(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N;return j=new V({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("my_awesome_eli5_mlm_model")
inputs = tokenizer(text, return_tensors="tf")
mask_token_index = tf.where(inputs["input_ids"] == tokenizer.mask_token_id)[0, 1]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>inputs = tokenizer(text, return_tensors=<span class="hljs-string">&quot;tf&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_index = tf.where(inputs[<span class="hljs-string">&quot;input_ids&quot;</span>] == tokenizer.mask_token_id)[<span class="hljs-number">0</span>, <span class="hljs-number">1</span>]`}}),C=new V({props:{code:`from transformers import TFAutoModelForMaskedLM

model = TFAutoModelForMaskedLM.from_pretrained("stevhliu/my_awesome_eli5_mlm_model")
logits = model(**inputs).logits
mask_token_logits = logits[0, mask_token_index, :]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> TFAutoModelForMaskedLM

<span class="hljs-meta">&gt;&gt;&gt; </span>model = TFAutoModelForMaskedLM.from_pretrained(<span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>logits = model(**inputs).logits
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_token_logits = logits[<span class="hljs-number">0</span>, mask_token_index, :]`}}),H=new V({props:{code:`top_3_tokens = tf.math.top_k(mask_token_logits, 3).indices.numpy()

for token in top_3_tokens:
    print(text.replace(tokenizer.mask_token, tokenizer.decode([token])))`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>top_3_tokens = tf.math.top_k(mask_token_logits, <span class="hljs-number">3</span>).indices.numpy()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">for</span> token <span class="hljs-keyword">in</span> top_3_tokens:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(text.replace(tokenizer.mask_token, tokenizer.decode([token])))
The Milky Way <span class="hljs-keyword">is</span> a spiral galaxy.
The Milky Way <span class="hljs-keyword">is</span> a massive galaxy.
The Milky Way <span class="hljs-keyword">is</span> a small galaxy.`}}),{c(){p=o("p"),i=a("Tokenize the text and return the "),m=o("code"),y=a("input_ids"),w=a(" as TensorFlow tensors. You\u2019ll also need to specify the position of the "),v=o("code"),x=a("<mask>"),F=a(" token:"),b=k(),T(j.$$.fragment),L=k(),D=o("p"),S=a("Pass your inputs to the model and return the "),W=o("code"),B=a("logits"),ie=a(" of the masked token:"),Q=k(),T(C.$$.fragment),le=k(),U=o("p"),X=a("Then return the three masked tokens with the highest probability and print them out:"),O=k(),T(H.$$.fragment)},l(u){p=n(u,"P",{});var E=r(p);i=l(E,"Tokenize the text and return the "),m=n(E,"CODE",{});var Y=r(m);y=l(Y,"input_ids"),Y.forEach(s),w=l(E," as TensorFlow tensors. You\u2019ll also need to specify the position of the "),v=n(E,"CODE",{});var ce=r(v);x=l(ce,"<mask>"),ce.forEach(s),F=l(E," token:"),E.forEach(s),b=$(u),A(j.$$.fragment,u),L=$(u),D=n(u,"P",{});var Z=r(D);S=l(Z,"Pass your inputs to the model and return the "),W=n(Z,"CODE",{});var K=r(W);B=l(K,"logits"),K.forEach(s),ie=l(Z," of the masked token:"),Z.forEach(s),Q=$(u),A(C.$$.fragment,u),le=$(u),U=n(u,"P",{});var oe=r(U);X=l(oe,"Then return the three masked tokens with the highest probability and print them out:"),oe.forEach(s),O=$(u),A(H.$$.fragment,u)},m(u,E){h(u,p,E),e(p,i),e(p,m),e(m,y),e(p,w),e(p,v),e(v,x),e(p,F),h(u,b,E),M(j,u,E),h(u,L,E),h(u,D,E),e(D,S),e(D,W),e(W,B),e(D,ie),h(u,Q,E),M(C,u,E),h(u,le,E),h(u,U,E),e(U,X),h(u,O,E),M(H,u,E),N=!0},p:Ga,i(u){N||(q(j.$$.fragment,u),q(C.$$.fragment,u),q(H.$$.fragment,u),N=!0)},o(u){z(j.$$.fragment,u),z(C.$$.fragment,u),z(H.$$.fragment,u),N=!1},d(u){u&&s(p),u&&s(b),P(j,u),u&&s(L),u&&s(D),u&&s(Q),P(C,u),u&&s(le),u&&s(U),u&&s(O),P(H,u)}}}function Fo(G){let p,i;return p=new ha({props:{$$slots:{default:[Lo]},$$scope:{ctx:G}}}),{c(){T(p.$$.fragment)},l(m){A(p.$$.fragment,m)},m(m,y){M(p,m,y),i=!0},p(m,y){const w={};y&2&&(w.$$scope={dirty:y,ctx:m}),p.$set(w)},i(m){i||(q(p.$$.fragment,m),i=!0)},o(m){z(p.$$.fragment,m),i=!1},d(m){P(p,m)}}}function Do(G){let p,i,m,y,w,v,x,F,b,j,L,D,S,W,B,ie,Q,C,le,U,X,O,H,N,u,E,Y,ce,Z,K,oe,De,te,Ae,ue,we,ge,ve,J,Me,ae,fe,pe,ke,xe,qe,ne,re,se,me,he,$e,c,R,de,ye,g,I,je,be,Ee,ee,Ce,ze,Se,Te,Pe,Ge,We,He,Oe,Be,Ye,rs,et,tt,Ot,Re,is,Tt,ht,ps,At,ft,ms,Nt,Ie,Ve,Mt,Ne,hs,qt,ct,St,st,at,Qe,fs,Ke,cs,us,lt,ot,Wt,_e,ds,zt,ut,_s,Pt,dt,gs,Rt,_t,ks,nt,Je,$s,ys,rt,it,Ht,Le,bs,Lt,gt,ws,Ft,kt,js,Yt,Ue,vs,Xe,_,xs,Fe,Is,$t,Os,Ns,Ut,Ss,Ws,Xt,Hs,Ys,Gt,Us,Xs,Es,yt,Ts,Dt,Gs,As,Ct,Vs,Ms,pt,Vt,Qs,Ks,bt,Js,Qt,Zs,ea,qs,wt,zs,mt,ta,Kt,sa,aa,Ps,jt,Rs,vt,Va,la,Qa,Ka,fa,Ja,Za,xa,Jt,Ea,Bt,Zt,ca,Ls,el,ua,tl,Ta,es,Aa,ts,Ma,It,ss,da,Fs,sl,_a,al,qa,oa,ll,za,as,ol,ga,nl,rl,Pa,Ds,Ra,Ze,il,na,pl,ml,ka,hl,fl,$a,cl,ul,La,Cs,Fa,ls,Da;return v=new va({}),L=new $o({props:{classNames:"absolute z-10 right-0 top-0",options:[{label:"Mixed",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/masked_language_modeling.ipynb"},{label:"PyTorch",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/pytorch/masked_language_modeling.ipynb"},{label:"TensorFlow",value:"https://colab.research.google.com/github/huggingface/notebooks/blob/main/transformers_doc/en/tensorflow/masked_language_modeling.ipynb"},{label:"Mixed",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/masked_language_modeling.ipynb"},{label:"PyTorch",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/pytorch/masked_language_modeling.ipynb"},{label:"TensorFlow",value:"https://studiolab.sagemaker.aws/import/github/huggingface/notebooks/blob/main/transformers_doc/en/tensorflow/masked_language_modeling.ipynb"}]}}),S=new fo({props:{id:"mqElG5QJWUg"}}),ge=new Xa({props:{$$slots:{default:[yo]},$$scope:{ctx:G}}}),fe=new V({props:{code:"pip install transformers datasets evaluate",highlighted:"pip install transformers datasets evaluate"}}),ne=new V({props:{code:`from huggingface_hub import notebook_login

notebook_login()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> huggingface_hub <span class="hljs-keyword">import</span> notebook_login

<span class="hljs-meta">&gt;&gt;&gt; </span>notebook_login()`}}),$e=new va({}),be=new V({props:{code:`from datasets import load_dataset

eli5 = load_dataset("eli5", split="train_asks[:5000]")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> load_dataset

<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = load_dataset(<span class="hljs-string">&quot;eli5&quot;</span>, split=<span class="hljs-string">&quot;train_asks[:5000]&quot;</span>)`}}),Oe=new V({props:{code:"eli5 = eli5.train_test_split(test_size=0.2)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = eli5.train_test_split(test_size=<span class="hljs-number">0.2</span>)'}}),tt=new V({props:{code:'eli5["train"][0]',highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>eli5[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;answers&#x27;</span>: {<span class="hljs-string">&#x27;a_id&#x27;</span>: [<span class="hljs-string">&#x27;c3d1aib&#x27;</span>, <span class="hljs-string">&#x27;c3d4lya&#x27;</span>],
  <span class="hljs-string">&#x27;score&#x27;</span>: [<span class="hljs-number">6</span>, <span class="hljs-number">3</span>],
  <span class="hljs-string">&#x27;text&#x27;</span>: [<span class="hljs-string">&quot;The velocity needed to remain in orbit is equal to the square root of Newton&#x27;s constant times the mass of earth divided by the distance from the center of the earth. I don&#x27;t know the altitude of that specific mission, but they&#x27;re usually around 300 km. That means he&#x27;s going 7-8 km/s.\\n\\nIn space there are no other forces acting on either the shuttle or the guy, so they stay in the same position relative to each other. If he were to become unable to return to the ship, he would presumably run out of oxygen, or slowly fall into the atmosphere and burn up.&quot;</span>,
   <span class="hljs-string">&quot;Hope you don&#x27;t mind me asking another question, but why aren&#x27;t there any stars visible in this photo?&quot;</span>]},
 <span class="hljs-string">&#x27;answers_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: []},
 <span class="hljs-string">&#x27;document&#x27;</span>: <span class="hljs-string">&#x27;&#x27;</span>,
 <span class="hljs-string">&#x27;q_id&#x27;</span>: <span class="hljs-string">&#x27;nyxfp&#x27;</span>,
 <span class="hljs-string">&#x27;selftext&#x27;</span>: <span class="hljs-string">&#x27;_URL_0_\\n\\nThis was on the front page earlier and I have a few questions about it. Is it possible to calculate how fast the astronaut would be orbiting the earth? Also how does he stay close to the shuttle so that he can return safely, i.e is he orbiting at the same speed and can therefore stay next to it? And finally if his propulsion system failed, would he eventually re-enter the atmosphere and presumably die?&#x27;</span>,
 <span class="hljs-string">&#x27;selftext_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: [<span class="hljs-string">&#x27;http://apod.nasa.gov/apod/image/1201/freeflyer_nasa_3000.jpg&#x27;</span>]},
 <span class="hljs-string">&#x27;subreddit&#x27;</span>: <span class="hljs-string">&#x27;askscience&#x27;</span>,
 <span class="hljs-string">&#x27;title&#x27;</span>: <span class="hljs-string">&#x27;Few questions about this space walk photograph.&#x27;</span>,
 <span class="hljs-string">&#x27;title_urls&#x27;</span>: {<span class="hljs-string">&#x27;url&#x27;</span>: []}}`}}),Ne=new va({}),st=new fo({props:{id:"8PmhEIXhBvI"}}),ot=new V({props:{code:`from transformers import AutoTokenizer

tokenizer = AutoTokenizer.from_pretrained("distilroberta-base")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoTokenizer

<span class="hljs-meta">&gt;&gt;&gt; </span>tokenizer = AutoTokenizer.from_pretrained(<span class="hljs-string">&quot;distilroberta-base&quot;</span>)`}}),it=new V({props:{code:`eli5 = eli5.flatten()
eli5["train"][0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>eli5 = eli5.flatten()
<span class="hljs-meta">&gt;&gt;&gt; </span>eli5[<span class="hljs-string">&quot;train&quot;</span>][<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;answers.a_id&#x27;</span>: [<span class="hljs-string">&#x27;c3d1aib&#x27;</span>, <span class="hljs-string">&#x27;c3d4lya&#x27;</span>],
 <span class="hljs-string">&#x27;answers.score&#x27;</span>: [<span class="hljs-number">6</span>, <span class="hljs-number">3</span>],
 <span class="hljs-string">&#x27;answers.text&#x27;</span>: [<span class="hljs-string">&quot;The velocity needed to remain in orbit is equal to the square root of Newton&#x27;s constant times the mass of earth divided by the distance from the center of the earth. I don&#x27;t know the altitude of that specific mission, but they&#x27;re usually around 300 km. That means he&#x27;s going 7-8 km/s.\\n\\nIn space there are no other forces acting on either the shuttle or the guy, so they stay in the same position relative to each other. If he were to become unable to return to the ship, he would presumably run out of oxygen, or slowly fall into the atmosphere and burn up.&quot;</span>,
  <span class="hljs-string">&quot;Hope you don&#x27;t mind me asking another question, but why aren&#x27;t there any stars visible in this photo?&quot;</span>],
 <span class="hljs-string">&#x27;answers_urls.url&#x27;</span>: [],
 <span class="hljs-string">&#x27;document&#x27;</span>: <span class="hljs-string">&#x27;&#x27;</span>,
 <span class="hljs-string">&#x27;q_id&#x27;</span>: <span class="hljs-string">&#x27;nyxfp&#x27;</span>,
 <span class="hljs-string">&#x27;selftext&#x27;</span>: <span class="hljs-string">&#x27;_URL_0_\\n\\nThis was on the front page earlier and I have a few questions about it. Is it possible to calculate how fast the astronaut would be orbiting the earth? Also how does he stay close to the shuttle so that he can return safely, i.e is he orbiting at the same speed and can therefore stay next to it? And finally if his propulsion system failed, would he eventually re-enter the atmosphere and presumably die?&#x27;</span>,
 <span class="hljs-string">&#x27;selftext_urls.url&#x27;</span>: [<span class="hljs-string">&#x27;http://apod.nasa.gov/apod/image/1201/freeflyer_nasa_3000.jpg&#x27;</span>],
 <span class="hljs-string">&#x27;subreddit&#x27;</span>: <span class="hljs-string">&#x27;askscience&#x27;</span>,
 <span class="hljs-string">&#x27;title&#x27;</span>: <span class="hljs-string">&#x27;Few questions about this space walk photograph.&#x27;</span>,
 <span class="hljs-string">&#x27;title_urls.url&#x27;</span>: []}`}}),_=new V({props:{code:`def preprocess_function(examples):
    return tokenizer([" ".join(x) for x in examples["answers.text"]])`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">preprocess_function</span>(<span class="hljs-params">examples</span>):
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> tokenizer([<span class="hljs-string">&quot; &quot;</span>.join(x) <span class="hljs-keyword">for</span> x <span class="hljs-keyword">in</span> examples[<span class="hljs-string">&quot;answers.text&quot;</span>]])`}}),yt=new V({props:{code:`tokenized_eli5 = eli5.map(
    preprocess_function,
    batched=True,
    num_proc=4,
    remove_columns=eli5["train"].column_names,
)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>tokenized_eli5 = eli5.<span class="hljs-built_in">map</span>(
<span class="hljs-meta">... </span>    preprocess_function,
<span class="hljs-meta">... </span>    batched=<span class="hljs-literal">True</span>,
<span class="hljs-meta">... </span>    num_proc=<span class="hljs-number">4</span>,
<span class="hljs-meta">... </span>    remove_columns=eli5[<span class="hljs-string">&quot;train&quot;</span>].column_names,
<span class="hljs-meta">... </span>)`}}),wt=new V({props:{code:`block_size = 128


def group_texts(examples):
    # Concatenate all texts.
    concatenated_examples = {k: sum(examples[k], []) for k in examples.keys()}
    total_length = len(concatenated_examples[list(examples.keys())[0]])
    # We drop the small remainder, we could add padding if the model supported it instead of this drop, you can
    # customize this part to your needs.
    if total_length >= block_size:
        total_length = (total_length // block_size) * block_size
    # Split by chunks of block_size.
    result = {
        k: [t[i : i + block_size] for i in range(0, total_length, block_size)]
        for k, t in concatenated_examples.items()
    }
    result["labels"] = result["input_ids"].copy()
    return result`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span>block_size = <span class="hljs-number">128</span>


<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">group_texts</span>(<span class="hljs-params">examples</span>):
<span class="hljs-meta">... </span>    <span class="hljs-comment"># Concatenate all texts.</span>
<span class="hljs-meta">... </span>    concatenated_examples = {k: <span class="hljs-built_in">sum</span>(examples[k], []) <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> examples.keys()}
<span class="hljs-meta">... </span>    total_length = <span class="hljs-built_in">len</span>(concatenated_examples[<span class="hljs-built_in">list</span>(examples.keys())[<span class="hljs-number">0</span>]])
<span class="hljs-meta">... </span>    <span class="hljs-comment"># We drop the small remainder, we could add padding if the model supported it instead of this drop, you can</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># customize this part to your needs.</span>
<span class="hljs-meta">... </span>    <span class="hljs-keyword">if</span> total_length &gt;= block_size:
<span class="hljs-meta">... </span>        total_length = (total_length // block_size) * block_size
<span class="hljs-meta">... </span>    <span class="hljs-comment"># Split by chunks of block_size.</span>
<span class="hljs-meta">... </span>    result = {
<span class="hljs-meta">... </span>        k: [t[i : i + block_size] <span class="hljs-keyword">for</span> i <span class="hljs-keyword">in</span> <span class="hljs-built_in">range</span>(<span class="hljs-number">0</span>, total_length, block_size)]
<span class="hljs-meta">... </span>        <span class="hljs-keyword">for</span> k, t <span class="hljs-keyword">in</span> concatenated_examples.items()
<span class="hljs-meta">... </span>    }
<span class="hljs-meta">... </span>    result[<span class="hljs-string">&quot;labels&quot;</span>] = result[<span class="hljs-string">&quot;input_ids&quot;</span>].copy()
<span class="hljs-meta">... </span>    <span class="hljs-keyword">return</span> result`}}),jt=new V({props:{code:"lm_dataset = tokenized_eli5.map(group_texts, batched=True, num_proc=4)",highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>lm_dataset = tokenized_eli5.<span class="hljs-built_in">map</span>(group_texts, batched=<span class="hljs-literal">True</span>, num_proc=<span class="hljs-number">4</span>)'}}),Jt=new dl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[vo],pytorch:[wo]},$$scope:{ctx:G}}}),Ls=new va({}),es=new dl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[qo],pytorch:[To]},$$scope:{ctx:G}}}),ts=new Xa({props:{$$slots:{default:[zo]},$$scope:{ctx:G}}}),Fs=new va({}),Ds=new V({props:{code:'text = "The Milky Way is a <mask> galaxy."',highlighted:'<span class="hljs-meta">&gt;&gt;&gt; </span>text = <span class="hljs-string">&quot;The Milky Way is a &lt;mask&gt; galaxy.&quot;</span>'}}),Cs=new V({props:{code:`from transformers import pipeline

mask_filler = pipeline("fill-mask", "stevhliu/my_awesome_eli5_mlm_model")
mask_filler(text, top_k=3)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> pipeline

<span class="hljs-meta">&gt;&gt;&gt; </span>mask_filler = pipeline(<span class="hljs-string">&quot;fill-mask&quot;</span>, <span class="hljs-string">&quot;stevhliu/my_awesome_eli5_mlm_model&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>mask_filler(text, top_k=<span class="hljs-number">3</span>)
[{<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.5150994658470154</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">21300</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; spiral&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a spiral galaxy.&#x27;</span>},
 {<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.07087188959121704</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">2232</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; massive&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a massive galaxy.&#x27;</span>},
 {<span class="hljs-string">&#x27;score&#x27;</span>: <span class="hljs-number">0.06434620916843414</span>,
  <span class="hljs-string">&#x27;token&#x27;</span>: <span class="hljs-number">650</span>,
  <span class="hljs-string">&#x27;token_str&#x27;</span>: <span class="hljs-string">&#x27; small&#x27;</span>,
  <span class="hljs-string">&#x27;sequence&#x27;</span>: <span class="hljs-string">&#x27;The Milky Way is a small galaxy.&#x27;</span>}]`}}),ls=new dl({props:{pytorch:!0,tensorflow:!0,jax:!1,$$slots:{tensorflow:[Fo],pytorch:[Ro]},$$scope:{ctx:G}}}),{c(){p=o("meta"),i=k(),m=o("h1"),y=o("a"),w=o("span"),T(v.$$.fragment),x=k(),F=o("span"),b=a("Masked language modeling"),j=k(),T(L.$$.fragment),D=k(),T(S.$$.fragment),W=k(),B=o("p"),ie=a(`Masked language modeling predicts a masked token in a sequence, and the model can attend to tokens bidirectionally. This
means the model has full access to the tokens on the left and right. Masked language modeling is great for tasks that
require a good contextual understanding of an entire sequence. BERT is an example of a masked language model.`),Q=k(),C=o("p"),le=a("This guide will show you how to:"),U=k(),X=o("ol"),O=o("li"),H=a("Finetune "),N=o("a"),u=a("DistilRoBERTa"),E=a(" on the "),Y=o("a"),ce=a("r/askscience"),Z=a(" subset of the "),K=o("a"),oe=a("ELI5"),De=a(" dataset."),te=k(),Ae=o("li"),ue=a("Use your finetuned model for inference."),we=k(),T(ge.$$.fragment),ve=k(),J=o("p"),Me=a("Before you begin, make sure you have all the necessary libraries installed:"),ae=k(),T(fe.$$.fragment),pe=k(),ke=o("p"),xe=a("We encourage you to log in to your Hugging Face account so you can upload and share your model with the community. When prompted, enter your token to log in:"),qe=k(),T(ne.$$.fragment),re=k(),se=o("h2"),me=o("a"),he=o("span"),T($e.$$.fragment),c=k(),R=o("span"),de=a("Load ELI5 dataset"),ye=k(),g=o("p"),I=a(`Start by loading a smaller subset of the r/askscience subset of the ELI5 dataset from the \u{1F917} Datasets library. This\u2019ll
give you a chance to experiment and make sure everything works before spending more time training on the full dataset.`),je=k(),T(be.$$.fragment),Ee=k(),ee=o("p"),Ce=a("Split the dataset\u2019s "),ze=o("code"),Se=a("train_asks"),Te=a(" split into a train and test set with the "),Pe=o("a"),Ge=a("train_test_split"),We=a(" method:"),He=k(),T(Oe.$$.fragment),Be=k(),Ye=o("p"),rs=a("Then take a look at an example:"),et=k(),T(tt.$$.fragment),Ot=k(),Re=o("p"),is=a("While this may look like a lot, you\u2019re only really interested in the "),Tt=o("code"),ht=a("text"),ps=a(" field. What\u2019s cool about language modeling tasks is you don\u2019t need labels (also known as an unsupervised task) because the next word "),At=o("em"),ft=a("is"),ms=a(" the label."),Nt=k(),Ie=o("h2"),Ve=o("a"),Mt=o("span"),T(Ne.$$.fragment),hs=k(),qt=o("span"),ct=a("Preprocess"),St=k(),T(st.$$.fragment),at=k(),Qe=o("p"),fs=a("For masked language modeling, the next step is to load a DistilRoBERTa tokenizer to process the "),Ke=o("code"),cs=a("text"),us=a(" subfield:"),lt=k(),T(ot.$$.fragment),Wt=k(),_e=o("p"),ds=a("You\u2019ll notice from the example above, the "),zt=o("code"),ut=a("text"),_s=a(" field is actually nested inside "),Pt=o("code"),dt=a("answers"),gs=a(`. This means you\u2019ll need to e
xtract the `),Rt=o("code"),_t=a("text"),ks=a(" subfield from its nested structure with the "),nt=o("a"),Je=o("code"),$s=a("flatten"),ys=a(" method:"),rt=k(),T(it.$$.fragment),Ht=k(),Le=o("p"),bs=a("Each subfield is now a separate column as indicated by the "),Lt=o("code"),gt=a("answers"),ws=a(" prefix, and the "),Ft=o("code"),kt=a("text"),js=a(` field is a list now. Instead
of tokenizing each sentence separately, convert the list to a string so you can jointly tokenize them.`),Yt=k(),Ue=o("p"),vs=a("Here is a first preprocessing function to join the list of strings for each example and tokenize the result:"),Xe=k(),T(_.$$.fragment),xs=k(),Fe=o("p"),Is=a("To apply this preprocessing function over the entire dataset, use the \u{1F917} Datasets "),$t=o("a"),Os=a("map"),Ns=a(" method. You can speed up the "),Ut=o("code"),Ss=a("map"),Ws=a(" function by setting "),Xt=o("code"),Hs=a("batched=True"),Ys=a(" to process multiple elements of the dataset at once, and increasing the number of processes with "),Gt=o("code"),Us=a("num_proc"),Xs=a(". Remove any columns you don\u2019t need:"),Es=k(),T(yt.$$.fragment),Ts=k(),Dt=o("p"),Gs=a("This dataset contains the token sequences, but some of these are longer than the maximum input length for the model."),As=k(),Ct=o("p"),Vs=a("You can now use a second preprocessing function to"),Ms=k(),pt=o("ul"),Vt=o("li"),Qs=a("concatenate all the sequences"),Ks=k(),bt=o("li"),Js=a("split the concatenated sequences into shorter chunks defined by "),Qt=o("code"),Zs=a("block_size"),ea=a(", which should be both shorter than the maximum input length and short enough for your GPU RAM."),qs=k(),T(wt.$$.fragment),zs=k(),mt=o("p"),ta=a("Apply the "),Kt=o("code"),sa=a("group_texts"),aa=a(" function over the entire dataset:"),Ps=k(),T(jt.$$.fragment),Rs=k(),vt=o("p"),Va=a("Now create a batch of examples using "),la=o("a"),Qa=a("DataCollatorForLanguageModeling"),Ka=a(". It\u2019s more efficient to "),fa=o("em"),Ja=a("dynamically pad"),Za=a(" the sentences to the longest length in a batch during collation, instead of padding the whole dataset to the maximum length."),xa=k(),T(Jt.$$.fragment),Ea=k(),Bt=o("h2"),Zt=o("a"),ca=o("span"),T(Ls.$$.fragment),el=k(),ua=o("span"),tl=a("Train"),Ta=k(),T(es.$$.fragment),Aa=k(),T(ts.$$.fragment),Ma=k(),It=o("h2"),ss=o("a"),da=o("span"),T(Fs.$$.fragment),sl=k(),_a=o("span"),al=a("Inference"),qa=k(),oa=o("p"),ll=a("Great, now that you\u2019ve finetuned a model, you can use it for inference!"),za=k(),as=o("p"),ol=a("Come up with some text you\u2019d like the model to fill in the blank with, and use the special "),ga=o("code"),nl=a("<mask>"),rl=a(" token to indicate the blank:"),Pa=k(),T(Ds.$$.fragment),Ra=k(),Ze=o("p"),il=a("The simplest way to try out your finetuned model for inference is to use it in a "),na=o("a"),pl=a("pipeline()"),ml=a(". Instantiate a "),ka=o("code"),hl=a("pipeline"),fl=a(" for fill-mask with your model, and pass your text to it. If you like, you can use the "),$a=o("code"),cl=a("top_k"),ul=a(" parameter to specify how many predictions to return:"),La=k(),T(Cs.$$.fragment),Fa=k(),T(ls.$$.fragment),this.h()},l(t){const f=go('[data-svelte="svelte-1phssyn"]',document.head);p=n(f,"META",{name:!0,content:!0}),f.forEach(s),i=$(t),m=n(t,"H1",{class:!0});var Bs=r(m);y=n(Bs,"A",{id:!0,class:!0,href:!0});var ya=r(y);w=n(ya,"SPAN",{});var ba=r(w);A(v.$$.fragment,ba),ba.forEach(s),ya.forEach(s),x=$(Bs),F=n(Bs,"SPAN",{});var wa=r(F);b=l(wa,"Masked language modeling"),wa.forEach(s),Bs.forEach(s),j=$(t),A(L.$$.fragment,t),D=$(t),A(S.$$.fragment,t),W=$(t),B=n(t,"P",{});var ja=r(B);ie=l(ja,`Masked language modeling predicts a masked token in a sequence, and the model can attend to tokens bidirectionally. This
means the model has full access to the tokens on the left and right. Masked language modeling is great for tasks that
require a good contextual understanding of an entire sequence. BERT is an example of a masked language model.`),ja.forEach(s),Q=$(t),C=n(t,"P",{});var _l=r(C);le=l(_l,"This guide will show you how to:"),_l.forEach(s),U=$(t),X=n(t,"OL",{});var Ca=r(X);O=n(Ca,"LI",{});var os=r(O);H=l(os,"Finetune "),N=n(os,"A",{href:!0,rel:!0});var gl=r(N);u=l(gl,"DistilRoBERTa"),gl.forEach(s),E=l(os," on the "),Y=n(os,"A",{href:!0,rel:!0});var kl=r(Y);ce=l(kl,"r/askscience"),kl.forEach(s),Z=l(os," subset of the "),K=n(os,"A",{href:!0,rel:!0});var $l=r(K);oe=l($l,"ELI5"),$l.forEach(s),De=l(os," dataset."),os.forEach(s),te=$(Ca),Ae=n(Ca,"LI",{});var yl=r(Ae);ue=l(yl,"Use your finetuned model for inference."),yl.forEach(s),Ca.forEach(s),we=$(t),A(ge.$$.fragment,t),ve=$(t),J=n(t,"P",{});var bl=r(J);Me=l(bl,"Before you begin, make sure you have all the necessary libraries installed:"),bl.forEach(s),ae=$(t),A(fe.$$.fragment,t),pe=$(t),ke=n(t,"P",{});var wl=r(ke);xe=l(wl,"We encourage you to log in to your Hugging Face account so you can upload and share your model with the community. When prompted, enter your token to log in:"),wl.forEach(s),qe=$(t),A(ne.$$.fragment,t),re=$(t),se=n(t,"H2",{class:!0});var Ba=r(se);me=n(Ba,"A",{id:!0,class:!0,href:!0});var jl=r(me);he=n(jl,"SPAN",{});var vl=r(he);A($e.$$.fragment,vl),vl.forEach(s),jl.forEach(s),c=$(Ba),R=n(Ba,"SPAN",{});var xl=r(R);de=l(xl,"Load ELI5 dataset"),xl.forEach(s),Ba.forEach(s),ye=$(t),g=n(t,"P",{});var El=r(g);I=l(El,`Start by loading a smaller subset of the r/askscience subset of the ELI5 dataset from the \u{1F917} Datasets library. This\u2019ll
give you a chance to experiment and make sure everything works before spending more time training on the full dataset.`),El.forEach(s),je=$(t),A(be.$$.fragment,t),Ee=$(t),ee=n(t,"P",{});var ra=r(ee);Ce=l(ra,"Split the dataset\u2019s "),ze=n(ra,"CODE",{});var Tl=r(ze);Se=l(Tl,"train_asks"),Tl.forEach(s),Te=l(ra," split into a train and test set with the "),Pe=n(ra,"A",{href:!0,rel:!0});var Al=r(Pe);Ge=l(Al,"train_test_split"),Al.forEach(s),We=l(ra," method:"),ra.forEach(s),He=$(t),A(Oe.$$.fragment,t),Be=$(t),Ye=n(t,"P",{});var Ml=r(Ye);rs=l(Ml,"Then take a look at an example:"),Ml.forEach(s),et=$(t),A(tt.$$.fragment,t),Ot=$(t),Re=n(t,"P",{});var ia=r(Re);is=l(ia,"While this may look like a lot, you\u2019re only really interested in the "),Tt=n(ia,"CODE",{});var ql=r(Tt);ht=l(ql,"text"),ql.forEach(s),ps=l(ia," field. What\u2019s cool about language modeling tasks is you don\u2019t need labels (also known as an unsupervised task) because the next word "),At=n(ia,"EM",{});var zl=r(At);ft=l(zl,"is"),zl.forEach(s),ms=l(ia," the label."),ia.forEach(s),Nt=$(t),Ie=n(t,"H2",{class:!0});var Ia=r(Ie);Ve=n(Ia,"A",{id:!0,class:!0,href:!0});var Pl=r(Ve);Mt=n(Pl,"SPAN",{});var Rl=r(Mt);A(Ne.$$.fragment,Rl),Rl.forEach(s),Pl.forEach(s),hs=$(Ia),qt=n(Ia,"SPAN",{});var Ll=r(qt);ct=l(Ll,"Preprocess"),Ll.forEach(s),Ia.forEach(s),St=$(t),A(st.$$.fragment,t),at=$(t),Qe=n(t,"P",{});var Oa=r(Qe);fs=l(Oa,"For masked language modeling, the next step is to load a DistilRoBERTa tokenizer to process the "),Ke=n(Oa,"CODE",{});var Fl=r(Ke);cs=l(Fl,"text"),Fl.forEach(s),us=l(Oa," subfield:"),Oa.forEach(s),lt=$(t),A(ot.$$.fragment,t),Wt=$(t),_e=n(t,"P",{});var xt=r(_e);ds=l(xt,"You\u2019ll notice from the example above, the "),zt=n(xt,"CODE",{});var Dl=r(zt);ut=l(Dl,"text"),Dl.forEach(s),_s=l(xt," field is actually nested inside "),Pt=n(xt,"CODE",{});var Cl=r(Pt);dt=l(Cl,"answers"),Cl.forEach(s),gs=l(xt,`. This means you\u2019ll need to e
xtract the `),Rt=n(xt,"CODE",{});var Bl=r(Rt);_t=l(Bl,"text"),Bl.forEach(s),ks=l(xt," subfield from its nested structure with the "),nt=n(xt,"A",{href:!0,rel:!0});var Il=r(nt);Je=n(Il,"CODE",{});var Ol=r(Je);$s=l(Ol,"flatten"),Ol.forEach(s),Il.forEach(s),ys=l(xt," method:"),xt.forEach(s),rt=$(t),A(it.$$.fragment,t),Ht=$(t),Le=n(t,"P",{});var pa=r(Le);bs=l(pa,"Each subfield is now a separate column as indicated by the "),Lt=n(pa,"CODE",{});var Nl=r(Lt);gt=l(Nl,"answers"),Nl.forEach(s),ws=l(pa," prefix, and the "),Ft=n(pa,"CODE",{});var Sl=r(Ft);kt=l(Sl,"text"),Sl.forEach(s),js=l(pa,` field is a list now. Instead
of tokenizing each sentence separately, convert the list to a string so you can jointly tokenize them.`),pa.forEach(s),Yt=$(t),Ue=n(t,"P",{});var Wl=r(Ue);vs=l(Wl,"Here is a first preprocessing function to join the list of strings for each example and tokenize the result:"),Wl.forEach(s),Xe=$(t),A(_.$$.fragment,t),xs=$(t),Fe=n(t,"P",{});var Et=r(Fe);Is=l(Et,"To apply this preprocessing function over the entire dataset, use the \u{1F917} Datasets "),$t=n(Et,"A",{href:!0,rel:!0});var Hl=r($t);Os=l(Hl,"map"),Hl.forEach(s),Ns=l(Et," method. You can speed up the "),Ut=n(Et,"CODE",{});var Yl=r(Ut);Ss=l(Yl,"map"),Yl.forEach(s),Ws=l(Et," function by setting "),Xt=n(Et,"CODE",{});var Ul=r(Xt);Hs=l(Ul,"batched=True"),Ul.forEach(s),Ys=l(Et," to process multiple elements of the dataset at once, and increasing the number of processes with "),Gt=n(Et,"CODE",{});var Xl=r(Gt);Us=l(Xl,"num_proc"),Xl.forEach(s),Xs=l(Et,". Remove any columns you don\u2019t need:"),Et.forEach(s),Es=$(t),A(yt.$$.fragment,t),Ts=$(t),Dt=n(t,"P",{});var Gl=r(Dt);Gs=l(Gl,"This dataset contains the token sequences, but some of these are longer than the maximum input length for the model."),Gl.forEach(s),As=$(t),Ct=n(t,"P",{});var Vl=r(Ct);Vs=l(Vl,"You can now use a second preprocessing function to"),Vl.forEach(s),Ms=$(t),pt=n(t,"UL",{});var Na=r(pt);Vt=n(Na,"LI",{});var Ql=r(Vt);Qs=l(Ql,"concatenate all the sequences"),Ql.forEach(s),Ks=$(Na),bt=n(Na,"LI",{});var Sa=r(bt);Js=l(Sa,"split the concatenated sequences into shorter chunks defined by "),Qt=n(Sa,"CODE",{});var Kl=r(Qt);Zs=l(Kl,"block_size"),Kl.forEach(s),ea=l(Sa,", which should be both shorter than the maximum input length and short enough for your GPU RAM."),Sa.forEach(s),Na.forEach(s),qs=$(t),A(wt.$$.fragment,t),zs=$(t),mt=n(t,"P",{});var Wa=r(mt);ta=l(Wa,"Apply the "),Kt=n(Wa,"CODE",{});var Jl=r(Kt);sa=l(Jl,"group_texts"),Jl.forEach(s),aa=l(Wa," function over the entire dataset:"),Wa.forEach(s),Ps=$(t),A(jt.$$.fragment,t),Rs=$(t),vt=n(t,"P",{});var ma=r(vt);Va=l(ma,"Now create a batch of examples using "),la=n(ma,"A",{href:!0});var Zl=r(la);Qa=l(Zl,"DataCollatorForLanguageModeling"),Zl.forEach(s),Ka=l(ma,". It\u2019s more efficient to "),fa=n(ma,"EM",{});var eo=r(fa);Ja=l(eo,"dynamically pad"),eo.forEach(s),Za=l(ma," the sentences to the longest length in a batch during collation, instead of padding the whole dataset to the maximum length."),ma.forEach(s),xa=$(t),A(Jt.$$.fragment,t),Ea=$(t),Bt=n(t,"H2",{class:!0});var Ha=r(Bt);Zt=n(Ha,"A",{id:!0,class:!0,href:!0});var to=r(Zt);ca=n(to,"SPAN",{});var so=r(ca);A(Ls.$$.fragment,so),so.forEach(s),to.forEach(s),el=$(Ha),ua=n(Ha,"SPAN",{});var ao=r(ua);tl=l(ao,"Train"),ao.forEach(s),Ha.forEach(s),Ta=$(t),A(es.$$.fragment,t),Aa=$(t),A(ts.$$.fragment,t),Ma=$(t),It=n(t,"H2",{class:!0});var Ya=r(It);ss=n(Ya,"A",{id:!0,class:!0,href:!0});var lo=r(ss);da=n(lo,"SPAN",{});var oo=r(da);A(Fs.$$.fragment,oo),oo.forEach(s),lo.forEach(s),sl=$(Ya),_a=n(Ya,"SPAN",{});var no=r(_a);al=l(no,"Inference"),no.forEach(s),Ya.forEach(s),qa=$(t),oa=n(t,"P",{});var ro=r(oa);ll=l(ro,"Great, now that you\u2019ve finetuned a model, you can use it for inference!"),ro.forEach(s),za=$(t),as=n(t,"P",{});var Ua=r(as);ol=l(Ua,"Come up with some text you\u2019d like the model to fill in the blank with, and use the special "),ga=n(Ua,"CODE",{});var io=r(ga);nl=l(io,"<mask>"),io.forEach(s),rl=l(Ua," token to indicate the blank:"),Ua.forEach(s),Pa=$(t),A(Ds.$$.fragment,t),Ra=$(t),Ze=n(t,"P",{});var ns=r(Ze);il=l(ns,"The simplest way to try out your finetuned model for inference is to use it in a "),na=n(ns,"A",{href:!0});var po=r(na);pl=l(po,"pipeline()"),po.forEach(s),ml=l(ns,". Instantiate a "),ka=n(ns,"CODE",{});var mo=r(ka);hl=l(mo,"pipeline"),mo.forEach(s),fl=l(ns," for fill-mask with your model, and pass your text to it. If you like, you can use the "),$a=n(ns,"CODE",{});var ho=r($a);cl=l(ho,"top_k"),ho.forEach(s),ul=l(ns," parameter to specify how many predictions to return:"),ns.forEach(s),La=$(t),A(Cs.$$.fragment,t),Fa=$(t),A(ls.$$.fragment,t),this.h()},h(){d(p,"name","hf:doc:metadata"),d(p,"content",JSON.stringify(Co)),d(y,"id","masked-language-modeling"),d(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(y,"href","#masked-language-modeling"),d(m,"class","relative group"),d(N,"href","https://huggingface.co/distilroberta-base"),d(N,"rel","nofollow"),d(Y,"href","https://www.reddit.com/r/askscience/"),d(Y,"rel","nofollow"),d(K,"href","https://huggingface.co/datasets/eli5"),d(K,"rel","nofollow"),d(me,"id","load-eli5-dataset"),d(me,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(me,"href","#load-eli5-dataset"),d(se,"class","relative group"),d(Pe,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.train_test_split"),d(Pe,"rel","nofollow"),d(Ve,"id","preprocess"),d(Ve,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Ve,"href","#preprocess"),d(Ie,"class","relative group"),d(nt,"href","https://huggingface.co/docs/datasets/process.html#flatten"),d(nt,"rel","nofollow"),d($t,"href","https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset.map"),d($t,"rel","nofollow"),d(la,"href","/docs/transformers/pr_22182/en/main_classes/data_collator#transformers.DataCollatorForLanguageModeling"),d(Zt,"id","train"),d(Zt,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(Zt,"href","#train"),d(Bt,"class","relative group"),d(ss,"id","inference"),d(ss,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),d(ss,"href","#inference"),d(It,"class","relative group"),d(na,"href","/docs/transformers/pr_22182/en/main_classes/pipelines#transformers.pipeline")},m(t,f){e(document.head,p),h(t,i,f),h(t,m,f),e(m,y),e(y,w),M(v,w,null),e(m,x),e(m,F),e(F,b),h(t,j,f),M(L,t,f),h(t,D,f),M(S,t,f),h(t,W,f),h(t,B,f),e(B,ie),h(t,Q,f),h(t,C,f),e(C,le),h(t,U,f),h(t,X,f),e(X,O),e(O,H),e(O,N),e(N,u),e(O,E),e(O,Y),e(Y,ce),e(O,Z),e(O,K),e(K,oe),e(O,De),e(X,te),e(X,Ae),e(Ae,ue),h(t,we,f),M(ge,t,f),h(t,ve,f),h(t,J,f),e(J,Me),h(t,ae,f),M(fe,t,f),h(t,pe,f),h(t,ke,f),e(ke,xe),h(t,qe,f),M(ne,t,f),h(t,re,f),h(t,se,f),e(se,me),e(me,he),M($e,he,null),e(se,c),e(se,R),e(R,de),h(t,ye,f),h(t,g,f),e(g,I),h(t,je,f),M(be,t,f),h(t,Ee,f),h(t,ee,f),e(ee,Ce),e(ee,ze),e(ze,Se),e(ee,Te),e(ee,Pe),e(Pe,Ge),e(ee,We),h(t,He,f),M(Oe,t,f),h(t,Be,f),h(t,Ye,f),e(Ye,rs),h(t,et,f),M(tt,t,f),h(t,Ot,f),h(t,Re,f),e(Re,is),e(Re,Tt),e(Tt,ht),e(Re,ps),e(Re,At),e(At,ft),e(Re,ms),h(t,Nt,f),h(t,Ie,f),e(Ie,Ve),e(Ve,Mt),M(Ne,Mt,null),e(Ie,hs),e(Ie,qt),e(qt,ct),h(t,St,f),M(st,t,f),h(t,at,f),h(t,Qe,f),e(Qe,fs),e(Qe,Ke),e(Ke,cs),e(Qe,us),h(t,lt,f),M(ot,t,f),h(t,Wt,f),h(t,_e,f),e(_e,ds),e(_e,zt),e(zt,ut),e(_e,_s),e(_e,Pt),e(Pt,dt),e(_e,gs),e(_e,Rt),e(Rt,_t),e(_e,ks),e(_e,nt),e(nt,Je),e(Je,$s),e(_e,ys),h(t,rt,f),M(it,t,f),h(t,Ht,f),h(t,Le,f),e(Le,bs),e(Le,Lt),e(Lt,gt),e(Le,ws),e(Le,Ft),e(Ft,kt),e(Le,js),h(t,Yt,f),h(t,Ue,f),e(Ue,vs),h(t,Xe,f),M(_,t,f),h(t,xs,f),h(t,Fe,f),e(Fe,Is),e(Fe,$t),e($t,Os),e(Fe,Ns),e(Fe,Ut),e(Ut,Ss),e(Fe,Ws),e(Fe,Xt),e(Xt,Hs),e(Fe,Ys),e(Fe,Gt),e(Gt,Us),e(Fe,Xs),h(t,Es,f),M(yt,t,f),h(t,Ts,f),h(t,Dt,f),e(Dt,Gs),h(t,As,f),h(t,Ct,f),e(Ct,Vs),h(t,Ms,f),h(t,pt,f),e(pt,Vt),e(Vt,Qs),e(pt,Ks),e(pt,bt),e(bt,Js),e(bt,Qt),e(Qt,Zs),e(bt,ea),h(t,qs,f),M(wt,t,f),h(t,zs,f),h(t,mt,f),e(mt,ta),e(mt,Kt),e(Kt,sa),e(mt,aa),h(t,Ps,f),M(jt,t,f),h(t,Rs,f),h(t,vt,f),e(vt,Va),e(vt,la),e(la,Qa),e(vt,Ka),e(vt,fa),e(fa,Ja),e(vt,Za),h(t,xa,f),M(Jt,t,f),h(t,Ea,f),h(t,Bt,f),e(Bt,Zt),e(Zt,ca),M(Ls,ca,null),e(Bt,el),e(Bt,ua),e(ua,tl),h(t,Ta,f),M(es,t,f),h(t,Aa,f),M(ts,t,f),h(t,Ma,f),h(t,It,f),e(It,ss),e(ss,da),M(Fs,da,null),e(It,sl),e(It,_a),e(_a,al),h(t,qa,f),h(t,oa,f),e(oa,ll),h(t,za,f),h(t,as,f),e(as,ol),e(as,ga),e(ga,nl),e(as,rl),h(t,Pa,f),M(Ds,t,f),h(t,Ra,f),h(t,Ze,f),e(Ze,il),e(Ze,na),e(na,pl),e(Ze,ml),e(Ze,ka),e(ka,hl),e(Ze,fl),e(Ze,$a),e($a,cl),e(Ze,ul),h(t,La,f),M(Cs,t,f),h(t,Fa,f),M(ls,t,f),Da=!0},p(t,[f]){const Bs={};f&2&&(Bs.$$scope={dirty:f,ctx:t}),ge.$set(Bs);const ya={};f&2&&(ya.$$scope={dirty:f,ctx:t}),Jt.$set(ya);const ba={};f&2&&(ba.$$scope={dirty:f,ctx:t}),es.$set(ba);const wa={};f&2&&(wa.$$scope={dirty:f,ctx:t}),ts.$set(wa);const ja={};f&2&&(ja.$$scope={dirty:f,ctx:t}),ls.$set(ja)},i(t){Da||(q(v.$$.fragment,t),q(L.$$.fragment,t),q(S.$$.fragment,t),q(ge.$$.fragment,t),q(fe.$$.fragment,t),q(ne.$$.fragment,t),q($e.$$.fragment,t),q(be.$$.fragment,t),q(Oe.$$.fragment,t),q(tt.$$.fragment,t),q(Ne.$$.fragment,t),q(st.$$.fragment,t),q(ot.$$.fragment,t),q(it.$$.fragment,t),q(_.$$.fragment,t),q(yt.$$.fragment,t),q(wt.$$.fragment,t),q(jt.$$.fragment,t),q(Jt.$$.fragment,t),q(Ls.$$.fragment,t),q(es.$$.fragment,t),q(ts.$$.fragment,t),q(Fs.$$.fragment,t),q(Ds.$$.fragment,t),q(Cs.$$.fragment,t),q(ls.$$.fragment,t),Da=!0)},o(t){z(v.$$.fragment,t),z(L.$$.fragment,t),z(S.$$.fragment,t),z(ge.$$.fragment,t),z(fe.$$.fragment,t),z(ne.$$.fragment,t),z($e.$$.fragment,t),z(be.$$.fragment,t),z(Oe.$$.fragment,t),z(tt.$$.fragment,t),z(Ne.$$.fragment,t),z(st.$$.fragment,t),z(ot.$$.fragment,t),z(it.$$.fragment,t),z(_.$$.fragment,t),z(yt.$$.fragment,t),z(wt.$$.fragment,t),z(jt.$$.fragment,t),z(Jt.$$.fragment,t),z(Ls.$$.fragment,t),z(es.$$.fragment,t),z(ts.$$.fragment,t),z(Fs.$$.fragment,t),z(Ds.$$.fragment,t),z(Cs.$$.fragment,t),z(ls.$$.fragment,t),Da=!1},d(t){s(p),t&&s(i),t&&s(m),P(v),t&&s(j),P(L,t),t&&s(D),P(S,t),t&&s(W),t&&s(B),t&&s(Q),t&&s(C),t&&s(U),t&&s(X),t&&s(we),P(ge,t),t&&s(ve),t&&s(J),t&&s(ae),P(fe,t),t&&s(pe),t&&s(ke),t&&s(qe),P(ne,t),t&&s(re),t&&s(se),P($e),t&&s(ye),t&&s(g),t&&s(je),P(be,t),t&&s(Ee),t&&s(ee),t&&s(He),P(Oe,t),t&&s(Be),t&&s(Ye),t&&s(et),P(tt,t),t&&s(Ot),t&&s(Re),t&&s(Nt),t&&s(Ie),P(Ne),t&&s(St),P(st,t),t&&s(at),t&&s(Qe),t&&s(lt),P(ot,t),t&&s(Wt),t&&s(_e),t&&s(rt),P(it,t),t&&s(Ht),t&&s(Le),t&&s(Yt),t&&s(Ue),t&&s(Xe),P(_,t),t&&s(xs),t&&s(Fe),t&&s(Es),P(yt,t),t&&s(Ts),t&&s(Dt),t&&s(As),t&&s(Ct),t&&s(Ms),t&&s(pt),t&&s(qs),P(wt,t),t&&s(zs),t&&s(mt),t&&s(Ps),P(jt,t),t&&s(Rs),t&&s(vt),t&&s(xa),P(Jt,t),t&&s(Ea),t&&s(Bt),P(Ls),t&&s(Ta),P(es,t),t&&s(Aa),P(ts,t),t&&s(Ma),t&&s(It),P(Fs),t&&s(qa),t&&s(oa),t&&s(za),t&&s(as),t&&s(Pa),P(Ds,t),t&&s(Ra),t&&s(Ze),t&&s(La),P(Cs,t),t&&s(Fa),P(ls,t)}}}const Co={local:"masked-language-modeling",sections:[{local:"load-eli5-dataset",title:"Load ELI5 dataset"},{local:"preprocess",title:"Preprocess"},{local:"train",title:"Train"},{local:"inference",title:"Inference"}],title:"Masked language modeling"};function Bo(G){return ko(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Uo extends co{constructor(p){super();uo(this,p,Bo,Do,_o,{})}}export{Uo as default,Co as metadata};
