import{S as Ps,i as ks,s as xs,e as n,k as d,w as b,t as o,M as Es,c as a,d as t,m as c,a as s,x as v,h as r,b as p,G as e,g as E,y,q as w,o as $,B as C,v as Ts,L as $s}from"../../chunks/vendor-hf-doc-builder.js";import{T as vs}from"../../chunks/Tip-hf-doc-builder.js";import{D as T}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Cs}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as ys}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as ws}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Ds(I){let h,k,u,g,x;return{c(){h=n("p"),k=o(`A configuration file can be loaded and saved to disk. Loading the configuration file and using this file to
initialize a model does `),u=n("strong"),g=o("not"),x=o(" load the model weights. It only affects the model\u2019s configuration.")},l(f){h=a(f,"P",{});var _=s(h);k=r(_,`A configuration file can be loaded and saved to disk. Loading the configuration file and using this file to
initialize a model does `),u=a(_,"STRONG",{});var J=s(u);g=r(J,"not"),J.forEach(t),x=r(_," load the model weights. It only affects the model\u2019s configuration."),_.forEach(t)},m(f,_){E(f,h,_),e(h,k),e(h,u),e(u,g),e(h,x)},d(f){f&&t(h)}}}function zs(I){let h,k,u,g,x;return g=new Cs({props:{code:`from transformers import AutoConfig

config = AutoConfig.from_pretrained("bert-base-cased")

# Push the config to your namespace with the name "my-finetuned-bert".
config.push_to_hub("my-finetuned-bert")

# Push the config to an organization with the name "my-finetuned-bert".
config.push_to_hub("huggingface/my-finetuned-bert")`,highlighted:`<span class="hljs-keyword">from</span> transformers <span class="hljs-keyword">import</span> AutoConfig

config = AutoConfig.from_pretrained(<span class="hljs-string">&quot;bert-base-cased&quot;</span>)

<span class="hljs-comment"># Push the config to your namespace with the name &quot;my-finetuned-bert&quot;.</span>
config.push_to_hub(<span class="hljs-string">&quot;my-finetuned-bert&quot;</span>)

<span class="hljs-comment"># Push the config to an organization with the name &quot;my-finetuned-bert&quot;.</span>
config.push_to_hub(<span class="hljs-string">&quot;huggingface/my-finetuned-bert&quot;</span>)`}}),{c(){h=n("p"),k=o("Examples:"),u=d(),b(g.$$.fragment)},l(f){h=a(f,"P",{});var _=s(h);k=r(_,"Examples:"),_.forEach(t),u=c(f),v(g.$$.fragment,f)},m(f,_){E(f,h,_),e(h,k),E(f,u,_),y(g,f,_),x=!0},p:$s,i(f){x||(w(g.$$.fragment,f),x=!0)},o(f){$(g.$$.fragment,f),x=!1},d(f){f&&t(h),f&&t(u),C(g,f)}}}function js(I){let h,k,u,g,x;return g=new Cs({props:{code:`# We can't instantiate directly the base class *PretrainedConfig* so let's show the examples on a
# derived class: BertConfig
config = BertConfig.from_pretrained(
    "bert-base-uncased"
)  # Download configuration from huggingface.co and cache.
config = BertConfig.from_pretrained(
    "./test/saved_model/"
)  # E.g. config (or model) was saved using *save_pretrained('./test/saved_model/')*
config = BertConfig.from_pretrained("./test/saved_model/my_configuration.json")
config = BertConfig.from_pretrained("bert-base-uncased", output_attentions=True, foo=False)
assert config.output_attentions == True
config, unused_kwargs = BertConfig.from_pretrained(
    "bert-base-uncased", output_attentions=True, foo=False, return_unused_kwargs=True
)
assert config.output_attentions == True
assert unused_kwargs == {"foo": False}`,highlighted:`<span class="hljs-comment"># We can&#x27;t instantiate directly the base class *PretrainedConfig* so let&#x27;s show the examples on a</span>
<span class="hljs-comment"># derived class: BertConfig</span>
config = BertConfig.from_pretrained(
    <span class="hljs-string">&quot;bert-base-uncased&quot;</span>
)  <span class="hljs-comment"># Download configuration from huggingface.co and cache.</span>
config = BertConfig.from_pretrained(
    <span class="hljs-string">&quot;./test/saved_model/&quot;</span>
)  <span class="hljs-comment"># E.g. config (or model) was saved using *save_pretrained(&#x27;./test/saved_model/&#x27;)*</span>
config = BertConfig.from_pretrained(<span class="hljs-string">&quot;./test/saved_model/my_configuration.json&quot;</span>)
config = BertConfig.from_pretrained(<span class="hljs-string">&quot;bert-base-uncased&quot;</span>, output_attentions=<span class="hljs-literal">True</span>, foo=<span class="hljs-literal">False</span>)
<span class="hljs-keyword">assert</span> config.output_attentions == <span class="hljs-literal">True</span>
config, unused_kwargs = BertConfig.from_pretrained(
    <span class="hljs-string">&quot;bert-base-uncased&quot;</span>, output_attentions=<span class="hljs-literal">True</span>, foo=<span class="hljs-literal">False</span>, return_unused_kwargs=<span class="hljs-literal">True</span>
)
<span class="hljs-keyword">assert</span> config.output_attentions == <span class="hljs-literal">True</span>
<span class="hljs-keyword">assert</span> unused_kwargs == {<span class="hljs-string">&quot;foo&quot;</span>: <span class="hljs-literal">False</span>}`}}),{c(){h=n("p"),k=o("Examples:"),u=d(),b(g.$$.fragment)},l(f){h=a(f,"P",{});var _=s(h);k=r(_,"Examples:"),_.forEach(t),u=c(f),v(g.$$.fragment,f)},m(f,_){E(f,h,_),e(h,k),E(f,u,_),y(g,f,_),x=!0},p:$s,i(f){x||(w(g.$$.fragment,f),x=!0)},o(f){$(g.$$.fragment,f),x=!1},d(f){f&&t(h),f&&t(u),C(g,f)}}}function As(I){let h,k;return{c(){h=n("p"),k=o("This API is experimental and may have some slight breaking changes in the next releases.")},l(u){h=a(u,"P",{});var g=s(h);k=r(g,"This API is experimental and may have some slight breaking changes in the next releases."),g.forEach(t)},m(u,g){E(u,h,g),e(h,k)},d(u){u&&t(h)}}}function qs(I){let h,k,u,g,x,f,_,J,To,ro,H,Do,Ue,zo,jo,no,D,Ao,st,qo,Oo,it,Fo,So,dt,Io,Lo,ct,No,Wo,ao,V,G,lt,ye,Mo,ft,Bo,so,l,we,Vo,mt,Ro,Uo,X,Jo,ht,Ho,Go,A,L,pt,Xo,Yo,gt,Ko,Qo,Je,Zo,er,tr,z,ut,or,rr,_t,nr,ar,He,sr,ir,Ge,dr,cr,Xe,lr,fr,mr,Y,bt,hr,pr,vt,gr,ur,_r,K,yt,br,vr,wt,yr,wr,$r,$t,Cr,Pr,q,Q,Ct,kr,xr,Pt,Er,Tr,Dr,Z,kt,zr,jr,xt,Ar,qr,Or,ee,Et,Fr,Sr,Tt,Ir,Lr,Nr,te,Dt,Wr,Mr,zt,Br,Vr,Rr,N,$e,Ur,Ce,Jr,jt,Hr,Gr,Xr,oe,Yr,re,Pe,Kr,O,Qr,At,Zr,en,qt,tn,on,Ot,rn,nn,an,ne,ke,sn,xe,dn,Ye,cn,ln,fn,ae,Ee,mn,Te,hn,Ke,pn,gn,un,W,De,_n,ze,bn,Qe,vn,yn,wn,se,$n,ie,je,Cn,F,Pn,Ft,kn,xn,Ze,En,Tn,St,Dn,zn,jn,M,Ae,An,qe,qn,It,On,Fn,Sn,de,In,ce,Oe,Ln,R,Nn,Lt,Wn,Mn,et,Bn,Vn,Rn,le,Fe,Un,Nt,Jn,Hn,fe,Se,Gn,Wt,Xn,Yn,me,Ie,Kn,Mt,Qn,Zn,he,Le,ea,Bt,ta,oa,pe,Ne,ra,We,na,Vt,aa,sa,ia,j,Me,da,Be,ca,Rt,la,fa,ma,U,ha,Ut,pa,ga,Jt,ua,_a,ba,Ht,va,io;return f=new ys({}),ye=new ys({}),we=new T({props:{name:"class transformers.PretrainedConfig",anchor:"transformers.PretrainedConfig",parameters:[{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.name_or_path",description:`<strong>name_or_path</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
Store the string that was passed to <a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.PreTrainedModel.from_pretrained">PreTrainedModel.from_pretrained()</a> or
<a href="/docs/transformers/pr_22182/en/main_classes/model#transformers.TFPreTrainedModel.from_pretrained">TFPreTrainedModel.from_pretrained()</a> as <code>pretrained_model_name_or_path</code> if the configuration was created
with such a method.`,name:"name_or_path"},{anchor:"transformers.PretrainedConfig.output_hidden_states",description:`<strong>output_hidden_states</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the model should return all hidden-states.`,name:"output_hidden_states"},{anchor:"transformers.PretrainedConfig.output_attentions",description:`<strong>output_attentions</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the model should returns all attentions.`,name:"output_attentions"},{anchor:"transformers.PretrainedConfig.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not the model should return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a plain tuple.`,name:"return_dict"},{anchor:"transformers.PretrainedConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model is used as an encoder/decoder or not.`,name:"is_encoder_decoder"},{anchor:"transformers.PretrainedConfig.is_decoder",description:`<strong>is_decoder</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model is used as decoder or not (in which case it&#x2019;s used as an encoder).`,name:"is_decoder"},{anchor:"transformers.PretrainedConfig.cross_attention_hidden_size**",description:`<strong>cross_attention_hidden_size**</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
The hidden size of the cross-attention layer in case the model is used as a decoder in an encoder-decoder
setting and the cross-attention hidden dimension differs from <code>self.config.hidden_size</code>.`,name:"cross_attention_hidden_size**"},{anchor:"transformers.PretrainedConfig.add_cross_attention",description:`<strong>add_cross_attention</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether cross-attention layers should be added to the model. Note, this option is only relevant for models
that can be used as decoder models within the <a href="/docs/transformers/pr_22182/en/model_doc/encoder-decoder#transformers.EncoderDecoderModel">EncoderDecoderModel</a> class, which consists of all models
in <code>AUTO_MODELS_FOR_CAUSAL_LM</code>.`,name:"add_cross_attention"},{anchor:"transformers.PretrainedConfig.tie_encoder_decoder",description:`<strong>tie_encoder_decoder</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether all encoder weights should be tied to their equivalent decoder weights. This requires the encoder
and decoder model to have the exact same parameter names.`,name:"tie_encoder_decoder"},{anchor:"transformers.PretrainedConfig.prune_heads",description:`<strong>prune_heads</strong> (<code>Dict[int, List[int]]</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Pruned heads of the model. The keys are the selected layer indices and the associated values, the list of
heads to prune in said layer.</p>
<p>For instance <code>{1: [0, 2], 2: [2, 3]}</code> will prune heads 0 and 2 on layer 1 and heads 2 and 3 on layer 2.`,name:"prune_heads"},{anchor:"transformers.PretrainedConfig.chunk_size_feed_forward",description:`<strong>chunk_size_feed_forward</strong> (<code>int</code>, <em>optional</em>, defaults to <code>0</code>) &#x2014;
The chunk size of all feed forward layers in the residual attention blocks. A chunk size of <code>0</code> means that
the feed forward layer is not chunked. A chunk size of n means that the feed forward layer processes <code>n</code> &lt;
sequence_length embeddings at a time. For more information on feed forward chunking, see <a href="../glossary.html#feed-forward-chunking">How does Feed
Forward Chunking work?</a>.`,name:"chunk_size_feed_forward"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L49",parameterGroups:[{title:"Parameters for sequence generation",parametersDescription:[{anchor:"transformers.PretrainedConfig.max_length",description:`<strong>max_length</strong> (<code>int</code>, <em>optional</em>, defaults to 20) &#x2014;
Maximum length that will be used by default in the <code>generate</code> method of the model.`,name:"max_length"},{anchor:"transformers.PretrainedConfig.min_length",description:`<strong>min_length</strong> (<code>int</code>, <em>optional</em>, defaults to 10) &#x2014;
Minimum length that will be used by default in the <code>generate</code> method of the model.`,name:"min_length"},{anchor:"transformers.PretrainedConfig.do_sample",description:`<strong>do_sample</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Flag that will be used by default in the <code>generate</code> method of the model. Whether or not to use sampling ;
use greedy decoding otherwise.`,name:"do_sample"},{anchor:"transformers.PretrainedConfig.early_stopping",description:`<strong>early_stopping</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Flag that will be used by default in the <code>generate</code> method of the model. Whether to stop the beam search
when at least <code>num_beams</code> sentences are finished per batch or not.`,name:"early_stopping"},{anchor:"transformers.PretrainedConfig.num_beams",description:`<strong>num_beams</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of beams for beam search that will be used by default in the <code>generate</code> method of the model. 1 means
no beam search.`,name:"num_beams"},{anchor:"transformers.PretrainedConfig.num_beam_groups",description:`<strong>num_beam_groups</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of groups to divide <code>num_beams</code> into in order to ensure diversity among different groups of beams
that will be used by default in the <code>generate</code> method of the model. 1 means no group beam search.`,name:"num_beam_groups"},{anchor:"transformers.PretrainedConfig.diversity_penalty",description:`<strong>diversity_penalty</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Value to control diversity for group beam search. that will be used by default in the <code>generate</code> method of
the model. 0 means no diversity penalty. The higher the penalty, the more diverse are the outputs.`,name:"diversity_penalty"},{anchor:"transformers.PretrainedConfig.temperature",description:`<strong>temperature</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
The value used to module the next token probabilities that will be used by default in the <code>generate</code> method
of the model. Must be strictly positive.`,name:"temperature"},{anchor:"transformers.PretrainedConfig.top_k",description:`<strong>top_k</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
Number of highest probability vocabulary tokens to keep for top-k-filtering that will be used by default in
the <code>generate</code> method of the model.`,name:"top_k"},{anchor:"transformers.PretrainedConfig.top_p",description:`<strong>top_p</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Value that will be used by default in the <code>generate</code> method of the model for <code>top_p</code>. If set to float &lt; 1,
only the most probable tokens with probabilities that add up to <code>top_p</code> or higher are kept for generation.`,name:"top_p"},{anchor:"transformers.PretrainedConfig.typical_p",description:`<strong>typical_p</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Local typicality measures how similar the conditional probability of predicting a target token next is to
the expected conditional probability of predicting a random token next, given the partial text already
generated. If set to float &lt; 1, the smallest set of the most locally typical tokens with probabilities that
add up to <code>typical_p</code> or higher are kept for generation. See <a href="https://arxiv.org/pdf/2202.00666.pdf" rel="nofollow">this
paper</a> for more details.`,name:"typical_p"},{anchor:"transformers.PretrainedConfig.repetition_penalty",description:`<strong>repetition_penalty</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Parameter for repetition penalty that will be used by default in the <code>generate</code> method of the model. 1.0
means no penalty.`,name:"repetition_penalty"},{anchor:"transformers.PretrainedConfig.length_penalty",description:`<strong>length_penalty</strong> (<code>float</code>, <em>optional</em>, defaults to 1) &#x2014;
Exponential penalty to the length that is used with beam-based generation. It is applied as an exponent to
the sequence length, which in turn is used to divide the score of the sequence. Since the score is the log
likelihood of the sequence (i.e. negative), <code>length_penalty</code> &gt; 0.0 promotes longer sequences, while
<code>length_penalty</code> &lt; 0.0 encourages shorter sequences.`,name:"length_penalty"},{anchor:"transformers.PretrainedConfig.no_repeat_ngram_size",description:`<strong>no_repeat_ngram_size</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; Value that will be used by default in the &#x2014;
<code>generate</code> method of the model for <code>no_repeat_ngram_size</code>. If set to int &gt; 0, all ngrams of that size can
only occur once.`,name:"no_repeat_ngram_size"},{anchor:"transformers.PretrainedConfig.encoder_no_repeat_ngram_size",description:`<strong>encoder_no_repeat_ngram_size</strong> (<code>int</code>, <em>optional</em>, defaults to 0) &#x2014; Value that will be used by &#x2014;
default in the <code>generate</code> method of the model for <code>encoder_no_repeat_ngram_size</code>. If set to int &gt; 0, all
ngrams of that size that occur in the <code>encoder_input_ids</code> cannot occur in the <code>decoder_input_ids</code>.`,name:"encoder_no_repeat_ngram_size"},{anchor:"transformers.PretrainedConfig.bad_words_ids",description:`<strong>bad_words_ids</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
List of token ids that are not allowed to be generated that will be used by default in the <code>generate</code>
method of the model. In order to get the tokens of the words that should not appear in the generated text,
use <code>tokenizer.encode(bad_word, add_prefix_space=True)</code>.`,name:"bad_words_ids"},{anchor:"transformers.PretrainedConfig.num_return_sequences",description:`<strong>num_return_sequences</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
Number of independently computed returned sequences for each element in the batch that will be used by
default in the <code>generate</code> method of the model.`,name:"num_return_sequences"},{anchor:"transformers.PretrainedConfig.output_scores",description:`<strong>output_scores</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model should return the logits when used for generation.`,name:"output_scores"},{anchor:"transformers.PretrainedConfig.return_dict_in_generate",description:`<strong>return_dict_in_generate</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model should return a <a href="/docs/transformers/pr_22182/en/main_classes/output#transformers.utils.ModelOutput">ModelOutput</a> instead of a <code>torch.LongTensor</code>.`,name:"return_dict_in_generate"},{anchor:"transformers.PretrainedConfig.forced_bos_token_id",description:`<strong>forced_bos_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The id of the token to force as the first generated token after the <code>decoder_start_token_id</code>. Useful for
multilingual models like <a href="../model_doc/mbart">mBART</a> where the first generated token needs to be the target
language token.`,name:"forced_bos_token_id"},{anchor:"transformers.PretrainedConfig.forced_eos_token_id",description:`<strong>forced_eos_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The id of the token to force as the last generated token when <code>max_length</code> is reached.`,name:"forced_eos_token_id"},{anchor:"transformers.PretrainedConfig.remove_invalid_values",description:`<strong>remove_invalid_values</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether to remove possible <em>nan</em> and <em>inf</em> outputs of the model to prevent the generation method to crash.
Note that using <code>remove_invalid_values</code> can slow down generation.`,name:"remove_invalid_values"}]},{title:"Parameters for fine-tuning tasks",parametersDescription:[{anchor:"transformers.PretrainedConfig.architectures",description:`<strong>architectures</strong> (<code>List[str]</code>, <em>optional</em>) &#x2014;
Model architectures that can be used with the model pretrained weights.`,name:"architectures"},{anchor:"transformers.PretrainedConfig.finetuning_task",description:`<strong>finetuning_task</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Name of the task used to fine-tune the model. This can be used when converting from an original (TensorFlow
or PyTorch) checkpoint.`,name:"finetuning_task"},{anchor:"transformers.PretrainedConfig.id2label",description:`<strong>id2label</strong> (<code>Dict[int, str]</code>, <em>optional</em>) &#x2014;
A map from index (for instance prediction index, or target index) to label.`,name:"id2label"},{anchor:"transformers.PretrainedConfig.label2id",description:"<strong>label2id</strong> (<code>Dict[str, int]</code>, <em>optional</em>) &#x2014; A map from label to index for the model.",name:"label2id"},{anchor:"transformers.PretrainedConfig.num_labels",description:`<strong>num_labels</strong> (<code>int</code>, <em>optional</em>) &#x2014;
Number of labels to use in the last layer added to the model, typically for a classification task.`,name:"num_labels"},{anchor:"transformers.PretrainedConfig.task_specific_params",description:`<strong>task_specific_params</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
Additional keyword arguments to store for the current task.`,name:"task_specific_params"},{anchor:"transformers.PretrainedConfig.problem_type",description:`<strong>problem_type</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Problem type for <code>XxxForSequenceClassification</code> models. Can be one of <code>&quot;regression&quot;</code>,
<code>&quot;single_label_classification&quot;</code> or <code>&quot;multi_label_classification&quot;</code>.`,name:"problem_type"}]},{title:"Parameters linked to the tokenizer",parametersDescription:[{anchor:"transformers.PretrainedConfig.tokenizer_class",description:`<strong>tokenizer_class</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The name of the associated tokenizer class to use (if none is set, will use the tokenizer associated to the
model by default).`,name:"tokenizer_class"},{anchor:"transformers.PretrainedConfig.prefix",description:`<strong>prefix</strong> (<code>str</code>, <em>optional</em>) &#x2014;
A specific prompt that should be added at the beginning of each text before calling the model.`,name:"prefix"},{anchor:"transformers.PretrainedConfig.bos_token_id",description:"<strong>bos_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014; The id of the <em>beginning-of-stream</em> token.",name:"bos_token_id"},{anchor:"transformers.PretrainedConfig.pad_token_id",description:"<strong>pad_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014; The id of the <em>padding</em> token.",name:"pad_token_id"},{anchor:"transformers.PretrainedConfig.eos_token_id",description:"<strong>eos_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014; The id of the <em>end-of-stream</em> token.",name:"eos_token_id"},{anchor:"transformers.PretrainedConfig.decoder_start_token_id",description:`<strong>decoder_start_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014;
If an encoder-decoder model starts decoding with a different token than <em>bos</em>, the id of that token.`,name:"decoder_start_token_id"},{anchor:"transformers.PretrainedConfig.sep_token_id",description:"<strong>sep_token_id</strong> (<code>int</code>, <em>optional</em>) &#x2014; The id of the <em>separation</em> token.",name:"sep_token_id"}]},{title:"PyTorch specific parameters",parametersDescription:[{anchor:"transformers.PretrainedConfig.torchscript",description:`<strong>torchscript</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the model should be used with Torchscript.`,name:"torchscript"},{anchor:"transformers.PretrainedConfig.tie_word_embeddings",description:`<strong>tie_word_embeddings</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether the model&#x2019;s input and output word embeddings should be tied. Note that this is only relevant if the
model has a output word embedding layer.`,name:"tie_word_embeddings"},{anchor:"transformers.PretrainedConfig.torch_dtype",description:`<strong>torch_dtype</strong> (<code>str</code>, <em>optional</em>) &#x2014;
The <code>dtype</code> of the weights. This attribute can be used to initialize the model to a non-default <code>dtype</code>
(which is normally <code>float32</code>) and thus allow for optimal storage allocation. For example, if the saved
model is <code>float16</code>, ideally we want to load it back using the minimal amount of memory needed to load
<code>float16</code> weights. Since the config object is stored in plain text, this attribute contains just the
floating type string without the <code>torch.</code> prefix. For example, for <code>torch.float16</code> \`<code>torch_dtype</code> is the
<code>&quot;float16&quot;</code> string.</p>
<p>This attribute is currently not being used during model loading time, but this may change in the future
versions. But we can already start preparing for the future by saving the dtype with save_pretrained.`,name:"torch_dtype"}]},{title:"TensorFlow specific parameters",parametersDescription:[{anchor:"transformers.PretrainedConfig.use_bfloat16",description:`<strong>use_bfloat16</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not the model should use BFloat16 scalars (only used by some TensorFlow models).`,name:"use_bfloat16"},{anchor:"transformers.PretrainedConfig.tf_legacy_loss",description:`<strong>tf_legacy_loss</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether the model should use legacy TensorFlow losses. Legacy losses have variable output shapes and may
not be XLA-compatible. This option is here for backward compatibility and will be removed in Transformers
v5.`,name:"tf_legacy_loss"}]}]}}),X=new vs({props:{$$slots:{default:[Ds]},$$scope:{ctx:I}}}),$e=new T({props:{name:"push_to_hub",anchor:"transformers.PretrainedConfig.push_to_hub",parameters:[{name:"repo_id",val:": str"},{name:"use_temp_dir",val:": typing.Optional[bool] = None"},{name:"commit_message",val:": typing.Optional[str] = None"},{name:"private",val:": typing.Optional[bool] = None"},{name:"use_auth_token",val:": typing.Union[bool, str, NoneType] = None"},{name:"max_shard_size",val:": typing.Union[int, str, NoneType] = '10GB'"},{name:"create_pr",val:": bool = False"},{name:"**deprecated_kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.push_to_hub.repo_id",description:`<strong>repo_id</strong> (<code>str</code>) &#x2014;
The name of the repository you want to push your config to. It should contain your organization name
when pushing to a given organization.`,name:"repo_id"},{anchor:"transformers.PretrainedConfig.push_to_hub.use_temp_dir",description:`<strong>use_temp_dir</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not to use a temporary directory to store the files saved before they are pushed to the Hub.
Will default to <code>True</code> if there is no directory named like <code>repo_id</code>, <code>False</code> otherwise.`,name:"use_temp_dir"},{anchor:"transformers.PretrainedConfig.push_to_hub.commit_message",description:`<strong>commit_message</strong> (<code>str</code>, <em>optional</em>) &#x2014;
Message to commit while pushing. Will default to <code>&quot;Upload config&quot;</code>.`,name:"commit_message"},{anchor:"transformers.PretrainedConfig.push_to_hub.private",description:`<strong>private</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
Whether or not the repository created should be private.`,name:"private"},{anchor:"transformers.PretrainedConfig.push_to_hub.use_auth_token",description:`<strong>use_auth_token</strong> (<code>bool</code> or <code>str</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>). Will default to <code>True</code> if <code>repo_url</code>
is not specified.`,name:"use_auth_token"},{anchor:"transformers.PretrainedConfig.push_to_hub.max_shard_size",description:`<strong>max_shard_size</strong> (<code>int</code> or <code>str</code>, <em>optional</em>, defaults to <code>&quot;10GB&quot;</code>) &#x2014;
Only applicable for models. The maximum size for a checkpoint before being sharded. Checkpoints shard
will then be each of size lower than this size. If expressed as a string, needs to be digits followed
by a unit (like <code>&quot;5MB&quot;</code>).`,name:"max_shard_size"},{anchor:"transformers.PretrainedConfig.push_to_hub.create_pr",description:`<strong>create_pr</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to create a PR with the uploaded files or directly commit.`,name:"create_pr"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/utils/hub.py#L703"}}),oe=new ws({props:{anchor:"transformers.PretrainedConfig.push_to_hub.example",$$slots:{default:[zs]},$$scope:{ctx:I}}}),Pe=new T({props:{name:"dict_torch_dtype_to_str",anchor:"transformers.PretrainedConfig.dict_torch_dtype_to_str",parameters:[{name:"d",val:": typing.Dict[str, typing.Any]"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L900"}}),ke=new T({props:{name:"from_dict",anchor:"transformers.PretrainedConfig.from_dict",parameters:[{name:"config_dict",val:": typing.Dict[str, typing.Any]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.from_dict.config_dict",description:`<strong>config_dict</strong> (<code>Dict[str, Any]</code>) &#x2014;
Dictionary that will be used to instantiate the configuration object. Such a dictionary can be
retrieved from a pretrained checkpoint by leveraging the <a href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig.get_config_dict">get_config_dict()</a> method.`,name:"config_dict"},{anchor:"transformers.PretrainedConfig.from_dict.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>) &#x2014;
Additional parameters from which to initialize the configuration object.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L677",returnDescription:`
<p>The configuration object instantiated from those parameters.</p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"
>PretrainedConfig</a></p>
`}}),Ee=new T({props:{name:"from_json_file",anchor:"transformers.PretrainedConfig.from_json_file",parameters:[{name:"json_file",val:": typing.Union[str, os.PathLike]"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.from_json_file.json_file",description:`<strong>json_file</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Path to the JSON file containing the parameters.`,name:"json_file"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L731",returnDescription:`
<p>The configuration object instantiated from that JSON file.</p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"
>PretrainedConfig</a></p>
`}}),De=new T({props:{name:"from_pretrained",anchor:"transformers.PretrainedConfig.from_pretrained",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.from_pretrained.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
This can be either:</p>
<ul>
<li>a string, the <em>model id</em> of a pretrained model configuration hosted inside a model repo on
huggingface.co. Valid model ids can be located at the root-level, like <code>bert-base-uncased</code>, or
namespaced under a user or organization name, like <code>dbmdz/bert-base-german-cased</code>.</li>
<li>a path to a <em>directory</em> containing a configuration file saved using the
<a href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig.save_pretrained">save_pretrained()</a> method, e.g., <code>./my_model_directory/</code>.</li>
<li>a path or url to a saved configuration JSON <em>file</em>, e.g., <code>./my_model_directory/configuration.json</code>.</li>
</ul>`,name:"pretrained_model_name_or_path"},{anchor:"transformers.PretrainedConfig.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>str</code> or <code>os.PathLike</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model configuration should be cached if the
standard cache should not be used.`,name:"cache_dir"},{anchor:"transformers.PretrainedConfig.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to force to (re-)download the configuration files and override the cached versions if
they exist.`,name:"force_download"},{anchor:"transformers.PretrainedConfig.from_pretrained.resume_download",description:`<strong>resume_download</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to delete incompletely received file. Attempts to resume the download if such a file
exists.`,name:"resume_download"},{anchor:"transformers.PretrainedConfig.from_pretrained.proxies",description:`<strong>proxies</strong> (<code>Dict[str, str]</code>, <em>optional</em>) &#x2014;
A dictionary of proxy servers to use by protocol or endpoint, e.g., <code>{&apos;http&apos;: &apos;foo.bar:3128&apos;, &apos;http://hostname&apos;: &apos;foo.bar:4012&apos;}.</code> The proxies are used on each request.`,name:"proxies"},{anchor:"transformers.PretrainedConfig.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>str</code> or <code>bool</code>, <em>optional</em>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, or not specified, will use
the token generated when running <code>huggingface-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"},{anchor:"transformers.PretrainedConfig.from_pretrained.revision",description:`<strong>revision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;main&quot;</code>) &#x2014;
The specific model version to use. It can be a branch name, a tag name, or a commit id, since we use a
git-based system for storing models and other artifacts on huggingface.co, so <code>revision</code> can be any
identifier allowed by git.</p>
<div class="course-tip  bg-gradient-to-br dark:bg-gradient-to-r before:border-green-500 dark:before:border-green-800 from-green-50 dark:from-gray-900 to-white dark:to-gray-950 border border-green-50 text-green-700 dark:text-gray-400">
						
<p>To test a pull request you made on the Hub, you can pass \`revision=&#x201C;refs/pr/<pr_number>&#x201C;.</pr_number></p>

					</div>`,name:"revision"},{anchor:"transformers.PretrainedConfig.from_pretrained.return_unused_kwargs",description:`<strong>return_unused_kwargs</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>False</code>, then this function returns just the final configuration object.</p>
<p>If <code>True</code>, then this functions returns a <code>Tuple(config, unused_kwargs)</code> where <em>unused_kwargs</em> is a
dictionary consisting of the key/value pairs whose keys are not configuration attributes: i.e., the
part of <code>kwargs</code> which has not been used to update <code>config</code> and is otherwise ignored.`,name:"return_unused_kwargs"},{anchor:"transformers.PretrainedConfig.from_pretrained.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the relevant files are located inside a subfolder of the model repo on huggingface.co, you can
specify the folder name here.`,name:"subfolder"},{anchor:"transformers.PretrainedConfig.from_pretrained.kwargs",description:`<strong>kwargs</strong> (<code>Dict[str, Any]</code>, <em>optional</em>) &#x2014;
The values in kwargs of any keys which are configuration attributes will be used to override the loaded
values. Behavior concerning key/value pairs whose keys are <em>not</em> configuration attributes is controlled
by the <code>return_unused_kwargs</code> keyword parameter.`,name:"kwargs"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L469",returnDescription:`
<p>The configuration object instantiated from this pretrained model.</p>
`,returnType:`
<p><a
  href="/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"
>PretrainedConfig</a></p>
`}}),se=new ws({props:{anchor:"transformers.PretrainedConfig.from_pretrained.example",$$slots:{default:[js]},$$scope:{ctx:I}}}),je=new T({props:{name:"get_config_dict",anchor:"transformers.PretrainedConfig.get_config_dict",parameters:[{name:"pretrained_model_name_or_path",val:": typing.Union[str, os.PathLike]"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.get_config_dict.pretrained_model_name_or_path",description:`<strong>pretrained_model_name_or_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
The identifier of the pre-trained checkpoint from which we want the dictionary of parameters.`,name:"pretrained_model_name_or_path"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L556",returnDescription:`
<p>The dictionary(ies) that will be used to instantiate the configuration object.</p>
`,returnType:`
<p><code>Tuple[Dict, Dict]</code></p>
`}}),Ae=new T({props:{name:"register_for_auto_class",anchor:"transformers.PretrainedConfig.register_for_auto_class",parameters:[{name:"auto_class",val:" = 'AutoConfig'"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.register_for_auto_class.auto_class",description:`<strong>auto_class</strong> (<code>str</code> or <code>type</code>, <em>optional</em>, defaults to <code>&quot;AutoConfig&quot;</code>) &#x2014;
The auto class to register this new configuration with.`,name:"auto_class"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L912"}}),de=new vs({props:{warning:!0,$$slots:{default:[As]},$$scope:{ctx:I}}}),Oe=new T({props:{name:"save_pretrained",anchor:"transformers.PretrainedConfig.save_pretrained",parameters:[{name:"save_directory",val:": typing.Union[str, os.PathLike]"},{name:"push_to_hub",val:": bool = False"},{name:"**kwargs",val:""}],parametersDescription:[{anchor:"transformers.PretrainedConfig.save_pretrained.save_directory",description:`<strong>save_directory</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Directory where the configuration JSON file will be saved (will be created if it does not exist).`,name:"save_directory"},{anchor:"transformers.PretrainedConfig.save_pretrained.push_to_hub",description:`<strong>push_to_hub</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether or not to push your model to the Hugging Face model hub after saving it. You can specify the
repository you want to push to with <code>repo_id</code> (will default to the name of <code>save_directory</code> in your
namespace).
kwargs &#x2014;
Additional key word arguments passed along to the <a href="/docs/transformers/pr_22182/en/main_classes/tokenizer#transformers.PreTrainedTokenizerFast.push_to_hub">push_to_hub()</a> method.`,name:"push_to_hub"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L423"}}),Fe=new T({props:{name:"to_dict",anchor:"transformers.PretrainedConfig.to_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L791",returnDescription:`
<p>Dictionary of all the attributes that make up this configuration instance.</p>
`,returnType:`
<p><code>Dict[str, Any]</code></p>
`}}),Se=new T({props:{name:"to_diff_dict",anchor:"transformers.PretrainedConfig.to_diff_dict",parameters:[],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L759",returnDescription:`
<p>Dictionary of all the attributes that make up this configuration instance,</p>
`,returnType:`
<p><code>Dict[str, Any]</code></p>
`}}),Ie=new T({props:{name:"to_json_file",anchor:"transformers.PretrainedConfig.to_json_file",parameters:[{name:"json_file_path",val:": typing.Union[str, os.PathLike]"},{name:"use_diff",val:": bool = True"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.to_json_file.json_file_path",description:`<strong>json_file_path</strong> (<code>str</code> or <code>os.PathLike</code>) &#x2014;
Path to the JSON file in which this configuration instance&#x2019;s parameters will be saved.`,name:"json_file_path"},{anchor:"transformers.PretrainedConfig.to_json_file.use_diff",description:`<strong>use_diff</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, only the difference between the config instance and the default <code>PretrainedConfig()</code>
is serialized to JSON file.`,name:"use_diff"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L838"}}),Le=new T({props:{name:"to_json_string",anchor:"transformers.PretrainedConfig.to_json_string",parameters:[{name:"use_diff",val:": bool = True"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.to_json_string.use_diff",description:`<strong>use_diff</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
If set to <code>True</code>, only the difference between the config instance and the default <code>PretrainedConfig()</code>
is serialized to JSON string.`,name:"use_diff"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L820",returnDescription:`
<p>String containing all the attributes that make up this configuration instance in JSON format.</p>
`,returnType:`
<p><code>str</code></p>
`}}),Ne=new T({props:{name:"update",anchor:"transformers.PretrainedConfig.update",parameters:[{name:"config_dict",val:": typing.Dict[str, typing.Any]"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.update.config_dict",description:"<strong>config_dict</strong> (<code>Dict[str, Any]</code>) &#x2014; Dictionary of attributes that should be updated for this class.",name:"config_dict"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L852"}}),Me=new T({props:{name:"update_from_string",anchor:"transformers.PretrainedConfig.update_from_string",parameters:[{name:"update_str",val:": str"}],parametersDescription:[{anchor:"transformers.PretrainedConfig.update_from_string.update_str",description:"<strong>update_str</strong> (<code>str</code>) &#x2014; String with attributes that should be updated for this class.",name:"update_str"}],source:"https://github.com/huggingface/transformers/blob/vr_22182/src/transformers/configuration_utils.py#L862"}}),{c(){h=n("meta"),k=d(),u=n("h1"),g=n("a"),x=n("span"),b(f.$$.fragment),_=d(),J=n("span"),To=o("Configuration"),ro=d(),H=n("p"),Do=o("The base class "),Ue=n("a"),zo=o("PretrainedConfig"),jo=o(` implements the common methods for loading/saving a configuration
either from a local file or directory, or from a pretrained model configuration provided by the library (downloaded
from HuggingFace\u2019s AWS S3 repository).`),no=d(),D=n("p"),Ao=o(`Each derived config class implements model specific attributes. Common attributes present in all config classes are:
`),st=n("code"),qo=o("hidden_size"),Oo=o(", "),it=n("code"),Fo=o("num_attention_heads"),So=o(", and "),dt=n("code"),Io=o("num_hidden_layers"),Lo=o(`. Text models further implement:
`),ct=n("code"),No=o("vocab_size"),Wo=o("."),ao=d(),V=n("h2"),G=n("a"),lt=n("span"),b(ye.$$.fragment),Mo=d(),ft=n("span"),Bo=o("PretrainedConfig"),so=d(),l=n("div"),b(we.$$.fragment),Vo=d(),mt=n("p"),Ro=o(`Base class for all configuration classes. Handles a few parameters common to all models\u2019 configurations as well as
methods for loading/downloading/saving configurations.`),Uo=d(),b(X.$$.fragment),Jo=d(),ht=n("p"),Ho=o("Class attributes (overridden by derived classes):"),Go=d(),A=n("ul"),L=n("li"),pt=n("strong"),Xo=o("model_type"),Yo=o(" ("),gt=n("code"),Ko=o("str"),Qo=o(`) \u2014 An identifier for the model type, serialized into the JSON file, and used to recreate
the correct object in `),Je=n("a"),Zo=o("AutoConfig"),er=o("."),tr=d(),z=n("li"),ut=n("strong"),or=o("is_composition"),rr=o(" ("),_t=n("code"),nr=o("bool"),ar=o(`) \u2014 Whether the config class is composed of multiple sub-configs. In this case the
config has to be initialized from two or more configs of type `),He=n("a"),sr=o("PretrainedConfig"),ir=o(` like:
`),Ge=n("a"),dr=o("EncoderDecoderConfig"),cr=o(" or "),Xe=n("a"),lr=o("~RagConfig"),fr=o("."),mr=d(),Y=n("li"),bt=n("strong"),hr=o("keys_to_ignore_at_inference"),pr=o(" ("),vt=n("code"),gr=o("List[str]"),ur=o(`) \u2014 A list of keys to ignore by default when looking at dictionary
outputs of the model during inference.`),_r=d(),K=n("li"),yt=n("strong"),br=o("attribute_map"),vr=o(" ("),wt=n("code"),yr=o("Dict[str, str]"),wr=o(`) \u2014 A dict that maps model specific attribute names to the standardized
naming of attributes.`),$r=d(),$t=n("p"),Cr=o("Common attributes (present in all subclasses):"),Pr=d(),q=n("ul"),Q=n("li"),Ct=n("strong"),kr=o("vocab_size"),xr=o(" ("),Pt=n("code"),Er=o("int"),Tr=o(`) \u2014 The number of tokens in the vocabulary, which is also the first dimension of the
embeddings matrix (this attribute may be missing for models that don\u2019t have a text modality like ViT).`),Dr=d(),Z=n("li"),kt=n("strong"),zr=o("hidden_size"),jr=o(" ("),xt=n("code"),Ar=o("int"),qr=o(") \u2014 The hidden size of the model."),Or=d(),ee=n("li"),Et=n("strong"),Fr=o("num_attention_heads"),Sr=o(" ("),Tt=n("code"),Ir=o("int"),Lr=o(`) \u2014 The number of attention heads used in the multi-head attention layers of the
model.`),Nr=d(),te=n("li"),Dt=n("strong"),Wr=o("num_hidden_layers"),Mr=o(" ("),zt=n("code"),Br=o("int"),Vr=o(") \u2014 The number of blocks in the model."),Rr=d(),N=n("div"),b($e.$$.fragment),Ur=d(),Ce=n("p"),Jr=o(`Upload the configuration file to the \u{1F917} Model Hub while synchronizing a local clone of the repo in
`),jt=n("code"),Hr=o("repo_path_or_name"),Gr=o("."),Xr=d(),b(oe.$$.fragment),Yr=d(),re=n("div"),b(Pe.$$.fragment),Kr=d(),O=n("p"),Qr=o("Checks whether the passed dictionary and its nested dicts have a "),At=n("em"),Zr=o("torch_dtype"),en=o(` key and if it\u2019s not None,
converts torch.dtype to a string of just the type. For example, `),qt=n("code"),tn=o("torch.float32"),on=o(" get converted into "),Ot=n("em"),rn=o("\u201Cfloat32\u201D"),nn=o(`
string, which can then be stored in the json format.`),an=d(),ne=n("div"),b(ke.$$.fragment),sn=d(),xe=n("p"),dn=o("Instantiates a "),Ye=n("a"),cn=o("PretrainedConfig"),ln=o(" from a Python dictionary of parameters."),fn=d(),ae=n("div"),b(Ee.$$.fragment),mn=d(),Te=n("p"),hn=o("Instantiates a "),Ke=n("a"),pn=o("PretrainedConfig"),gn=o(" from the path to a JSON file of parameters."),un=d(),W=n("div"),b(De.$$.fragment),_n=d(),ze=n("p"),bn=o("Instantiate a "),Qe=n("a"),vn=o("PretrainedConfig"),yn=o(" (or a derived class) from a pretrained model configuration."),wn=d(),b(se.$$.fragment),$n=d(),ie=n("div"),b(je.$$.fragment),Cn=d(),F=n("p"),Pn=o("From a "),Ft=n("code"),kn=o("pretrained_model_name_or_path"),xn=o(`, resolve to a dictionary of parameters, to be used for instantiating a
`),Ze=n("a"),En=o("PretrainedConfig"),Tn=o(" using "),St=n("code"),Dn=o("from_dict"),zn=o("."),jn=d(),M=n("div"),b(Ae.$$.fragment),An=d(),qe=n("p"),qn=o(`Register this class with a given auto class. This should only be used for custom configurations as the ones in
the library are already mapped with `),It=n("code"),On=o("AutoConfig"),Fn=o("."),Sn=d(),b(de.$$.fragment),In=d(),ce=n("div"),b(Oe.$$.fragment),Ln=d(),R=n("p"),Nn=o("Save a configuration object to the directory "),Lt=n("code"),Wn=o("save_directory"),Mn=o(`, so that it can be re-loaded using the
`),et=n("a"),Bn=o("from_pretrained()"),Vn=o(" class method."),Rn=d(),le=n("div"),b(Fe.$$.fragment),Un=d(),Nt=n("p"),Jn=o("Serializes this instance to a Python dictionary."),Hn=d(),fe=n("div"),b(Se.$$.fragment),Gn=d(),Wt=n("p"),Xn=o(`Removes all attributes from config which correspond to the default config attributes for better readability and
serializes to a Python dictionary.`),Yn=d(),me=n("div"),b(Ie.$$.fragment),Kn=d(),Mt=n("p"),Qn=o("Save this instance to a JSON file."),Zn=d(),he=n("div"),b(Le.$$.fragment),ea=d(),Bt=n("p"),ta=o("Serializes this instance to a JSON string."),oa=d(),pe=n("div"),b(Ne.$$.fragment),ra=d(),We=n("p"),na=o("Updates attributes of this class with attributes from "),Vt=n("code"),aa=o("config_dict"),sa=o("."),ia=d(),j=n("div"),b(Me.$$.fragment),da=d(),Be=n("p"),ca=o("Updates attributes of this class with attributes from "),Rt=n("code"),la=o("update_str"),fa=o("."),ma=d(),U=n("p"),ha=o("The expected format is ints, floats and strings as is, and for booleans use "),Ut=n("code"),pa=o("true"),ga=o(" or "),Jt=n("code"),ua=o("false"),_a=o(`. For example:
\u201Cn_embd=10,resid_pdrop=0.2,scale_attn_weights=false,summary_type=cls_index\u201D`),ba=d(),Ht=n("p"),va=o("The keys to change have to already exist in the config object."),this.h()},l(i){const P=Es('[data-svelte="svelte-1phssyn"]',document.head);h=a(P,"META",{name:!0,content:!0}),P.forEach(t),k=c(i),u=a(i,"H1",{class:!0});var Ve=s(u);g=a(Ve,"A",{id:!0,class:!0,href:!0});var Gt=s(g);x=a(Gt,"SPAN",{});var Xt=s(x);v(f.$$.fragment,Xt),Xt.forEach(t),Gt.forEach(t),_=c(Ve),J=a(Ve,"SPAN",{});var Yt=s(J);To=r(Yt,"Configuration"),Yt.forEach(t),Ve.forEach(t),ro=c(i),H=a(i,"P",{});var co=s(H);Do=r(co,"The base class "),Ue=a(co,"A",{href:!0});var ya=s(Ue);zo=r(ya,"PretrainedConfig"),ya.forEach(t),jo=r(co,` implements the common methods for loading/saving a configuration
either from a local file or directory, or from a pretrained model configuration provided by the library (downloaded
from HuggingFace\u2019s AWS S3 repository).`),co.forEach(t),no=c(i),D=a(i,"P",{});var B=s(D);Ao=r(B,`Each derived config class implements model specific attributes. Common attributes present in all config classes are:
`),st=a(B,"CODE",{});var wa=s(st);qo=r(wa,"hidden_size"),wa.forEach(t),Oo=r(B,", "),it=a(B,"CODE",{});var $a=s(it);Fo=r($a,"num_attention_heads"),$a.forEach(t),So=r(B,", and "),dt=a(B,"CODE",{});var Ca=s(dt);Io=r(Ca,"num_hidden_layers"),Ca.forEach(t),Lo=r(B,`. Text models further implement:
`),ct=a(B,"CODE",{});var Pa=s(ct);No=r(Pa,"vocab_size"),Pa.forEach(t),Wo=r(B,"."),B.forEach(t),ao=c(i),V=a(i,"H2",{class:!0});var lo=s(V);G=a(lo,"A",{id:!0,class:!0,href:!0});var ka=s(G);lt=a(ka,"SPAN",{});var xa=s(lt);v(ye.$$.fragment,xa),xa.forEach(t),ka.forEach(t),Mo=c(lo),ft=a(lo,"SPAN",{});var Ea=s(ft);Bo=r(Ea,"PretrainedConfig"),Ea.forEach(t),lo.forEach(t),so=c(i),l=a(i,"DIV",{class:!0});var m=s(l);v(we.$$.fragment,m),Vo=c(m),mt=a(m,"P",{});var Ta=s(mt);Ro=r(Ta,`Base class for all configuration classes. Handles a few parameters common to all models\u2019 configurations as well as
methods for loading/downloading/saving configurations.`),Ta.forEach(t),Uo=c(m),v(X.$$.fragment,m),Jo=c(m),ht=a(m,"P",{});var Da=s(ht);Ho=r(Da,"Class attributes (overridden by derived classes):"),Da.forEach(t),Go=c(m),A=a(m,"UL",{});var ge=s(A);L=a(ge,"LI",{});var Re=s(L);pt=a(Re,"STRONG",{});var za=s(pt);Xo=r(za,"model_type"),za.forEach(t),Yo=r(Re," ("),gt=a(Re,"CODE",{});var ja=s(gt);Ko=r(ja,"str"),ja.forEach(t),Qo=r(Re,`) \u2014 An identifier for the model type, serialized into the JSON file, and used to recreate
the correct object in `),Je=a(Re,"A",{href:!0});var Aa=s(Je);Zo=r(Aa,"AutoConfig"),Aa.forEach(t),er=r(Re,"."),Re.forEach(t),tr=c(ge),z=a(ge,"LI",{});var S=s(z);ut=a(S,"STRONG",{});var qa=s(ut);or=r(qa,"is_composition"),qa.forEach(t),rr=r(S," ("),_t=a(S,"CODE",{});var Oa=s(_t);nr=r(Oa,"bool"),Oa.forEach(t),ar=r(S,`) \u2014 Whether the config class is composed of multiple sub-configs. In this case the
config has to be initialized from two or more configs of type `),He=a(S,"A",{href:!0});var Fa=s(He);sr=r(Fa,"PretrainedConfig"),Fa.forEach(t),ir=r(S,` like:
`),Ge=a(S,"A",{href:!0});var Sa=s(Ge);dr=r(Sa,"EncoderDecoderConfig"),Sa.forEach(t),cr=r(S," or "),Xe=a(S,"A",{href:!0});var Ia=s(Xe);lr=r(Ia,"~RagConfig"),Ia.forEach(t),fr=r(S,"."),S.forEach(t),mr=c(ge),Y=a(ge,"LI",{});var Kt=s(Y);bt=a(Kt,"STRONG",{});var La=s(bt);hr=r(La,"keys_to_ignore_at_inference"),La.forEach(t),pr=r(Kt," ("),vt=a(Kt,"CODE",{});var Na=s(vt);gr=r(Na,"List[str]"),Na.forEach(t),ur=r(Kt,`) \u2014 A list of keys to ignore by default when looking at dictionary
outputs of the model during inference.`),Kt.forEach(t),_r=c(ge),K=a(ge,"LI",{});var Qt=s(K);yt=a(Qt,"STRONG",{});var Wa=s(yt);br=r(Wa,"attribute_map"),Wa.forEach(t),vr=r(Qt," ("),wt=a(Qt,"CODE",{});var Ma=s(wt);yr=r(Ma,"Dict[str, str]"),Ma.forEach(t),wr=r(Qt,`) \u2014 A dict that maps model specific attribute names to the standardized
naming of attributes.`),Qt.forEach(t),ge.forEach(t),$r=c(m),$t=a(m,"P",{});var Ba=s($t);Cr=r(Ba,"Common attributes (present in all subclasses):"),Ba.forEach(t),Pr=c(m),q=a(m,"UL",{});var ue=s(q);Q=a(ue,"LI",{});var Zt=s(Q);Ct=a(Zt,"STRONG",{});var Va=s(Ct);kr=r(Va,"vocab_size"),Va.forEach(t),xr=r(Zt," ("),Pt=a(Zt,"CODE",{});var Ra=s(Pt);Er=r(Ra,"int"),Ra.forEach(t),Tr=r(Zt,`) \u2014 The number of tokens in the vocabulary, which is also the first dimension of the
embeddings matrix (this attribute may be missing for models that don\u2019t have a text modality like ViT).`),Zt.forEach(t),Dr=c(ue),Z=a(ue,"LI",{});var eo=s(Z);kt=a(eo,"STRONG",{});var Ua=s(kt);zr=r(Ua,"hidden_size"),Ua.forEach(t),jr=r(eo," ("),xt=a(eo,"CODE",{});var Ja=s(xt);Ar=r(Ja,"int"),Ja.forEach(t),qr=r(eo,") \u2014 The hidden size of the model."),eo.forEach(t),Or=c(ue),ee=a(ue,"LI",{});var to=s(ee);Et=a(to,"STRONG",{});var Ha=s(Et);Fr=r(Ha,"num_attention_heads"),Ha.forEach(t),Sr=r(to," ("),Tt=a(to,"CODE",{});var Ga=s(Tt);Ir=r(Ga,"int"),Ga.forEach(t),Lr=r(to,`) \u2014 The number of attention heads used in the multi-head attention layers of the
model.`),to.forEach(t),Nr=c(ue),te=a(ue,"LI",{});var oo=s(te);Dt=a(oo,"STRONG",{});var Xa=s(Dt);Wr=r(Xa,"num_hidden_layers"),Xa.forEach(t),Mr=r(oo," ("),zt=a(oo,"CODE",{});var Ya=s(zt);Br=r(Ya,"int"),Ya.forEach(t),Vr=r(oo,") \u2014 The number of blocks in the model."),oo.forEach(t),ue.forEach(t),Rr=c(m),N=a(m,"DIV",{class:!0});var tt=s(N);v($e.$$.fragment,tt),Ur=c(tt),Ce=a(tt,"P",{});var fo=s(Ce);Jr=r(fo,`Upload the configuration file to the \u{1F917} Model Hub while synchronizing a local clone of the repo in
`),jt=a(fo,"CODE",{});var Ka=s(jt);Hr=r(Ka,"repo_path_or_name"),Ka.forEach(t),Gr=r(fo,"."),fo.forEach(t),Xr=c(tt),v(oe.$$.fragment,tt),tt.forEach(t),Yr=c(m),re=a(m,"DIV",{class:!0});var mo=s(re);v(Pe.$$.fragment,mo),Kr=c(mo),O=a(mo,"P",{});var _e=s(O);Qr=r(_e,"Checks whether the passed dictionary and its nested dicts have a "),At=a(_e,"EM",{});var Qa=s(At);Zr=r(Qa,"torch_dtype"),Qa.forEach(t),en=r(_e,` key and if it\u2019s not None,
converts torch.dtype to a string of just the type. For example, `),qt=a(_e,"CODE",{});var Za=s(qt);tn=r(Za,"torch.float32"),Za.forEach(t),on=r(_e," get converted into "),Ot=a(_e,"EM",{});var es=s(Ot);rn=r(es,"\u201Cfloat32\u201D"),es.forEach(t),nn=r(_e,`
string, which can then be stored in the json format.`),_e.forEach(t),mo.forEach(t),an=c(m),ne=a(m,"DIV",{class:!0});var ho=s(ne);v(ke.$$.fragment,ho),sn=c(ho),xe=a(ho,"P",{});var po=s(xe);dn=r(po,"Instantiates a "),Ye=a(po,"A",{href:!0});var ts=s(Ye);cn=r(ts,"PretrainedConfig"),ts.forEach(t),ln=r(po," from a Python dictionary of parameters."),po.forEach(t),ho.forEach(t),fn=c(m),ae=a(m,"DIV",{class:!0});var go=s(ae);v(Ee.$$.fragment,go),mn=c(go),Te=a(go,"P",{});var uo=s(Te);hn=r(uo,"Instantiates a "),Ke=a(uo,"A",{href:!0});var os=s(Ke);pn=r(os,"PretrainedConfig"),os.forEach(t),gn=r(uo," from the path to a JSON file of parameters."),uo.forEach(t),go.forEach(t),un=c(m),W=a(m,"DIV",{class:!0});var ot=s(W);v(De.$$.fragment,ot),_n=c(ot),ze=a(ot,"P",{});var _o=s(ze);bn=r(_o,"Instantiate a "),Qe=a(_o,"A",{href:!0});var rs=s(Qe);vn=r(rs,"PretrainedConfig"),rs.forEach(t),yn=r(_o," (or a derived class) from a pretrained model configuration."),_o.forEach(t),wn=c(ot),v(se.$$.fragment,ot),ot.forEach(t),$n=c(m),ie=a(m,"DIV",{class:!0});var bo=s(ie);v(je.$$.fragment,bo),Cn=c(bo),F=a(bo,"P",{});var be=s(F);Pn=r(be,"From a "),Ft=a(be,"CODE",{});var ns=s(Ft);kn=r(ns,"pretrained_model_name_or_path"),ns.forEach(t),xn=r(be,`, resolve to a dictionary of parameters, to be used for instantiating a
`),Ze=a(be,"A",{href:!0});var as=s(Ze);En=r(as,"PretrainedConfig"),as.forEach(t),Tn=r(be," using "),St=a(be,"CODE",{});var ss=s(St);Dn=r(ss,"from_dict"),ss.forEach(t),zn=r(be,"."),be.forEach(t),bo.forEach(t),jn=c(m),M=a(m,"DIV",{class:!0});var rt=s(M);v(Ae.$$.fragment,rt),An=c(rt),qe=a(rt,"P",{});var vo=s(qe);qn=r(vo,`Register this class with a given auto class. This should only be used for custom configurations as the ones in
the library are already mapped with `),It=a(vo,"CODE",{});var is=s(It);On=r(is,"AutoConfig"),is.forEach(t),Fn=r(vo,"."),vo.forEach(t),Sn=c(rt),v(de.$$.fragment,rt),rt.forEach(t),In=c(m),ce=a(m,"DIV",{class:!0});var yo=s(ce);v(Oe.$$.fragment,yo),Ln=c(yo),R=a(yo,"P",{});var nt=s(R);Nn=r(nt,"Save a configuration object to the directory "),Lt=a(nt,"CODE",{});var ds=s(Lt);Wn=r(ds,"save_directory"),ds.forEach(t),Mn=r(nt,`, so that it can be re-loaded using the
`),et=a(nt,"A",{href:!0});var cs=s(et);Bn=r(cs,"from_pretrained()"),cs.forEach(t),Vn=r(nt," class method."),nt.forEach(t),yo.forEach(t),Rn=c(m),le=a(m,"DIV",{class:!0});var wo=s(le);v(Fe.$$.fragment,wo),Un=c(wo),Nt=a(wo,"P",{});var ls=s(Nt);Jn=r(ls,"Serializes this instance to a Python dictionary."),ls.forEach(t),wo.forEach(t),Hn=c(m),fe=a(m,"DIV",{class:!0});var $o=s(fe);v(Se.$$.fragment,$o),Gn=c($o),Wt=a($o,"P",{});var fs=s(Wt);Xn=r(fs,`Removes all attributes from config which correspond to the default config attributes for better readability and
serializes to a Python dictionary.`),fs.forEach(t),$o.forEach(t),Yn=c(m),me=a(m,"DIV",{class:!0});var Co=s(me);v(Ie.$$.fragment,Co),Kn=c(Co),Mt=a(Co,"P",{});var ms=s(Mt);Qn=r(ms,"Save this instance to a JSON file."),ms.forEach(t),Co.forEach(t),Zn=c(m),he=a(m,"DIV",{class:!0});var Po=s(he);v(Le.$$.fragment,Po),ea=c(Po),Bt=a(Po,"P",{});var hs=s(Bt);ta=r(hs,"Serializes this instance to a JSON string."),hs.forEach(t),Po.forEach(t),oa=c(m),pe=a(m,"DIV",{class:!0});var ko=s(pe);v(Ne.$$.fragment,ko),ra=c(ko),We=a(ko,"P",{});var xo=s(We);na=r(xo,"Updates attributes of this class with attributes from "),Vt=a(xo,"CODE",{});var ps=s(Vt);aa=r(ps,"config_dict"),ps.forEach(t),sa=r(xo,"."),xo.forEach(t),ko.forEach(t),ia=c(m),j=a(m,"DIV",{class:!0});var ve=s(j);v(Me.$$.fragment,ve),da=c(ve),Be=a(ve,"P",{});var Eo=s(Be);ca=r(Eo,"Updates attributes of this class with attributes from "),Rt=a(Eo,"CODE",{});var gs=s(Rt);la=r(gs,"update_str"),gs.forEach(t),fa=r(Eo,"."),Eo.forEach(t),ma=c(ve),U=a(ve,"P",{});var at=s(U);ha=r(at,"The expected format is ints, floats and strings as is, and for booleans use "),Ut=a(at,"CODE",{});var us=s(Ut);pa=r(us,"true"),us.forEach(t),ga=r(at," or "),Jt=a(at,"CODE",{});var _s=s(Jt);ua=r(_s,"false"),_s.forEach(t),_a=r(at,`. For example:
\u201Cn_embd=10,resid_pdrop=0.2,scale_attn_weights=false,summary_type=cls_index\u201D`),at.forEach(t),ba=c(ve),Ht=a(ve,"P",{});var bs=s(Ht);va=r(bs,"The keys to change have to already exist in the config object."),bs.forEach(t),ve.forEach(t),m.forEach(t),this.h()},h(){p(h,"name","hf:doc:metadata"),p(h,"content",JSON.stringify(Os)),p(g,"id","configuration"),p(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(g,"href","#configuration"),p(u,"class","relative group"),p(Ue,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(G,"id","transformers.PretrainedConfig"),p(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),p(G,"href","#transformers.PretrainedConfig"),p(V,"class","relative group"),p(Je,"href","/docs/transformers/pr_22182/en/model_doc/auto#transformers.AutoConfig"),p(He,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(Ge,"href","/docs/transformers/pr_22182/en/model_doc/encoder-decoder#transformers.EncoderDecoderConfig"),p(Xe,"href","/docs/transformers/pr_22182/en/model_doc/rag#transformers.RagConfig"),p(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ye,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ke,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Qe,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(Ze,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig"),p(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(et,"href","/docs/transformers/pr_22182/en/main_classes/configuration#transformers.PretrainedConfig.from_pretrained"),p(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),p(l,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(i,P){e(document.head,h),E(i,k,P),E(i,u,P),e(u,g),e(g,x),y(f,x,null),e(u,_),e(u,J),e(J,To),E(i,ro,P),E(i,H,P),e(H,Do),e(H,Ue),e(Ue,zo),e(H,jo),E(i,no,P),E(i,D,P),e(D,Ao),e(D,st),e(st,qo),e(D,Oo),e(D,it),e(it,Fo),e(D,So),e(D,dt),e(dt,Io),e(D,Lo),e(D,ct),e(ct,No),e(D,Wo),E(i,ao,P),E(i,V,P),e(V,G),e(G,lt),y(ye,lt,null),e(V,Mo),e(V,ft),e(ft,Bo),E(i,so,P),E(i,l,P),y(we,l,null),e(l,Vo),e(l,mt),e(mt,Ro),e(l,Uo),y(X,l,null),e(l,Jo),e(l,ht),e(ht,Ho),e(l,Go),e(l,A),e(A,L),e(L,pt),e(pt,Xo),e(L,Yo),e(L,gt),e(gt,Ko),e(L,Qo),e(L,Je),e(Je,Zo),e(L,er),e(A,tr),e(A,z),e(z,ut),e(ut,or),e(z,rr),e(z,_t),e(_t,nr),e(z,ar),e(z,He),e(He,sr),e(z,ir),e(z,Ge),e(Ge,dr),e(z,cr),e(z,Xe),e(Xe,lr),e(z,fr),e(A,mr),e(A,Y),e(Y,bt),e(bt,hr),e(Y,pr),e(Y,vt),e(vt,gr),e(Y,ur),e(A,_r),e(A,K),e(K,yt),e(yt,br),e(K,vr),e(K,wt),e(wt,yr),e(K,wr),e(l,$r),e(l,$t),e($t,Cr),e(l,Pr),e(l,q),e(q,Q),e(Q,Ct),e(Ct,kr),e(Q,xr),e(Q,Pt),e(Pt,Er),e(Q,Tr),e(q,Dr),e(q,Z),e(Z,kt),e(kt,zr),e(Z,jr),e(Z,xt),e(xt,Ar),e(Z,qr),e(q,Or),e(q,ee),e(ee,Et),e(Et,Fr),e(ee,Sr),e(ee,Tt),e(Tt,Ir),e(ee,Lr),e(q,Nr),e(q,te),e(te,Dt),e(Dt,Wr),e(te,Mr),e(te,zt),e(zt,Br),e(te,Vr),e(l,Rr),e(l,N),y($e,N,null),e(N,Ur),e(N,Ce),e(Ce,Jr),e(Ce,jt),e(jt,Hr),e(Ce,Gr),e(N,Xr),y(oe,N,null),e(l,Yr),e(l,re),y(Pe,re,null),e(re,Kr),e(re,O),e(O,Qr),e(O,At),e(At,Zr),e(O,en),e(O,qt),e(qt,tn),e(O,on),e(O,Ot),e(Ot,rn),e(O,nn),e(l,an),e(l,ne),y(ke,ne,null),e(ne,sn),e(ne,xe),e(xe,dn),e(xe,Ye),e(Ye,cn),e(xe,ln),e(l,fn),e(l,ae),y(Ee,ae,null),e(ae,mn),e(ae,Te),e(Te,hn),e(Te,Ke),e(Ke,pn),e(Te,gn),e(l,un),e(l,W),y(De,W,null),e(W,_n),e(W,ze),e(ze,bn),e(ze,Qe),e(Qe,vn),e(ze,yn),e(W,wn),y(se,W,null),e(l,$n),e(l,ie),y(je,ie,null),e(ie,Cn),e(ie,F),e(F,Pn),e(F,Ft),e(Ft,kn),e(F,xn),e(F,Ze),e(Ze,En),e(F,Tn),e(F,St),e(St,Dn),e(F,zn),e(l,jn),e(l,M),y(Ae,M,null),e(M,An),e(M,qe),e(qe,qn),e(qe,It),e(It,On),e(qe,Fn),e(M,Sn),y(de,M,null),e(l,In),e(l,ce),y(Oe,ce,null),e(ce,Ln),e(ce,R),e(R,Nn),e(R,Lt),e(Lt,Wn),e(R,Mn),e(R,et),e(et,Bn),e(R,Vn),e(l,Rn),e(l,le),y(Fe,le,null),e(le,Un),e(le,Nt),e(Nt,Jn),e(l,Hn),e(l,fe),y(Se,fe,null),e(fe,Gn),e(fe,Wt),e(Wt,Xn),e(l,Yn),e(l,me),y(Ie,me,null),e(me,Kn),e(me,Mt),e(Mt,Qn),e(l,Zn),e(l,he),y(Le,he,null),e(he,ea),e(he,Bt),e(Bt,ta),e(l,oa),e(l,pe),y(Ne,pe,null),e(pe,ra),e(pe,We),e(We,na),e(We,Vt),e(Vt,aa),e(We,sa),e(l,ia),e(l,j),y(Me,j,null),e(j,da),e(j,Be),e(Be,ca),e(Be,Rt),e(Rt,la),e(Be,fa),e(j,ma),e(j,U),e(U,ha),e(U,Ut),e(Ut,pa),e(U,ga),e(U,Jt),e(Jt,ua),e(U,_a),e(j,ba),e(j,Ht),e(Ht,va),io=!0},p(i,[P]){const Ve={};P&2&&(Ve.$$scope={dirty:P,ctx:i}),X.$set(Ve);const Gt={};P&2&&(Gt.$$scope={dirty:P,ctx:i}),oe.$set(Gt);const Xt={};P&2&&(Xt.$$scope={dirty:P,ctx:i}),se.$set(Xt);const Yt={};P&2&&(Yt.$$scope={dirty:P,ctx:i}),de.$set(Yt)},i(i){io||(w(f.$$.fragment,i),w(ye.$$.fragment,i),w(we.$$.fragment,i),w(X.$$.fragment,i),w($e.$$.fragment,i),w(oe.$$.fragment,i),w(Pe.$$.fragment,i),w(ke.$$.fragment,i),w(Ee.$$.fragment,i),w(De.$$.fragment,i),w(se.$$.fragment,i),w(je.$$.fragment,i),w(Ae.$$.fragment,i),w(de.$$.fragment,i),w(Oe.$$.fragment,i),w(Fe.$$.fragment,i),w(Se.$$.fragment,i),w(Ie.$$.fragment,i),w(Le.$$.fragment,i),w(Ne.$$.fragment,i),w(Me.$$.fragment,i),io=!0)},o(i){$(f.$$.fragment,i),$(ye.$$.fragment,i),$(we.$$.fragment,i),$(X.$$.fragment,i),$($e.$$.fragment,i),$(oe.$$.fragment,i),$(Pe.$$.fragment,i),$(ke.$$.fragment,i),$(Ee.$$.fragment,i),$(De.$$.fragment,i),$(se.$$.fragment,i),$(je.$$.fragment,i),$(Ae.$$.fragment,i),$(de.$$.fragment,i),$(Oe.$$.fragment,i),$(Fe.$$.fragment,i),$(Se.$$.fragment,i),$(Ie.$$.fragment,i),$(Le.$$.fragment,i),$(Ne.$$.fragment,i),$(Me.$$.fragment,i),io=!1},d(i){t(h),i&&t(k),i&&t(u),C(f),i&&t(ro),i&&t(H),i&&t(no),i&&t(D),i&&t(ao),i&&t(V),C(ye),i&&t(so),i&&t(l),C(we),C(X),C($e),C(oe),C(Pe),C(ke),C(Ee),C(De),C(se),C(je),C(Ae),C(de),C(Oe),C(Fe),C(Se),C(Ie),C(Le),C(Ne),C(Me)}}}const Os={local:"configuration",sections:[{local:"transformers.PretrainedConfig",title:"PretrainedConfig"}],title:"Configuration"};function Fs(I){return Ts(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Bs extends Ps{constructor(h){super();ks(this,h,Fs,qs,xs,{})}}export{Bs as default,Os as metadata};
